/*!
 * TODO add license info here 
 */
(function(global){
if (typeof define != 'undefined') {
	define(['jquery'],load);
} else {
	load(global.jQuery);
}
function load(jQuery){
;/*
    json2.js
    2011-10-19

    Public Domain.

    NO WARRANTY EXPRESSED OR IMPLIED. USE AT YOUR OWN RISK.

    See http://www.JSON.org/js.html


    This code should be minified before deployment.
    See http://javascript.crockford.com/jsmin.html

    USE YOUR OWN COPY. IT IS EXTREMELY UNWISE TO LOAD CODE FROM SERVERS YOU DO
    NOT CONTROL.


    This file creates a global JSON object containing two methods: stringify
    and parse.

        JSON.stringify(value, replacer, space)
            value       any JavaScript value, usually an object or array.

            replacer    an optional parameter that determines how object
                        values are stringified for objects. It can be a
                        function or an array of strings.

            space       an optional parameter that specifies the indentation
                        of nested structures. If it is omitted, the text will
                        be packed without extra whitespace. If it is a number,
                        it will specify the number of spaces to indent at each
                        level. If it is a string (such as '\t' or '&nbsp;'),
                        it contains the characters used to indent at each level.

            This method produces a JSON text from a JavaScript value.

            When an object value is found, if the object contains a toJSON
            method, its toJSON method will be called and the result will be
            stringified. A toJSON method does not serialize: it returns the
            value represented by the name/value pair that should be serialized,
            or undefined if nothing should be serialized. The toJSON method
            will be passed the key associated with the value, and this will be
            bound to the value

            For example, this would serialize Dates as ISO strings.

                Date.prototype.toJSON = function (key) {
                    function f(n) {
                        // Format integers to have at least two digits.
                        return n < 10 ? '0' + n : n;
                    }

                    return this.getUTCFullYear()   + '-' +
                         f(this.getUTCMonth() + 1) + '-' +
                         f(this.getUTCDate())      + 'T' +
                         f(this.getUTCHours())     + ':' +
                         f(this.getUTCMinutes())   + ':' +
                         f(this.getUTCSeconds())   + 'Z';
                };

            You can provide an optional replacer method. It will be passed the
            key and value of each member, with this bound to the containing
            object. The value that is returned from your method will be
            serialized. If your method returns undefined, then the member will
            be excluded from the serialization.

            If the replacer parameter is an array of strings, then it will be
            used to select the members to be serialized. It filters the results
            such that only members with keys listed in the replacer array are
            stringified.

            Values that do not have JSON representations, such as undefined or
            functions, will not be serialized. Such values in objects will be
            dropped; in arrays they will be replaced with null. You can use
            a replacer function to replace those with JSON values.
            JSON.stringify(undefined) returns undefined.

            The optional space parameter produces a stringification of the
            value that is filled with line breaks and indentation to make it
            easier to read.

            If the space parameter is a non-empty string, then that string will
            be used for indentation. If the space parameter is a number, then
            the indentation will be that many spaces.

            Example:

            text = JSON.stringify(['e', {pluribus: 'unum'}]);
            // text is '["e",{"pluribus":"unum"}]'


            text = JSON.stringify(['e', {pluribus: 'unum'}], null, '\t');
            // text is '[\n\t"e",\n\t{\n\t\t"pluribus": "unum"\n\t}\n]'

            text = JSON.stringify([new Date()], function (key, value) {
                return this[key] instanceof Date ?
                    'Date(' + this[key] + ')' : value;
            });
            // text is '["Date(---current time---)"]'


        JSON.parse(text, reviver)
            This method parses a JSON text to produce an object or array.
            It can throw a SyntaxError exception.

            The optional reviver parameter is a function that can filter and
            transform the results. It receives each of the keys and values,
            and its return value is used instead of the original value.
            If it returns what it received, then the structure is not modified.
            If it returns undefined then the member is deleted.

            Example:

            // Parse the text. Values that look like ISO date strings will
            // be converted to Date objects.

            myData = JSON.parse(text, function (key, value) {
                var a;
                if (typeof value === 'string') {
                    a =
/^(\d{4})-(\d{2})-(\d{2})T(\d{2}):(\d{2}):(\d{2}(?:\.\d*)?)Z$/.exec(value);
                    if (a) {
                        return new Date(Date.UTC(+a[1], +a[2] - 1, +a[3], +a[4],
                            +a[5], +a[6]));
                    }
                }
                return value;
            });

            myData = JSON.parse('["Date(09/09/2001)"]', function (key, value) {
                var d;
                if (typeof value === 'string' &&
                        value.slice(0, 5) === 'Date(' &&
                        value.slice(-1) === ')') {
                    d = new Date(value.slice(5, -1));
                    if (d) {
                        return d;
                    }
                }
                return value;
            });


    This is a reference implementation. You are free to copy, modify, or
    redistribute.
*/

/*jslint evil: true, regexp: true */

/*members "", "\b", "\t", "\n", "\f", "\r", "\"", JSON, "\\", apply,
    call, charCodeAt, getUTCDate, getUTCFullYear, getUTCHours,
    getUTCMinutes, getUTCMonth, getUTCSeconds, hasOwnProperty, join,
    lastIndex, length, parse, prototype, push, replace, slice, stringify,
    test, toJSON, toString, valueOf
*/


// Create a JSON object only if one does not already exist. We create the
// methods in a closure to avoid creating global variables.

var JSON;
if (!JSON) {
    JSON = {};
}

(function () {
    'use strict';

    function f(n) {
        // Format integers to have at least two digits.
        return n < 10 ? '0' + n : n;
    }

    if (typeof Date.prototype.toJSON !== 'function') {

        Date.prototype.toJSON = function (key) {

            return isFinite(this.valueOf())
                ? this.getUTCFullYear()     + '-' +
                    f(this.getUTCMonth() + 1) + '-' +
                    f(this.getUTCDate())      + 'T' +
                    f(this.getUTCHours())     + ':' +
                    f(this.getUTCMinutes())   + ':' +
                    f(this.getUTCSeconds())   + 'Z'
                : null;
        };

        String.prototype.toJSON      =
            Number.prototype.toJSON  =
            Boolean.prototype.toJSON = function (key) {
                return this.valueOf();
            };
    }

    var cx = /[\u0000\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g,
        escapable = /[\\\"\x00-\x1f\x7f-\x9f\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g,
        gap,
        indent,
        meta = {    // table of character substitutions
            '\b': '\\b',
            '\t': '\\t',
            '\n': '\\n',
            '\f': '\\f',
            '\r': '\\r',
            '"' : '\\"',
            '\\': '\\\\'
        },
        rep;


    function quote(string) {

// If the string contains no control characters, no quote characters, and no
// backslash characters, then we can safely slap some quotes around it.
// Otherwise we must also replace the offending characters with safe escape
// sequences.

        escapable.lastIndex = 0;
        return escapable.test(string) ? '"' + string.replace(escapable, function (a) {
            var c = meta[a];
            return typeof c === 'string'
                ? c
                : '\\u' + ('0000' + a.charCodeAt(0).toString(16)).slice(-4);
        }) + '"' : '"' + string + '"';
    }


    function str(key, holder) {

// Produce a string from holder[key].

        var i,          // The loop counter.
            k,          // The member key.
            v,          // The member value.
            length,
            mind = gap,
            partial,
            value = holder[key];

// If the value has a toJSON method, call it to obtain a replacement value.

        if (value && typeof value === 'object' &&
                typeof value.toJSON === 'function') {
            value = value.toJSON(key);
        }

// If we were called with a replacer function, then call the replacer to
// obtain a replacement value.

        if (typeof rep === 'function') {
            value = rep.call(holder, key, value);
        }

// What happens next depends on the value's type.

        switch (typeof value) {
        case 'string':
            return quote(value);

        case 'number':

// JSON numbers must be finite. Encode non-finite numbers as null.

            return isFinite(value) ? String(value) : 'null';

        case 'boolean':
        case 'null':

// If the value is a boolean or null, convert it to a string. Note:
// typeof null does not produce 'null'. The case is included here in
// the remote chance that this gets fixed someday.

            return String(value);

// If the type is 'object', we might be dealing with an object or an array or
// null.

        case 'object':

// Due to a specification blunder in ECMAScript, typeof null is 'object',
// so watch out for that case.

            if (!value) {
                return 'null';
            }

// Make an array to hold the partial results of stringifying this object value.

            gap += indent;
            partial = [];

// Is the value an array?

            if (Object.prototype.toString.apply(value) === '[object Array]') {

// The value is an array. Stringify every element. Use null as a placeholder
// for non-JSON values.

                length = value.length;
                for (i = 0; i < length; i += 1) {
                    partial[i] = str(i, value) || 'null';
                }

// Join all of the elements together, separated with commas, and wrap them in
// brackets.

                v = partial.length === 0
                    ? '[]'
                    : gap
                    ? '[\n' + gap + partial.join(',\n' + gap) + '\n' + mind + ']'
                    : '[' + partial.join(',') + ']';
                gap = mind;
                return v;
            }

// If the replacer is an array, use it to select the members to be stringified.

            if (rep && typeof rep === 'object') {
                length = rep.length;
                for (i = 0; i < length; i += 1) {
                    if (typeof rep[i] === 'string') {
                        k = rep[i];
                        v = str(k, value);
                        if (v) {
                            partial.push(quote(k) + (gap ? ': ' : ':') + v);
                        }
                    }
                }
            } else {

// Otherwise, iterate through all of the keys in the object.

                for (k in value) {
                    if (Object.prototype.hasOwnProperty.call(value, k)) {
                        v = str(k, value);
                        if (v) {
                            partial.push(quote(k) + (gap ? ': ' : ':') + v);
                        }
                    }
                }
            }

// Join all of the member texts together, separated with commas,
// and wrap them in braces.

            v = partial.length === 0
                ? '{}'
                : gap
                ? '{\n' + gap + partial.join(',\n' + gap) + '\n' + mind + '}'
                : '{' + partial.join(',') + '}';
            gap = mind;
            return v;
        }
    }

// If the JSON object does not yet have a stringify method, give it one.

    if (typeof JSON.stringify !== 'function') {
        JSON.stringify = function (value, replacer, space) {

// The stringify method takes a value and an optional replacer, and an optional
// space parameter, and returns a JSON text. The replacer can be a function
// that can replace values, or an array of strings that will select the keys.
// A default replacer method can be provided. Use of the space parameter can
// produce text that is more easily readable.

            var i;
            gap = '';
            indent = '';

// If the space parameter is a number, make an indent string containing that
// many spaces.

            if (typeof space === 'number') {
                for (i = 0; i < space; i += 1) {
                    indent += ' ';
                }

// If the space parameter is a string, it will be used as the indent string.

            } else if (typeof space === 'string') {
                indent = space;
            }

// If there is a replacer, it must be a function or an array.
// Otherwise, throw an error.

            rep = replacer;
            if (replacer && typeof replacer !== 'function' &&
                    (typeof replacer !== 'object' ||
                    typeof replacer.length !== 'number')) {
                throw new Error('JSON.stringify');
            }

// Make a fake root object containing our value under the key of ''.
// Return the result of stringifying the value.

            return str('', {'': value});
        };
    }


// If the JSON object does not yet have a parse method, give it one.

    if (typeof JSON.parse !== 'function') {
        JSON.parse = function (text, reviver) {

// The parse method takes a text and an optional reviver function, and returns
// a JavaScript value if the text is a valid JSON text.

            var j;

            function walk(holder, key) {

// The walk method is used to recursively walk the resulting structure so
// that modifications can be made.

                var k, v, value = holder[key];
                if (value && typeof value === 'object') {
                    for (k in value) {
                        if (Object.prototype.hasOwnProperty.call(value, k)) {
                            v = walk(value, k);
                            if (v !== undefined) {
                                value[k] = v;
                            } else {
                                delete value[k];
                            }
                        }
                    }
                }
                return reviver.call(holder, key, value);
            }


// Parsing happens in four stages. In the first stage, we replace certain
// Unicode characters with escape sequences. JavaScript handles many characters
// incorrectly, either silently deleting them, or treating them as line endings.

            text = String(text);
            cx.lastIndex = 0;
            if (cx.test(text)) {
                text = text.replace(cx, function (a) {
                    return '\\u' +
                        ('0000' + a.charCodeAt(0).toString(16)).slice(-4);
                });
            }

// In the second stage, we run the text against regular expressions that look
// for non-JSON patterns. We are especially concerned with '()' and 'new'
// because they can cause invocation, and '=' because it can cause mutation.
// But just to be safe, we want to reject all unexpected forms.

// We split the second stage into 4 regexp operations in order to work around
// crippling inefficiencies in IE's and Safari's regexp engines. First we
// replace the JSON backslash pairs with '@' (a non-JSON character). Second, we
// replace all simple value tokens with ']' characters. Third, we delete all
// open brackets that follow a colon or comma or that begin the text. Finally,
// we look to see that the remaining characters are only whitespace or ']' or
// ',' or ':' or '{' or '}'. If that is so, then the text is safe for eval.

            if (/^[\],:{}\s]*$/
                    .test(text.replace(/\\(?:["\\\/bfnrt]|u[0-9a-fA-F]{4})/g, '@')
                        .replace(/"[^"\\\n\r]*"|true|false|null|-?\d+(?:\.\d*)?(?:[eE][+\-]?\d+)?/g, ']')
                        .replace(/(?:^|:|,)(?:\s*\[)+/g, ''))) {

// In the third stage we use the eval function to compile the text into a
// JavaScript structure. The '{' operator is subject to a syntactic ambiguity
// in JavaScript: it can begin a block or an object literal. We wrap the text
// in parens to eliminate the ambiguity.

                j = eval('(' + text + ')');

// In the optional fourth stage, we recursively walk the new structure, passing
// each name/value pair to a reviver function for possible transformation.

                return typeof reviver === 'function'
                    ? walk({'': j}, '')
                    : j;
            }

// If the text is not JSON parseable, then a SyntaxError is thrown.

            throw new SyntaxError('JSON.parse');
        };
    }
}());/*global global: true, process: true, require: true, module: true */

/**
 * Establishes the `GCN' object and exposes it in the global context.
 */
GCN = (function (global) {
	'use strict';

	// Check whether we are in nodeJS context.
	if (typeof process !== 'undefined' && process.versions
			&& process.versions.node) {
		global.isNode = true;
		var XMLHttpRequest = require('xmlhttprequest').XMLHttpRequest;
		jQuery = global.$ = global.jQuery = require('jquery');
		global.jQuery.ajaxSettings.xhr = function createNodeXHRForGCN() {
			return new XMLHttpRequest();
		};
		// http://stackoverflow.com/a/6432602
		global.jQuery.support.cors = true;
	}

	/**
	 * @private
	 * @type {boolean} A flag to indicate whether or not a handler has been
	 *                 registerd through the `GCN.onRender()' function.
	 */
	var hasOnRenderHandler = false;

	/**
	 * @private
	 * @type {boolean} A flag to indicate whether or not a handler has been
	 *                 registerd through the `GCN.onError()' function.
	 */
	var hasOnErrorHandler = false;

	/**
	 * @ignore
	 * @type {boolean} An internal flag that stores whether an authentication
	 *                 handler has been set.
	 */
	var hasAuthenticationHandler = false;

	/**
	 * GCN JS API error object.  This is the object passed to error handlers.
	 *
	 * @class 
	 * @name GCNError
	 * @param {string} code error code for the error
	 * @param {string} message descriptive error message
	 * @param {object} data additional data
	 */
	var GCNError = function (code, message, data) {
		this.code = code;
		this.message = message;
		this.data = data;
	};

	/**
	 * Returns a human-readable representation of this error object.
	 *
	 * @public
	 * @return {string}
	 */
	GCNError.prototype.toString = function () {
		return 'GCN ERROR (' + this.code + '): "' + (this.message || '') + '"';
	};

	/**
	 * @name GCN
	 * @class
	 *
	 * Base namespace for the Gentics Content.Node JavaScript API.
	 */
	var GCN = global.GCN || {};

	jQuery.extend(GCN, {
		/** @lends GCN */

		/**
		 * Reference to the global context.
		 * 
		 * @type {object} 
		 */
		global: global,

		/**
		 * Settings for the Gentics Content.Node JavaScript API.
		 * 
		 * @type {object<string, string>}
		 */
		settings: {

			/**
			 * The language code with which to render tags.
			 * 
			 * @const
			 * @name settings.lang
			 * @default 'en'
			 * @memberOf GCN
			 * @type {string} 
			 */
			lang: 'en',

			/**
			 * Default GCN backend path. Do not add a trailing slash here.
			 * 
			 * @const
			 * @default '/CNPortletapp'
			 * @name settings.BACKEND_PATH
			 * @memberOf GCN
			 * @type {string}
			 */
			BACKEND_PATH: '/CNPortletapp',

			/**
			 * The keyword for the construct that defines Aloha Editor links. In
			 * most Content.Node installations this will be "gtxalohapagelink",
			 * but can be otherwise defined.
			 * 
			 * @const
			 * @default 'gtxalohapagelink'
			 * @name settings.MAGIC_LINK
			 * @memberOf GCN
			 * @type {string}
			 */
			MAGIC_LINK: 'gtxalohapagelink',

			/**
			 * Determines whether links will be rendered as back-end urls or
			 * front-end urls. Can either be set to "backend" or "frontend".
			 * 
			 * @const
			 * @default 'backend'
			 * @name settings.linksRenderMode
			 * @memberOf GCN
			 * @type {string}
			 */
			linksRenderMode: 'backend',

			/**
			 * Set a channelid to work on for multichannelling or false if no
			 * channel should be used
			 * 
			 * @memberOf GCN
			 * @default false
			 * @type {bool|int|string}
			 */
			channel: false
		},

		/**
		 * Publish a message
		 *
		 * @param {string} message channel name
		 * @param {*=} params
		 */
		pub: function (channel, params) {
			if (!hasOnErrorHandler && channel === 'error-encountered') {
				// throw an error if there is no subscription to
				// error-encountered.
				throw params;
			}

			jQuery(GCN).trigger(channel, params);
		},

		/**
		 * Subscribe to a message channel
		 *
		 * @param {string} message channel name
		 * @param {function} handler function - message parameters will be
		 *                           passed.
		 */
		sub: function (channel, handler) {
			// register default handlers
			switch (channel) {
			case 'error-encountered':
				hasOnErrorHandler = true;
				break;
			case 'tag.rendered':
			case 'page.rendered':
			case 'content-rendered':
				hasOnRenderHandler = true;
				break;
			case 'authentication-required':
			case 'session.authentication-required':
				hasAuthenticationHandler = true;
				break;
			}

			jQuery(GCN).bind(channel, function (event, param1, param2, param3) {
				handler(param1, param2, param3);
			});
		},

		/**
		 * Tigger an error message 'error-encountered'.
		 *
		 * @param {string} error code
		 * @param {string} error message
		 * @param {object} additional error data
		 */
		error: function (code, message, data) {
			var error = new GCNError(code, message, data);
			this.pub('error-encountered', error);
		},

		/**
		 * Returns an object containing the formal error fields.  The object
		 * contains a `toString' method to print any uncaught exceptions
		 * nicely.
		 *
		 * @param {string} code
		 * @param {string} message
		 * @param {object} data
		 * @return {GCNError}
		 */
		createError: function (code, message, data) {
			return new GCNError(code, message, data);
		},

		/**
		 * Wraps the `jQuery.ajax()' method.
		 *
		 * @public
		 * @param {object} settings
		 * @throws HTTP_ERROR
		 */
		ajax: function (settings) {
			if (settings.json) {
				settings.data = JSON.stringify(settings.json);
				delete settings.json;
			}
			settings.dataType = 'json';
			settings.contentType = 'application/json; charset=utf-8';
			jQuery.ajax(settings);
		},

		/**
		 * Set links render mode if a parameter is given
		 * retrieve it if not
		 *
		 * @param {string} mode
		 * @return {string} mode
		 */
		linksRenderMode: function (mode) {
			if (mode) {
				GCN.settings.linksRenderMode = mode;
			}
			return GCN.settings.linksRenderMode;
		},

		/**
		 * Set channel if a parameter is given retrieve it otherwise.
		 *
		 * If you don't want to work on a channel just set it to false, which
		 * is the default value.
		 *
		 * @param {string|boolean} channel The id of the channel to be set or false to unset the channel.
		 * @return {string} current channel id.
		 */
		channel: function (channel) {
			if (channel || false === channel) {
				GCN.settings.channel = channel;
			}
			return GCN.settings.channel;
		},

		/**
		 * Constructs the nodeId query parameter for rest calls.
		 *
		 * @param {AbstractContentObject} contentObject A content object instance.
		 * @param {string=} delimiter Optional delimiter character.
		 * @return {string} Query parameter string.
		 */
		_getChannelParameter: function (contentObject, delimiter) {
			if (false === contentObject._channel) {
				return '';
			}
			return (delimiter || '?') + 'nodeId=' + contentObject._channel;
		},

		/**
		 * @param {string} html Rendered content
		 * @param {Chainback} obj The rendered ContentObject.
		 * @param {function(html)} callback Receives the processed html.
		 */
		_handleContentRendered: function (html, obj, callback) {
			if (hasOnRenderHandler) {
				// Because 'content-rendered' has been deprecated in favor of
				// '{tag|page}.rendered'.
				GCN.pub('content-rendered', [html, obj, callback]);
				GCN.pub(obj._type + '.rendered', [html, obj, callback]);
			} else {
				callback(html);
			}
		},

		/**
		 * Handles the ajax transport error.  It will invoke the custom error
		 * handler if one is provided, and propagate the error onto the global
		 * handler if the an error handler does not return `false'.
		 *
		 * @param {object} xhr
		 * @param {string} msg The error message
		 * @param {function} handler Custom error handler.
		 * @throws HTTP_ERROR
		 */
		handleHttpError: function (xhr, msg, handler) {
			var throwException = true;

			if (handler) {
				throwException = handler(GCN.createError('HTTP_ERROR', msg,
					xhr));
			}

			if (throwException !== 'false') {
				GCN.error('HTTP_ERROR', msg, xhr);
			}
		},

		/**
		 * Handles error that occur when an ajax request succeeds but the
		 * backend responds with an error.
		 *
		 * @param {object} reponse The REST API response object.
		 * @param {function(GCNError):boolean} handler Custom error handler.
		 */
		handleResponseError: function (response, handler) {
			var info = response.responseInfo;
			var throwException = true;

			if (handler) {
				throwException = handler(GCN.createError(
					info.responseCode,
					info.responseMessage,
					response
				));
			}

			if (throwException !== false) {
				GCN.error(info.responseCode, info.responseMessage, response);
			}
		},

		/**
		 * Tiggers the GCN error event.
		 *
		 * @param {GCNError} error
		 * @param {function(GCNError):boolean} handler Custom error handler.
		 * @return {boolean} Whether or not to the exception was thrown.
		 */
		handleError: function (error, handler) {
			var throwException = true;

			if (handler) {
				throwException = handler(error);
			}

			if (throwException !== false) {
				GCN.error(error.code, error.message, error.data);
			}

			return throwException;
		},

		/**
		 * Check if an authentication handler has been registered.
		 *
		 * @return {boolean} True if an handler for the
		 *                   'authentication-required' message has been
		 *                   registered.
		 */
		_hasAuthenticationHandler: function () {
			return hasAuthenticationHandler;
		}

	});

	// Expose the Gentics Content.Node JavaScript API to the global context.
	// This will be `window' in most cases.
	return (global.GCN = GCN);

}(typeof global !== 'undefined' ? global : window));
(function (GCN) {

	'use strict';

	/**
	 * Only grows, never shrinks.
	 *
	 * @private
	 * @type {number}
	 */
	var uniqueIdCounter = 0;

	/**
	 * Generates a unique id with an optional prefix.
	 *
	 * The returned value is only unique among other returned values,
	 * not globally.
	 *
	 * @public
	 * @param {string}
	 *        Optional prefix for the id to be generated.
	 * @return {string}
	 *        Never the same string more than once.
	 */
	function uniqueId(prefix) {
		return (prefix || '') + (++uniqueIdCounter);
	}

	/**
	 * Escapes the given property name by prefixing dots with backslashes.
	 *
	 * @param {string} name The property name to escape.
	 * @return {string} Escaed string.
	 */
	function escapePropertyName(name) {
		return name.replace(/\./g, '\\.');
	}

	/**
	 * A regular expression to identify executable script tags.
	 *
	 * @type {RegExp}
	 */
	var rgxpScriptType = /\/(java|ecma)script/i;


	/**
	 * A string to be used in regular expressions matching script tags.
	 *
	 * TODO: The string does not work correctly for complex cases and
	 * should be improved.
	 *
	 * @type {string}
	 */
	var SCRIPT_TAG = '<script(\\s[^>]*?)?>';

	/**
	 * This regular expression is used to find opening script tags.
	 *
	 * It uses the global flag to find several matching tags, for
	 * example to replace them.
	 *
	 * @type {RegExp}
	 */
	var rgxpScriptTags = new RegExp(SCRIPT_TAG, 'ig');

	/**
	 * This regular expression is used to find opening script tags.
	 * It does not use the global flag, and can be used to test if
	 * a string contains scripts at all.
	 *
	 * For testing strings, this expression should be used instead
	 * of rgxpScriptTags, because the latter keeps an index of found
	 * occurrences (due to its global flag), which causes the
	 * regular expression to often fail (in Firefox).
	 *
	 * @type {RegExp}
	 */
	var rgxpScriptTag = new RegExp(SCRIPT_TAG, 'i');



	/**
	 * A regular expression to find script types.
	 *
	 * @type {RegExp}
	 */
	var rgxpType = new RegExp(
		' type\\s*=\\s*'
			+ '[\\"\\\']'
			+ '([^\\"\\\']*[^\\s][^\\"\\\']*)'
			+ '[\\"\\\']',
		'i'
	);

	var rand = Math.random().toString().replace('.', '');

	/**
	 * Places sentinal strings in front of every executable script tag.
	 *
	 * @param {string} html HTML markup
	 * @return {string} HTML string with marked <script> tags.
	 */
	function markScriptTagLocations(html) {
		var i = 0;
		rgxpScriptTags.lastIndex = 0;
		return html.replace(rgxpScriptTags, function (str, substr, offset) {
			var type = substr && substr.match(rgxpType);
			if (!type || rgxpScriptType.test(type)) {
				return rand + (i++) + str;
			}
			return str;
		});
	}

	/**
	 * Masks a <script> tag's `type' attribute by replacing it with a random
	 * string.
	 *
	 * Masking script tags is done to prevent them from being handled specially
	 * by jQuery, which removes javascript/ecmascript tags when appending DOM
	 * elements into the document, but executes them.
	 *
	 * unmakeScriptType() reverses this.
	 *
	 * @param {jQuery.<HTMLElement>} $script jQuery unit set containing the
	 *                                       <script> tag that is to have its
	 *                                       type attribute masked.
	 */
	function maskScriptType($script) {
		var type = $script.attr('type');
		$script.attr('type', rand).attr('data-origtype', type);
	}

	/**
	 * Restores a <script> tag's original type attribute value if it had been
	 * masked using maskScriptType().
	 *
	 * Essentially the reverse of maskScriptType().
	 *
	 * @param {jQuery.<HTMLElement>} $script jQuery unit set containing the
	 *                                       <script> tag that is to have its
	 *                                       type attribute unmasked.
	 */
	function unmaskScriptType($script) {
		var orig = $script.attr('data-origtype');
		if (typeof orig === 'string') {
			$script.attr('type', orig).removeAttr('data-origtype');
		} else {
			$script.removeAttr('type');
		}
	}

	/**
	 * Replaces the type attribute of <script> tags with a value that will
	 * protect them from being specially handled by jQuery.
	 *
	 * @param {string} html Markup
	 * @return {string} Markup with <script> tags protected from jQuery.
	 */
	function protectScriptTags(html, $scripts) {
		var i;
		var type;
		var $script;
		for (i = 0; i < $scripts.length; i++) {
			$script = $scripts.eq(i);
			type = $script.attr('type');
			if (!type || rgxpScriptType.test(type)) {
				maskScriptType($script);
				html = html.replace(rand + i, $script[0].outerHTML);
				unmaskScriptType($script);
			}
		}
		return html;
	}

	/**
	 * Restores the type attribute for <script> tags that have been processed
	 * via protectScriptTags().
	 *
	 * @param {jQuery.<HTMLElement>} $element Root HTMLElement in which to
	 *                                        restore <script> tags.
	 */
	function restoreScriptTagTypes($element) {
		var $scripts = $element.find('script[type="' + rand + '"]');
		var $script;
		var i;
		for (i = 0; i < $scripts.length; i++) {
			$script = $scripts.eq(i);
			$script.removeClass(rand + i);
			unmaskScriptType($script);
		}
	}

	/**
	 * Joins the innerHTML of multiple elements.
	 *
	 * @param {jQuery.<HTMLElement>} $elements
	 * @return {string} A concatenated string of the contents of the given set
	 *                  of elements.
	 */
	function joinContents($elements) {
		var contents = '';
		$elements.each(function () {
			contents += jQuery(this).html();
		});
		return contents;
	}

	/**
	 * Inserts the inner HTML of the given HTML markup while preserving
	 * <script> tags, and still allowing jQuery to execute them.
	 *
	 * @param {jQuery.<HTMLElement>} $element
	 * @param {string} html
	 */
	function insertInnerHTMLWithScriptTags($element, html) {
		if (!rgxpScriptTag.test(html)) {
			$element.html(jQuery(html).contents());
			return;
		}
		var marked = markScriptTagLocations(html);
		var $scripts = jQuery(html).filter('script');
		var $html = jQuery(marked);
		var contents = joinContents($html.filter(':not(script)'));
		contents = protectScriptTags(contents, $scripts);
		$element.html(contents);

		// Trap script errors originating from rendered tags and log it on the
		// console.
		try {
			$element.append($scripts);
		} catch (ex) {
			var _console = 'console'; // Because jslint is paranoid.
			if (typeof window[_console] === 'function') {
				window[_console].error(ex);
			}
		}

		restoreScriptTagTypes($element);
	}

	/**
	 * Merge class names from one element into another.
	 *
	 * The merge result will be a unqiue set of space-seperated class names.
	 *
	 * @param {jQuery.<HTMLElement>} $first jQuery unit set containing the DOM
	 *                                      whose class names are to be merged.
	 * @param {jQuery.<HTMLElement>} $second jQuery unit set containing the DOM
	 *                                       whose class names are to be merged.
	 * @return {string} The merge result of the merge: a unqiue set of
	 *                  space-seperated class names.
	 */
	function mergeClassNames($first, $second) {
		var first = ($first.attr('class') || '').split(' ');
		var second = ($second.attr('class') || '').split(' ');
		var names = first.concat(second).sort();
		var i;
		for (i = 1; i < names.length; i++) {
			if (names[i] === names[i - 1]) {
				names.splice(i--, 1);
			}
		}
		return names.join(' ');
	}

	/**
	 * Creates a map of attributes merged from their value in $from with their
	 * value in $to.
	 *
	 * Class names--unlike other attributes, which are simply copied from $from
	 * into $to--are treaded specially to produce a unique set of
	 * space-seperated class names.
	 *
	 * @param {jQuery.<HTMLElement>} $to jQuery unit set containing the DOM
	 *                                   element which should receive the
	 *                                   merged attributes.
	 * @param {jQuery.<HTMLElement>} $from jQuery unit set containing the DOM
	 *                                     element whose attributes will be
	 *                                     merged into the other.
	 * @param {object<string, string>} A associate array of attributes.
	 */
	function mergeAttributes($to, $from) {
		var from = $from[0].attributes;
		var to = $to[0].attributes;
		var i;
		var attr = {};
		for (i = 0; i < from.length; i++) {
			attr[from[i].name] = ('class' === from[i].name)
			                   ? mergeClassNames($to, $from)
			                   : $from.attr(from[i].name);
		}
		return attr;
	}

	/**
	 * Renders the given HTML string onto (not into) an DOM element.
	 * Does nearly the equivelent of $.replaceWith() or changing the element's
	 * outerHTML.
	 *
	 *             http://bugs.jquery.com/ticket/8142#comment:6
	 *             ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	 * 'All of jQuery's insertion methods use a domManip function internally  to
	 * clean/process elements before and after they are inserted into  the  DOM.
	 * One of the things the domManip function  does  is  pull  out  any  script
	 * elements about to  be  inserted  and  run  them  through  an  "evalScript
	 * routine" rather than inject them with the rest of the  DOM  fragment.  It
	 * inserts the scripts separately, evaluates them,  and  then  removes  them
	 * from the DOM.
	 *
	 * 'I believe that  one  of  the  reasons  jQuery  does  this  is  to  avoid
	 * "Permission Denied" errors that  can  occur  in  Internet  Explorer  when
	 * inserting scripts under certain circumstances. It also avoids  repeatedly
	 * inserting/evaluating the  same  script  (which  could  potentially  cause
	 * problems) if it is within a containing element that you are inserting and
	 * then moving around the DOM.'
	 *
	 * @param {jQuery.<HTMLElement>} $element jQuery unit set containing the
	 *                                        DOM element we wish to render the
	 *                                        given html content onto.
	 * @param {string} html HTML content which will become give to the element.
	 */
	function renderOnto($element, html) {
		insertInnerHTMLWithScriptTags($element, html);
		var attr = mergeAttributes($element, jQuery(html));
		var name;
		for (name in attr) {
			if (attr.hasOwnProperty(name)) {
				$element.attr(name, attr[name]);
			}
		}
	}

	/**
	 * Removes the given chainback instance from its cached location.
	 *
	 * @param {Chainback} chainback Instance to remove from cache.
	 */
	function decache(chainback) {
		if (chainback._constructor.__gcncache__[chainback.__gcnhash__]) {
			delete chainback._constructor.__gcncache__[chainback.__gcnhash__];
		}
	}

	/**
	 * Maps constructs, that were fetched via the Rest API, to a hashmap, using
	 * their keyword as the keys.
	 *
	 * @param {object<string, object>} constructs Consturcts mapped against
	 *                                            their id.
	 * @return {object<string, object>} Constructs mapped against their keys.
	 */
	function mapConstructs(constructs) {
		if (!constructs) {
			return {};
		}
		var map = {};
		var constructId;
		for (constructId in constructs) {
			if (constructs.hasOwnProperty(constructId)) {
				map[constructs[constructId].keyword] = constructs[constructId];
			}
		}
		return map;
	}

	GCN.uniqueId = uniqueId;
	GCN.escapePropertyName = escapePropertyName;
	GCN.renderOnto = renderOnto;
	GCN.decache = decache;
	GCN.mapConstructs = mapConstructs;

}(GCN));
(function (GCN) {

	'use strict';

	/**
	 * Enqueue a method into the given chainback objects's call chain. If a
	 * mutex is locking this chain, then place the call in the queued calls
	 * instead.
	 *
	 * @private
	 * @param {Chainback} chainback The object whose queue we want to push
	 *                                  the given method to.
	 * @param {function} method The method to chain.
	 */
	function addCallToQueue(chainback, method) {
		if (!chainback.__gcnmutex__) {
			chainback.__gcncallqueue__.push(method);
		} else {
			chainback.__gcncallchain__.push(method);
			if (0 === chainback.__gcnajaxcount__
					&& 1 === chainback.__gcncallchain__.length) {
				method.call(chainback);
			}
		}
	}

	/**
	 * Dequeue the function at the top of the given chainback's call chain and
	 * invoke the next function in the queue.
	 *
	 * @private
	 * @param {Chainback} chainback
	 */
	function callNext(chainback) {
		// Waiting for an ajax call to complete.  Go away, and try again when
		// another call completes.
		if (chainback.__gcnajaxcount__ > 0) {
			return;
		}

		if (0 === chainback.__gcncallchain__.length
				&& 0 === chainback.__gcncallqueue__.length) {
			return; // We should never reach here. Just so you know...
		}

		// Discard the empty shell...
		chainback.__gcncallchain__.shift();

		// Load and fire the next bullet...
		if (chainback.__gcncallchain__.length) {
			chainback.__gcncallchain__[0].call(chainback);
		} else if (chainback.__gcncallqueue__.length) {
			chainback.__gcncallqueue__.shift().call(chainback);
		}
	}

	/**
	 * Wraps the given method in a closure that provides scaffolding to chain
	 * invocations of the method correctly.
	 *
	 * @private
	 * @param {function} method The original function we want to wrap.
	 * @param {string} name The method name as it was defined in its object.
	 * @return {function} A function that wraps the original function.
	 */
	function makeMethodChainable(method, name) {
		return function () {
			var args = arguments;
			var that = this;
			var func = function () {
				method.apply(that, args);
				callNext(that);
			};
			func.__gcncallname__ = name; // For debugging
			addCallToQueue(this, func);
			return this;
		};
	}

	/**
	 * The Chainback constructor.
	 *
	 * Surfaces the chainback constructor in such a way as to be able to use
	 * call apply() on it.
	 *
	 * http://stackoverflow.com/questions/1606797/use-of-apply-with-new-operator-is-this-possible
	 *
	 * @private
	 * @param {Chainback} ctor The Chainback class we wish to initialize.
	 * @param {Array} args
	 * @param {object} continuation
	 * @return {Chainback}
	 */
	var Chainback = (function () {
		var Chainback = function (ctor, args) {
			return ctor.apply(this, args);
		};
		return function (ctor, args, continuation) {
			Chainback.prototype = ctor.prototype;
			return new Chainback(ctor, args);
		};
	}());

	/**
	 * Get a chainback instance's current channel.
	 *
	 * @param {Chainback} chainback
	 * @return {number} The channel id or 0 if no channel is set.
	 */
	function getChannel(chainback) {
		return chainback._channel || 0;
	}

	/**
	 * Get an instance of the given chainback class from its constructor's
	 * cache.  If the object for this hash does not exist in the cache, then
	 * instantiate a new object, place into the cache using the hash as the
	 * cache key.
	 *
	 * If no hash is passed to this function, then the Chainback instance that
	 * is returned will not be fully realized.  It will be a "fetus" instance
	 * that has yet to be bound to an id. Once it receives an id it will keep
	 * it for the remainder of its life.  These "fetus" instances are not be
	 * placed in the cache until they have aquired an id.
	 *
	 * @ignore
	 * @private
	 * @param {Chainback} ctor A chainback constructor.
	 * @param {string} hash A hash string that represents this chainback.
	 * @param {Chainback} callee The Chainback instance from which this
	 *                           invocation originated.
	 * @param {Array.<*>} args Arguments that will be applied to the chainback
	 *                         when (re-) initializing it.  This array should
	 *                         contain the following elements in the following
	 *                         order:
	 *                              id : string|array
	 *                         success : function|null
	 *                           error : function|null
	 *                         setting : object
	 * @return {Chainback}
	 */
	GCN.getChainback = function (ctor, hash, callee, args) {
		var chainback = hash && ctor.__gcncache__[hash];
		if (chainback) {
			// Reset the cached instance and re-initialize it.
			chainback._chain = callee;
			return chainback._init.apply(chainback, args);
		}
		args.push(callee);
		var isFetus = !hash;
		var hasCallee = !!callee;
		if (isFetus && hasCallee) {
			// TODO: Creating a hash form just the ctor argument is
			//       insufficient.  We must also consider
			//       ctor._needsChainedHash.  For example, createTag() will
			//       cause a new chanback to be created which will have a hash
			//       value of 'TagAPI:id' but it should be
			//       'Page::id::TagAPI:id'.
			hash = ctor._makeHash(getChannel(callee) + '/' + GCN.uniqueId(ctor.__chainbacktype__ + '-unique-'));
			chainback = callee.__gcntempcache__[hash];
			if (!chainback) {
				chainback =
					callee.__gcntempcache__[hash] =
						new Chainback(ctor, args);
			}
			return chainback;
		}
		return new Chainback(ctor, args);
	};

	/**
	 * @ignore
	 * Create a class which allows for chainable callback methods.
	 * @private
	 * @param {object<string, *>} props Definition of the class to be created.
	 *                                  All function are wrapped to allow them
	 *                                  to be as chainable callbacks unless
	 *                                  their name is prefixed with a "!" .
	 * @return {Chainback}
	 */
	GCN.defineChainback = function (props) {

		/**
		 * @ignore
		 * @TODO: use named arguments
		 *
		 * @constructor
		 * @param {number|string} id
		 * @param {?function(Chainback)} success
		 * @param {?function(GCNError):boolean} error
		 * @param {?object} chainlink
		 */
		var chainback = function () {
			var args = Array.prototype.slice.call(arguments);

			this._chain = args.pop();
			this._channel = this._chain ? this._chain._channel : GCN.channel();

			// Please note: We prefix and suffix these values with a double
			// underscore because they are not to be relied on whatsoever
			// outside of this file!  Although they need to be carried around
			// on chainback instances, they are nevertheless soley for internal
			// wiring.
			this.__gcnmutex__     = true;
			this.__gcncallchain__ = [];
			this.__gcncallqueue__ = [];
			this.__gcntempcache__ = {};

			// This is used to synchronize ajax calls with non-ajax calls in a
			// chainback call queue.
			//
			// It serves as a type of countdown latch, or reverse counting
			// semaphore (msdn.microsoft.com/en-us/magazine/cc163427.aspx).
			//
			// Upon each invocation of `_queueAjax()', on a chainback object,
			// its `__gcnajaxcount__' counter will be incremented.  And each
			// time a queued ajax call completes (successfully or otherwise),
			// the counter is decremented.  Before any chainback object can
			// move on to the next call in its call queue, it will check the
			// value of this counter to determine whether it is permitted to do
			// so.  If the counter's value is 0, access is granted;  otherwise
			// the requesting chainback will wait until a pending ajax call
			// completes to trigger a retry.
			this.__gcnajaxcount__ = 0;

			var obj = args[0];
			var ids;

			switch (jQuery.type(obj)) {
			case 'null':
			case 'undefined':
				break;
			case 'object':
				if (typeof obj.id !== 'undefined') {
					ids = [obj.id];
				}
				break;
			case 'array':
				ids = obj;
				break;
			default:
				ids = [obj];
			}

			// If one or more id is provided in the instantialization of this
			// object, only then will this instance be added to its class'
			// cache.
			if (ids) {
				this._setHash(ids.sort().join(','));
				this._addToCache();
			}

			this._init.apply(this, args);
		};

		/**
		 * Causes all promises that are made by this Chainback object, as well
		 * as all derived promises, to be resolved before the given success
		 * callback is invoked to receive this object in a "fulfilled" state.
		 * If a problem is encountered at any point during the resolution of a
		 * promise in the resolution chain, the error function is called, and
		 * further resolution is aborted.
		 *
		 * @private
		 * @param {function(Chainback)} success Callback function to be invoked
		 *                                      when all the promises on which
		 *                                      this object depends have been
		 *                                      completed.
		 * @param {function(GCNError):boolean=} error Optional custom error
		 *                                      handler.
		 */
		chainback.prototype._fulfill = function (success, error) {
			if (this._chain) {
				this._chain._fulfill(success, error);
			} else {
				success(this);
			}
		};

		// inheritance
		if (props._extends) {
			var inheritance = (jQuery.type(props._extends) === 'array')
			                ? props._extends
			                : [props._extends];
			var i;
			for (i = 0; i < inheritance.length; i++) {
				jQuery.extend(chainback.prototype, inheritance[i].prototype);
			}
			delete props._extends;
		}

		// static fields and methods
		jQuery.extend(chainback, {

			/**
			 * @private
			 * @static
			 * @type {object<string, Chainback>} An associative array holding
			 *                                   instances of this class.  Each
			 *                                   instance is mapped against a
			 *                                   hash key generated through
			 *                                   `_makehash()'.
			 */
			__gcncache__: {},

			/**
			 * @private
			 * @static
			 * @type {string} A string that represents this chainback's type.
			 *                It is used in generating hashs for instances of
			 *                this class.
			 */
			__chainbacktype__: props.__chainbacktype__ ||
				Math.random().toString(32),

			/**
			 * @private
			 * @static
			 * @type {boolean} Whether or not we need to use the hash of this
			 *                 object's parent chainback object in order to
			 *                 generate a unique hash key when instantiating
			 *                 objects for this class.
			 */
			_needsChainedHash: false,

			/**
			 * Given the arguments "one", "two", "three", will return something
			 * like: "one::two::ChainbackType:three".
			 *
			 * @private
			 * @static
			 * @param {...string} One or more strings to concatenate into the
			 *                    hash.
			 * @return {string} The hash string.
			 */
			_makeHash: function () {
				var ids = Array.prototype.slice.call(arguments);
				var id = ids.pop();
				ids.push(chainback.__chainbacktype__ + ':' + id);
				return ids.join('::');
			}
		});

		var DONT_MERGE = {
			__gcnmutex__     : true,
			__gcnorigin__    : true,
			__gcncallchain__ : true,
			__gcncallqueue__ : true,
			__gcnajaxcount__ : true,
			__gcntempcache__ : true
		};

		// Prototype chainback methods and properties

		jQuery.extend(chainback.prototype, {

			/**
			 * @type {Chainback} Each object holds a reference to its
			 *                   constructor.
			 */
			_constructor: chainback,

			/**
			 * Facilitates chaining from one chainback object to another.
			 *
			 * Uses "chainlink" objects to grow and internal linked list of
			 * chainback objects which make up a sort of callee chain.
			 *
			 * A link is created every time a context switch happens
			 * (ie: moving from one API to another).  Consider the following:
			 *
			 * page('1').tags().tag('content').render('#content');
			 *
			 * Accomplishing the above chain of execution will involve 3
			 * different chainable APIs, and 2 different API switches: a page
			 * API flows into a tags collection API, which in turn flows to a
			 * tag API.  This method is invoked each time that the exposed API
			 * mutates in this way.
			 *
			 * @private
			 * @param {Chainback} ctor The Chainback class we want to continue
			 *                         with.
			 * @param {number|string|Array.<number|string>|object} settings
			 *      If this argument is not defined, a random hash will be
			 *      generated as the object's hash.
			 *      An object can be provided instead of an id to directly
			 *      instantiate it from JSON data received from the server.
			 * @param {function} success
			 * @param {function} error
			 * @return {Chainback}
			 * @throws UNKNOWN_ARGUMENT If `settings' is not a number, string,
			 *                          array or object.
			 */
			_continue: function (ctor, settings, success, error) {
				// Is this a fully realized Chainback, or is it a Chainback
				// which has yet to determine which id it is bound to, from its
				// parent?
				var isFetus = false;
				var ids;
				var hashInputs = [];

				switch (jQuery.type(settings)) {
				case 'undefined':
				case 'null':
					isFetus = true;
					break;
				case 'array':
					ids = settings.sort().join(',');
					break;
				case 'number':
				case 'string':
					ids = settings;
					break;
				case 'object':
					ids = settings.id;
					break;
				default:
					GCN.error('UNKNOWN_ARGUMENT',
						'Don\'t know what to do with the object ' + settings);
					return;
				}

				var hash;
				if (isFetus) {
					hash = null;
				} else {
					var channel = getChannel(this);
					hash = ctor._needsChainedHash
					     ? ctor._makeHash(this.__gcnhash__, channel + '/' + ids)
					     : ctor._makeHash(channel + '/' + ids);
				}

				var chainback = GCN.getChainback(ctor, hash, this,
					[settings, success, error, {}]);

				return chainback;
			},

			/**
			 * Terminates any further exection of the functions that remain in
			 * the call queue.
			 *
			 * TODO: Kill all ajax calls.
			 *
			 * @private
			 * @return {Array.<function>} A list of functions that we in this
			 *                            Chainback's call queue when an abort
			 *                            happend.
			 */
			_abort: function () {
				this._clearCache();
				var callchain =
						this.__gcncallchain__.concat(this.__gcncallqueue__);
				this.__gcnmutex__ = true;
				this.__gcncallchain__ = [];
				this.__gcncallqueue__ = [];
				return callchain;
			},

			/**
			 * Gets the chainback from which this object was `_continue'd()
			 * from.
			 *
			 * @private
			 * @param {Chainback}
			 * @return {Chainback} This Chainback's ancestor.
			 */
			_ancestor: function () {
				return this._chain;
			},

			/**
			 * Locks the semaphore.
			 *
			 * @private
			 * @return {Chainback} This Chainback.
			 */
			_procure: function () {
				this.__gcnmutex__ = false;
				return this;
			},

			/**
			 * Unlocks the semaphore.
			 *
			 * @private
			 * @return {Chainback} This Chainback.
			 */
			_vacate: function () {
				this.__gcnmutex__ = true;
				this.__release__();
				return this;
			},

			/**
			 * Halts and forks the main call chain of this chainback object.
			 * Creates a derivitive object that will be used to accomplish
			 * operations that need to complete before the main chain is
			 * permitted to proceed.  Before execution on the main chainback
			 * object is restarted, the forked derivitive object is merged into
			 * the original chainback instance.
			 *
			 * @private
			 * @return {Chainback} A derivitive Chainback object forked from
			 *                     this Chainback instance.
			 */
			_fork: function () {
				var that = this;
				this._procure();
				var Fork = function ChainbackFork() {
					var prop;
					for (prop in that) {
						if (that.hasOwnProperty(prop) && !DONT_MERGE[prop]) {
							this[prop] = that[prop];
						}
					}
					this.__gcnorigin__    = that;
					this.__gcnmutex__     = true;
					this.__gcncallchain__ = [];
					this.__gcncallqueue__ = [];
				};
				Fork.prototype = new this._constructor();
				return new Fork();
			},

			/**
			 * Transfers the state of this derivitive into its origin.
			 *
			 * @private
			 */
			_merge: function () {
				if (!this.__gcnorigin__) {
					return;
				}
				var origin = this.__gcnorigin__;
				var prop;
				for (prop in this) {
					if (this.hasOwnProperty(prop) && !DONT_MERGE[prop]) {
						origin[prop] = this[prop];
					}
				}
				origin._vacate();
				return origin;
			},

			/**
			 * Wraps jQuery's `ajax' method.  Queues the callbacks in the chain
			 * call so that they can be invoked synchonously.  Without blocking
			 * the browser thread.
			 * @TODO: The onError callbacks should always return a value.
			 *        'undefined' should be treated like false.
			 *
			 * @private
			 * @param {object} settings
			 */
			_queueAjax: function (settings) {
				if (settings.json) {
					settings.data = JSON.stringify(settings.json);
					delete settings.json;
				}

				settings.dataType = 'json';
				settings.contentType = 'application/json; charset=utf-8';
				settings.error = (function (onError) {
					return function (xhr, status, error) {
						// Check if the error message and the response headers
						// are empty. This means that the ajax request was aborted.
						// This usually happens when another page is loaded.
						// jQuery doesn't provide a meaningful error message in this case.
						if (!error
								&& typeof xhr === 'object'
								&& !xhr.getAllResponseHeaders()) {
							return;
						}

						var throwException = true;
						if (onError) {
							throwException = onError(GCN.createError('HTTP_ERROR', error, xhr));
						}
						if (throwException !== false) {
							GCN.error('AJAX_ERROR', error, xhr);
						}
					};
				}(settings.error));

				// Duck-type the complete callback, or add one if not provided.
				// We use complete to forward the continuation because it is
				// the last callback to be executed the jQuery ajax callback
				// sequence.
				settings.complete = (function (chainback, onComplete, opts) {
					return function () {
						--chainback.__gcnajaxcount__;
						onComplete.apply(chainback, arguments);
						callNext(chainback);
					};
				}(this, settings.complete || function () {}, settings));

				++this.__gcnajaxcount__;

				GCN.ajax(settings);
			},

			/**
			 * Clears the cache for this individual object.
			 *
			 * @private
			 * @return {Chainback} This Chainback.
			 */
			_clearCache: function () {
				if (chainback.__gcncache__[this.__gcnhash__]) {
					delete chainback.__gcncache__[this.__gcnhash__];
				}
				return this;
			},

			/**
			 * Add this object to the cache, using its hash as the key.
			 *
			 * @private
			 * @return {Chainback} This Chainback.
			 */
			_addToCache: function () {
				this._constructor.__gcncache__[this.__gcnhash__] = this;
				return this;
			},

			/**
			 * Removes the given chainback instance from the temporary cache,
			 * usually after the chainback instance has matured from a "fetus"
			 * into a fully realized chainback object.
			 *
			 * @param {Chainback} instance The chainback instance to remove.
			 * @return {boolean} True if this chainback instance was found and
			 *                   removed, false if it could not be found.
			 */
			_removeFromTempCache: function (instance) {
				var hash;
				var cache = instance._ancestor().__gcntempcache__;
				for (hash in cache) {
					if (cache.hasOwnProperty(hash) && instance === cache[hash]) {
						delete cache[hash];
						return true;
					}
				}
				return false;
			},

			/**
			 * @private
			 * @param {string|number} str
			 * @return {Chainback} This Chainback.
			 */
			_setHash: function (str) {
				var ctor = this._constructor;
				var addAncestorHash = ctor._needsChainedHash && this._chain;
				var channel = getChannel(this);
				var hash = addAncestorHash
				         ? ctor._makeHash(this._chain.__gcnhash__, channel + '/' + str)
				         : ctor._makeHash(channel + '/' + str);
				this.__gcnhash__ = hash;
				return this;
			},

			/**
			 * Invokes the given callback function while ensuring that any
			 * exceptions that occur during the invocation of the callback,
			 * will be caught and allow the Chainback object to complete its
			 * all remaining queued calls.
			 *
			 * @param {function} callback The function to invoke.
			 * @param {Array.<*>=} args A list of object that will be passed as
			 *                          arguments into the callback function.
			 */
			_invoke: function (callback, args) {
				if (typeof callback !== 'function') {
					return;
				}
				try {
					if (args && args.length) {
						callback.apply(null, args);
					} else {
						callback();
					}
				} catch (ex) {
					setTimeout(function () {
						throw ex;
					}, 1);
				}
			}

		});

		/**
		 * Causes the chainback call queue to start running again once a lock
		 * has been released.  This function is defined here because it needs
		 * to be made chainable.
		 *
		 * @private
		 */
		props.__release__ = function () {};

		var propName;
		var propValue;

		// Generates the chainable callback methods.  Transforms all functions
		// whose names do not start with the "!" character into chainable
		// callback prototype methods.
		for (propName in props) {
			if (props.hasOwnProperty(propName)) {
				propValue = props[propName];
				if (jQuery.type(propValue) === 'function' &&
						propName.charAt(0) !== '!') {
					chainback.prototype[propName] =
							makeMethodChainable(propValue, propName);
				} else {
					if (propName.charAt(0) === '!') {
						propName = propName.substring(1, propName.length);
					}
					chainback.prototype[propName] = propValue;
				}
			}
		}

		return chainback;
	};

}(GCN));
(function (GCN) {

	'use strict';

	/**
	 * @type {Array.<function>} A set of functions to be invoked after the next
	 *                          `authenticated' message is broadcasted. Once
	 *                          this event is proceeded, all functions in this
	 *                          array will be invoked in order, and the array
	 *                          will be flushed in preparation for the next
	 *                          `authenticated' event.
	 */
	var afterAuthenticationQueue = [];

	/**
	 * Fetches the details of the user who is logged in to this session.
	 *
	 * @param {function} success Callback to receive the requested user data.
	 * @param {function} error Handler for failures
	 * @throws HTTP_ERROR
	 */
	function fetchUserDetails(success, error) {
		GCN.ajax({
			url: GCN.settings.BACKEND_PATH + '/rest/user/me?sid=' + GCN.sid,
			dataType: 'json',
			contentType: 'application/json; charset=utf-8',

			success: function (response) {
				if (GCN.getResponseCode(response) === 'OK') {
					success(response.user);
				} else {
					GCN.handleResponseError(response, error);
				}
			},

			error: function (xhr, status, msg) {
				GCN.handleHttpError(xhr, msg, error);
			}
		});
	}

	jQuery.extend(GCN, {
		/** @lends GCN */

		/**
		 * @const
		 * @type {boolean} Whether or not Single-SignOn is used for automatic
		 *                 authentication.
		 */
		usingSSO: false,

		isAuthenticating: false,

		/**
		 * @type {number} Stores the user's session id.  It is required for
		 *                making REST-API requests.
		 */
		sid: null,

		/**
		 * Sets the `sid'.  If one has already been set, the it will be
		 * overwritten.
		 *
		 * @param {id} sid The value to set the `sid' to.
		 */
		setSid: function (sid) {
			GCN.sid = sid;
			GCN.pub('session-set', [sid]);
			GCN.pub('session.sid-set', [sid]);
		},

		/**
		 * Log into Content.Node, with the given credentials.
		 *
		 * @param {string} username
		 * @param {string} password
		 * @param {function} success Invoked when login attempt completes
		 *                           regardless of whether or not
		 *                           authentication succeeded.
		 * @param {function} error Called if there an HTTP error occured when
		 *                         performing the ajax request.
		 */
		login: function (username, password, success, error) {
			GCN.isAuthenticating = true;
			GCN.ajax({

				/**
				 * Why we add a ".json" suffix to the login url: In the context
				 * of the GCN environment, the ".json" suffix is appended to
				 * REST-API requests to ensure that the server returns JSON
				 * data rather than XML data, which is what browsers seem to
				 * automatically request.  The usage of the ".json" suffix here
				 * is for an entirely different reason.  We use it as a (fairly
				 * innocent) hack to prevent this request from being processed
				 * by CAS filters that are targeting "rest/auth/login" .  In
				 * most production cases, this would not be necessary, since it
				 * is not common that this login url would be used for both
				 * credential based logins and SSO logins, but having it does
				 * not do anything bad.
				 */
				url: GCN.settings.BACKEND_PATH + '/rest/auth/login.json',
				type: 'POST',
				dataType: 'json',
				contentType: 'application/json; charset=utf-8',
				data: JSON.stringify({
					login: username || '',
					password: password || ''
				}),
				success: function (response, textStatus, jqXHR) {
					GCN.isAuthenticating = false;
					if (GCN.getResponseCode(response) === 'OK') {
						if (GCN.global.isNode) {
							var header = jqXHR.getResponseHeader('Set-Cookie');
							if (!header) {
								GCN.handleError(GCN.createError(
									'AUTHENTICATION_FAILED',
									'Could not find authentication cookie',
									jqXHR
								), error);
								return;
							}
							var secret = header.substr(19, 15);
							GCN.setSid(response.sid + secret);
						} else {
							GCN.setSid(response.sid);
						}

						if (success) {
							success(true, { user: response.user });
						}

						// Because 'authenticated' has been deprecated in favor
						// of 'session.authenticated'
						GCN.pub('authenticated', {user: response.user});
						GCN.pub('session.authenticated', {user: response.user});
					} else {
						var info = response.responseInfo;
						if (success) {
							success(false, {
								error: GCN.createError(info.responseCode,
									info.responseMessage, response)
							});
						}
					}
				},

				error: function (xhr, status, msg) {
					GCN.handleHttpError(xhr, msg, error);
				}

			});
		},

		/**
		 * Triggers the `authentication-required' event.  Provides the handler
		 * a `proceed' and a `cancel' function to branch the continuation of
		 * the program's control flow depending on the success or failure of
		 * the authentication attempt.
		 *
		 * @param {function(GCNError=)} cancelCallback A function to be invoked
		 *                                             if authentication fails.
		 * @throws NO_AUTH_HANDLER Thrown if now handler has been registered
		 *                         `onAuthenticatedRequired' method.
		 */
		authenticate: function (cancelCallback) {
			// Check whether an authentication handler has been set.
			if (!this._hasAuthenticationHandler()) {
				afterAuthenticationQueue = [];

				var error = GCN.createError('NO_AUTH_HANDLER', 'Could not ' +
					'authenticate because no authentication handler has been' +
					' registered.');

				if (cancelCallback) {
					cancelCallback(error);
				} else {
					GCN.error(error.code, error.message, error.data);
				}

				return;
			}

			GCN.isAuthenticating = true;

			var proceed = GCN.onAuthenticated;
			var cancel = function (error) {
				afterAuthenticationQueue = [];
				cancelCallback(error);
			};

			// Because 'authentication-required' has been deprecated in favor of
			// 'session.authentication-required'
			GCN.pub('authentication-required', [proceed, cancel]);
			GCN.pub('session.authentication-required', [proceed, cancel]);
		},

		afterNextAuthentication: function (callback) {
			if (callback) {
				afterAuthenticationQueue.push(callback);
			}
		},

		/**
		 * This is the method that is passed as `proceed()' to the handler
		 * registered through `onAuthenticationRequired()'.  It ensures that
		 * all functions that are pending authentication will be executed in
		 * FIFO order.
		 */
		onAuthenticated: function () {
			GCN.isAuthenticating = false;

			var i;
			var j = afterAuthenticationQueue.length;

			for (i = 0; i < j; ++i) {
				afterAuthenticationQueue[i]();
			}

			afterAuthenticationQueue = [];
		},

		/**
		 * Destroys the saved session data.
		 * At the moment this only involves clearing the stored SID.
		 */
		clearSession: function () {
			GCN.setSid(null);
		},

		/**
		 * Attemps to authenticate using Single-Sign-On.
		 *
		 * @param {function} success
		 * @param {function} error
		 * @throws HTTP_ERROR
		 */
		loginWithSSO: function (success, error) {
			GCN.isAuthenticating = true;

			// The following must happen after the dom is ready, and not before.
			jQuery(function () {
				var iframe = jQuery('<iframe id="gcn-sso-frame">').hide();

				jQuery('body').append(iframe);

				iframe.load(function () {
					GCN.isAuthenticating = false;

					var response = iframe.contents().text();

					switch (response) {
					case '':
					case 'FAILURE':
						var err = GCN.createError('HTTP_ERROR',
							'Error encountered while making HTTP request');

						GCN.handleError(err, error);
						break;
					case 'NOTFOUND':
						success(false);
						break;
					default:
						GCN.setSid(response);

						fetchUserDetails(function (user) {
							if (success) {
								success(true, {user: user});
							}

							// Because 'authenticated' has been deprecated in
							// favor of 'session.authenticated'
							GCN.pub('authenticated', {user: user});
							GCN.pub('session.authenticated', {user: user});
						});
					}

					iframe.remove();
				});

				iframe.attr('src', GCN.settings.BACKEND_PATH +
					'/rest/auth/ssologin?ts=' + (new Date()).getTime());
			});
		},

		/**
		 * Do a logout and clear the session id.
		 *
		 * @param {function} success
		 * @param {function} error A callback that will be invoked if an ajax
		 *                         error occurs while trying to accomplish the
		 *                         logout request.
		 */
		logout: function (success, error) {
			// If no `sid' exists, the logout fails.
			if (!GCN.sid) {
				success(false, GCN.createError('NO_SESSION',
					'There is no session to log out of.'));

				return;
			}

			GCN.ajax({
				url: GCN.settings.BACKEND_PATH + '/rest/auth/logout/' +
				     GCN.sid,
				type: 'POST',
				dataType: 'json',
				contentType: 'application/json; charset=utf-8',

				success: function (response) {
					if (GCN.getResponseCode(response) === 'OK') {
						GCN.clearSession();
						success(true);
					} else {
						var info = response.responseInfo;
						success(false, GCN.createError(info.responseCode,
							info.responseMessage, response));
					}
				},

				error: function (xhr, status, msg) {
					GCN.handleHttpError(xhr, msg, error);
				}
			});
		},

		/**
		 * Given a GCN ajax response object, return the response code.
		 *
		 * @param {object} response GCN response object return in the ajax
		 *                          request callback.
		 */
		getResponseCode: function (response) {
			return (response && response.responseInfo &&
				response.responseInfo.responseCode);
		}

	});

}(GCN));
(function (GCN) {

	'use strict';

	/**
	 * Updates the internal data of the given content object.
	 *
	 * This function extends and overwrites properties of the instances's
	 * internal data structure.  No property is deleted on account of being
	 * absent from the given `props' object.
	 *
	 * @param {ContentObjectAPI} obj An instance whose internal data is to be
	 *                               reset.
	 * @param {object} props The properties with which to replace the internal
	 *                       data of the given chainback instance.
	 */
	function update(obj, props) {
		jQuery.extend(obj._data, props);
	}

	/**
	 * The prefix that will be temporarily applied to block tags during an
	 * encode() process.
	 *
	 * @type {string}
	 * @const
	 */
	var BLOCK_ENCODING_PREFIX = 'GCN_BLOCK_TMP__';

	/**
	 * Will match <span id="GENTICS_block_123"></span>" but not "<node abc123>"
	 * tags.  The first backreference contains the tagname of the tag
	 * corresponding to this block.
	 *
	 * Limitation: Will not work with unicode characters.
	 *
	 * @type {RexExp}
	 * @const
	 */
    var CONTENT_BLOCK = new RegExp(
			// "<span" or "<div" but not "<node"
			'<(?!node)[a-z]+'            +
				// "class=... data-*..."
				'(?:\\s+[^/<>\\s=]+(?:=(?:"[^"]*"|\'[^\']*\'|[^>/\\s]+))?)*?' +
				// " id = "
				'\\s+id\\s*=\\s*["\']?'  +
				// "GCN_BLOCK_TMP__"
				BLOCK_ENCODING_PREFIX    +
				// "_abc-123"
				'([^"\'/<>\\s=]*)["\']?' +
				// class=... data-*...
				'(?:\\s+[^/<>\\s=]+(?:=(?:"[^"]*"|\'[^\']*\'|[^>/\\s]+))?)*' +
				// "' ...></span>" or "</div>"
				'\\s*></[a-z]+>',
			'gi'
		);

	/**
	 * Will match <node foo> or <node bar_123> or <node foo-bar> but not
	 * <node "blah">.
	 *
	 * @type {RegExp}
	 * @const
	 */
	var NODE_NOTATION = /<node ([a-z0-9_\-]+?)>/gim;

	/**
	 * Examines a string for "<node>" tags, and for each occurance of this
	 * notation, the given callback will be invoked to manipulate the string.
	 *
	 * @private
	 * @static
	 * @param {string} str The string that will be examined for "<node>" tags.
	 * @param {function} onMatchFound Callback function that should receive the
	 *                                following three parameters:
	 *
	 *                    name:string The name of the tag being notated by the
	 *                                node substring.  If the `str' arguments
	 *                                is "<node myTag>", then the `name' value
	 *                                will be "myTag".
	 *                  offset:number The offset where the node substring was
	 *                                found within the examined string.
	 *                     str:string The string in which the "<node *>"
	 *                                substring occured.
	 *
	 *                                The return value of the function will
	 *                                replace the entire "<node>" substring
	 *                                that was passed to it within the examined
	 *                                string.
	 */
	function replaceNodeTags(str, onMatchFound) {
		var parsed = str.replace(NODE_NOTATION, function (substr, tagname,
		                                                  offset, examined) {
				return onMatchFound(tagname, offset, examined);
			});
		return parsed;
	}

	/*
	 * have a look at _init 
	 */
	GCN.ContentObjectAPI = GCN.defineChainback({
		/** @lends ContentObjectAPI */

		/**
		 * @private
		 * @type {string} A string denoting a content node type.  This value is
		 *                used to compose the correct REST API ajax urls.  The
		 *                following are valid values: "node", "folder",
		 *                "template", "page", "file", "image".
		 */
		_type: null,

		/**
		 * @private
		 * @type {object<string,*>} An internal object to store data that we
		 *                          get from the server.
		 */
		_data: {},

		/**
		 * @private
		 * @type {object<string,*>} An internal object to store updates to
		 *                          the content object.  Should reflect the
		 *                          structural typography of the `_data'
		 *                          object.
		 */
		_shadow: {},

		/**
		 * @type {boolean} Flags whether or not data for this content object have
		 *                 been fetched from the server.
		 */
		_fetched: false,

		/**
		 * @private
		 * @type {object} will contain an objects internal settings
		 */
		_settings: null,

		/**
		 * An array of all properties of an object that can be changed by the
		 * user. Writeable properties for all content objects.
		 * 
		 * @public
		 * @type {Array.string}
		 */
		WRITEABLE_PROPS: [],

		/**
		 * <p>This object can contain various contrains for writeable props. 
		 * Those contrains will be checked when the user tries to set/save a
		 * property. Currently only maxLength is beeing handled.</p>
		 *
		 * <p>Example:</p>
		 * <pre>WRITEABLE_PROPS_CONSTRAINTS: {
		 *    'name': {
		 *        maxLength: 255
		 *     } 
		 * }</pre>
		 * @type {object}
		 * @const
		 *
		 */
		WRITEABLE_PROPS_CONSTRAINTS: {},

		/**
		 * Fetches this content object's data from the backend.
		 *
		 * @ignore
		 * @param {function(object)} success A function to receive the server
		 *                                   response.
		 * @param {function(GCNError):boolean} error Optional custrom error
		 *                                           handler.
		 */
		'!fetch': function (success, error, stack) {
			var obj = this;
			var ajax = function () {
				obj._authAjax({
					url: GCN.settings.BACKEND_PATH + '/rest/' + obj._type +
					     '/load/' + obj.id() + GCN._getChannelParameter(obj),
					data: obj._loadParams(),
					error: error,
					success: success
				});
			};

			// If this chainback object has an ancestor, then invoke that
			// parent's `_read()' method before fetching the data for this
			// chainback object.
			if (obj._chain) {
				var circularReference =
						stack && -1 < jQuery.inArray(obj._chain, stack);
				if (!circularReference) {
					stack = stack || [];
					stack.push(obj._chain);
					obj._chain._read(ajax, error, stack);
					return;
				}
			}

			ajax();
		},

		/**
		 * Internal method, to fetch this object's data from the server.
		 *
		 * @ignore
		 * @private
		 * @param {function(ContentObjectAPI)=} success Optional callback that
		 *                                              receives this object as
		 *                                              its only argument.
		 * @param {function(GCNError):boolean=} error Optional customer error
		 *                                            handler.
		 */
		'!_read': function (success, error, stack) {
			var obj = this;
			if (obj._fetched) {
				if (success) {
					obj._invoke(success, [obj]);
				}
				return;
			}

			if (obj.multichannelling) {
				obj.multichannelling.read(obj, success, error);
				return;
			}

			var id = obj.id();

			if (null === id || undefined === id) {
				obj._getIdFromParent(function () {
					obj._read(success, error, stack);
				}, error, stack);
				return;
			}

			obj.fetch(function (response) {
				obj._processResponse(response);
				obj._fetched = true;
				if (success) {
					obj._invoke(success, [obj]);
				}
			}, error, stack);
		},

		/**
		 * Retrieves this object's id from its parent.  This function is used
		 * in order for this object to be able to fetch its data from the
		 * backend.
		 *
		 * FIXME: If the id that `obj` aquires results in it having a hash that
		 * is found in the cache, then `obj` should not replace the object that
		 * was in the cache, rather, `obj` should be masked by the object in the
		 * cache.  This scenario will arise in the following scenario:
		 *
		 * page.node().constructs();
		 * page.node().folders();
		 *
		 * The above will cause the same node to be fetched from the server
		 * twice, each time, clobbering the previosly loaded data in the cache.
		 *
		 * @ignore
		 * @private
		 * @param {function(ContentObjectAPI)=} success Optional callback that
		 *                                              receives this object as
		 *                                              its only argument.
		 * @param {function(GCNError):boolean=} error Optional customer error
		 *                                            handler.
		 * @throws CANNOT_GET_OBJECT_ID
		 */
		'!_getIdFromParent': function (success, error, stack) {
			var parent = this._ancestor();

			if (!parent) {
				var err = GCN.createError('CANNOT_GET_OBJECT_ID',
					'Cannot get an id for object', this);
				GCN.handleError(err, error);
				return;
			}

			var that = this;

			parent._read(function () {
				if ('folder' === that._type) {
					// There are 3 possible property names that an object can
					// use to hold the id of the folder that it is related to:
					//
					// "folderId": for pages, templates, files, and images.
					// "motherId": for folders
					// "nodeId":   for nodes
					//
					// We need to see which of this properties is set, the
					// first one we find will be our folder's id.
					var props = ['folderId', 'motherId', 'nodeId'];
					var prop = props.pop();
					var id;

					while (prop) {
						id = parent.prop(prop);
						if (typeof id !== 'undefined') {
							break;
						}
						prop = props.pop();
					}

					that._data.id = id;
				} else {
					that._data.id = parent.prop(that._type + 'Id');
				}

				if (that._data.id === null || typeof that._data.id === 'undefined') {
					var err = GCN.createError('CANNOT_GET_OBJECT_ID',
						'Cannot get an id for object', this);
					GCN.handleError(err, error);
					return;
				}

				that._setHash(that._data.id)._addToCache();

				if (success) {
					success();
				}
			}, error, stack);
		},

		/**
		 * Gets this object's node id. If used in a multichannelling is enabled
		 * it will return the channel id or 0 if no channel was set.
		 * 
		 * @public
		 * @function
		 * @name nodeId
		 * @memberOf ContentObjectAPI
		 * @return {number} The channel to which this object is set. 0 if no
		 *         channel is set.
		 */
		'!nodeId': function () {
			return this._channel || 0;
		},

		/**
		 * Gets this object's id. We'll return the id of the object when it has
		 * been loaded - this can only be a localid. Otherwise we'll return the
		 * id which was provided by the user. This can either be a localid or a
		 * globalid.
		 *
		 * @name id
		 * @function
		 * @memberOf ContentObjectAPI
		 * @public
		 * @return {number}
		 */
		'!id': function () {
			return this._data.id;
		},

		/**
		 * Alias for {@link ContentObjectAPI#id}
		 *
		 * @name localId
		 * @function
		 * @memberOf ContentObjectAPI
		 * @private
		 * @return {number}
		 * @decprecated
		 */
		'!localId': function () {
			return this.id();
		},

		/**
		 * Update the `_shadow' object that maintains changes to properties
		 * that reflected the internal `_data' object.  This shadow object is
		 * used to persist differential changes to a REST API object.
		 *
		 * @ignore
		 * @private
		 * @param {string} path The path through the object to the property we
		 *                      want to modify if a node in the path contains
		 *                      dots, then these dots should be escaped.  This
		 *                      can be done using the GCN.escapePropertyName()
		 *                      convenience function.
		 * @param {*} value The value we wish to set the property to.
		 * @param {function=} error Custom error handler.
		 * @param {boolean=} force If true, no error will be thrown if `path'
		 *                         cannot be fully resolved against the
		 *                         internal `_data' object, instead, the path
		 *                         will be created on the shadow object.
		 */
		'!_update': function (pathStr, value, error, force) {
			var boundary = Math.random().toString(8).substring(2);
			var path = pathStr.replace(/\./g, boundary)
			                  .replace(new RegExp('\\\\' + boundary, 'g'), '.')
			                  .split(boundary);
			var shadow = this._shadow;
			var actual = this._data;
			var i = 0;
			var numPathNodes = path.length;
			var pathNode;
			// Whether or not the traversal path in `_data' and `_shadow' are
			// at the same position in the respective objects.
			var areMirrored = true;

			while (true) {
				pathNode = path[i++];

				if (areMirrored) {
					actual = actual[pathNode];
					areMirrored = jQuery.type(actual) !== 'undefined';
				}

				if (i === numPathNodes) {
					break;
				}

				if (shadow[pathNode]) {
					shadow = shadow[pathNode];
				} else if (areMirrored || force) {
					shadow = (shadow[pathNode] = {});
				} else {
					break; // goto error
				}
			}

			if (i === numPathNodes && (areMirrored || force)) {
				shadow[pathNode] = value;
			} else {
				var err = GCN.createError('TYPE_ERROR', 'Object "' +
					path.slice(0, i).join('.') + '" does not exist',
					actual);
				GCN.handleError(err, error);
			}
		},

		/**
		 * Receives the response from a REST API request, and stores it in the
		 * internal `_data' object.
		 *
		 * @private
		 * @param {object} data Parsed JSON response data.
		 */
		'!_processResponse': function (data) {
			jQuery.extend(this._data, data[this._type]);
		},

		/**
		 * Specifies a list of parameters that will be added to the url when
		 * loading the content object from the server.
		 *
		 * @private
		 * @return {object} object With parameters to be appended to the load
		 *                         request
		 */
		'!_loadParams': function () {},

		/**
		 * Reads the property `property' of this content object if this
		 * property is among those in the WRITEABLE_PROPS array. If a second
		 * argument is provided, them the property is updated with that value.
		 *
		 * @name prop
		 * @function
		 * @memberOf ContentObjectAPI
		 * @param {String} property Name of the property to be read or updated.
		 * @param {String} value Optional value to set property to. If omitted the property will just be read.
		 * @param {function(GCNError):boolean=} error Custom error handler to 
		 *                                      stop error propagation for this
		 *                                      synchronous call. 
		 * @return {?*} Meta attribute.
		 * @throws UNFETCHED_OBJECT_ACCESS if the object has not been fetched from the server yet
		 * @throws READONLY_ATTRIBUTE whenever trying to write to an attribute that's readonly
		 */
		'!prop': function (property, value, error) {
			if (!this._fetched) {
				GCN.handleError(GCN.createError(
					'UNFETCHED_OBJECT_ACCESS',
					'Object not fetched yet.'
				), error);
				return;
			}

			if (typeof value !== 'undefined') {
				// Check whether the property is writable
				if (jQuery.inArray(property, this.WRITEABLE_PROPS) >= 0) {
					// Check wether the property has a constraint and verify it
					var constraint = this.WRITEABLE_PROPS_CONSTRAINTS[property];
					if (constraint) {
						// verify maxLength
						if (constraint.maxLength && value.length >= constraint.maxLength) {
							var data = { name: property, value: value, maxLength: constraint.maxLength };
							var constraintError = GCN.createError('ATTRIBUTE_CONSTRAINT_VIOLATION',
								'Attribute "' + property + '" of ' + this._type +
								' is too long. The \'maxLength\' was set to {' + constraint.maxLength + '} ', data);
							GCN.handleError(constraintError, error);
							return;
						}
					}
					this._update(GCN.escapePropertyName(property), value);
				} else {
					GCN.handleError(GCN.createError('READONLY_ATTRIBUTE',
						'Attribute "' + property + '" of ' + this._type +
						' is read-only. Writeable properties are: ' +
						this.WRITEABLE_PROPS, this.WRITEABLE_PROPS), error);
					return;
				}
			}

			return (
				(jQuery.type(this._shadow[property]) !== 'undefined'
					? this._shadow
					: this._data)[property]
			);
		},

		/**
		 * Sends the a template string to the Aloha Servlet for rendering.
		 *
		 * @ignore
		 * @TODO: Consider making this function public.  At least one developer
		 *        has had need to render a custom template for a content
		 *        object.
		 *
		 * @private
		 * @param {string} template Template which will be rendered.
		 * @param {string} mode The rendering mode.  Valid values are "view",
		 *                      "edit", "pub."
		 * @param {function(object)} success A callback the receives the render
		 *                                   response.
		 * @param {function(GCNError):boolean} error Error handler.
		 */
		'!_renderTemplate' : function (template, mode, success, error) {
			var channelParam = GCN._getChannelParameter(this);
			var url = GCN.settings.BACKEND_PATH
			        + '/rest/' + this._type
			        + '/render/' + this.id()
			        + channelParam
			        + (channelParam ? '&' : '?')
			        + 'edit=' + ('edit' === mode)
			        + '&template=' + encodeURIComponent(template);
			this._authAjax({
				url: url,
				error: error,
				success: success
			});
		},

		/**
		 * Wrapper for internal chainback _ajax method.
		 * 
		 * @ignore
		 * @private
		 * @param {object<string, *>} settings Settings for the ajax request.
		 *                                     The settings object is identical
		 *                                     to that of the `GCN.ajax'
		 *                                     method, which handles the actual
		 *                                     ajax transportation.
		 * @throws AJAX_ERROR
		 */
		'!_ajax': function (settings) {
			var that = this;

			// force no cache for all API calls
			settings.cache = false;
			settings.success = (function (onSuccess, onError) {
				return function (data) {
					// Ajax calls that do not target the REST API servlet do
					// not response data with a `responseInfo' object.
					// "/CNPortletapp/alohatag" is an example.  So we cannot
					// just assume that it exists.
					if (data.responseInfo) {
						switch (data.responseInfo.responseCode) {
						case 'OK':
							break;
						case 'AUTHREQUIRED':
							GCN.clearSession();
							that._authAjax(settings);
							return;
						default:
							GCN.handleResponseError(data, onError);
							return;
						}
					}

					if (onSuccess) {
						onSuccess(data);
					}
				};
			}(settings.success, settings.error, settings.url));

			this._queueAjax(settings);
		},

		/**
		 * Concrete implementatation of _fulfill().
		 *
		 * Resolves all promises made by this content object while ensuring
		 * that circularReferences, (which are completely possible, and valid)
		 * do not result in infinit recursion.
		 *
		 * @override
		 */
		'!_fulfill': function (success, error, stack) {
			var obj = this;
			if (obj._chain) {
				var circularReference =
						stack && -1 < jQuery.inArray(obj._chain, stack);
				if (!circularReference) {
					stack = stack || [];
					stack.push(obj._chain);
					obj._fulfill(function () {
						obj._read(success, error);
					}, error, stack);
					return;
				}
			}
			obj._read(success, error);
		},

		/**
		 * Similar to `_ajax', except that it prefixes the ajax url with the
		 * current session's `sid', and will trigger an
		 * `authentication-required' event if the session is not authenticated.
		 *
		 * @ignore
		 * @TODO(petro): Consider simplifiying this function signature to read:
		 *               `_auth( url, success, error )'
		 *
		 * @private
		 * @param {object<string, *>} settings Settings for the ajax request.
		 * @throws AUTHENTICATION_FAILED
		 */
		_authAjax: function (settings) {
			var that = this;

			if (GCN.isAuthenticating) {
				GCN.afterNextAuthentication(function () {
					that._authAjax(settings);
				});
				return;
			}

			if (!GCN.sid) {
				var cancel;

				if (settings.error) {
					/**
					 * @ignore
					 */
					cancel = function (error) {
						GCN.handleError(
							error || GCN.createError('AUTHENTICATION_FAILED'),
							settings.error
						);
					};
				} else {
					/**
					 * @ignore
					 */
					cancel = function (error) {
						if (error) {
							GCN.error(error.code, error.message, error.data);
						} else {
							GCN.error('AUTHENTICATION_FAILED');
						}
					};
				}

				GCN.afterNextAuthentication(function () {
					that._authAjax(settings);
				});

				if (GCN.usingSSO) {
					// First, try to automatically authenticate via
					// Single-SignOn
					GCN.loginWithSSO(GCN.onAuthenticated, function () {
						// ... if SSO fails, then fallback to requesting user
						// credentials: broadcast `authentication-required'
						// message.
						GCN.authenticate(cancel);
					});
				} else {
					// Trigger the `authentication-required' event to request
					// user credentials.
					GCN.authenticate(cancel);
				}

				return;
			}

			// Append "?sid=..." or "&sid=..." if needed.

			var urlFragment = settings.url.substr(
				GCN.settings.BACKEND_PATH.length
			);
			var isSidInUrl = /[\?\&]sid=/.test(urlFragment);
			if (!isSidInUrl) {
				var isFirstParam = (jQuery.inArray('?',
					urlFragment.split('')) === -1);
				settings.url += (isFirstParam ? '?' : '&') + 'sid='
				             +  (GCN.sid || '');
			}

			this._ajax(settings);
		},

		/**
		 * Recursively call `_continueWith()'.
		 *
		 * @ignore
		 * @private
		 * @override
		 */
		'!_onContinue': function (success, error) {
			var that = this;
			this._continueWith(function () {
				that._read(success, error);
			}, error);
		},

		/**
		 * Initializes this content object.  If a `success' callback is
		 * provided, it will cause this object's data to be fetched and passed
		 * to the callback.  This object's data will be fetched from the cache
		 * if is available, otherwise it will be fetched from the server.  If
		 * this content object API contains parent chainbacks, it will get its
		 * parent to fetch its own data first.
		 *
		 * <p>
		 * Basic content object implementation which all other content objects
		 * will inherit from.
		 * </p>
		 * 
		 * <p>
		 * If a `success' callback is provided,
		 * it will cause this object's data to be fetched and passed to the
		 * callback. This object's data will be fetched from the cache if is
		 * available, otherwise it will be fetched from the server. If this
		 * content object API contains parent chainbacks, it will get its parent
		 * to fetch its own data first.
		 * </p>
		 * 
		 * <p>
		 * You might also provide an object for initialization, to directly
		 * instantiate the object's data without loading it from the server. To
		 * do so just pass in a data object as received from the server instead
		 * of an id--just make sure this object has an `id' property.
		 * </p>
		 * 
		 * <p>
		 * If an `error' handler is provided, as the third parameter, it will
		 * catch any errors that have occured since the invocation of this call.
		 * It allows the global error handler to be intercepted before stopping
		 * the error or allowing it to propagate on to the global handler.
		 * </p>
		 * 
		 * @class
		 * @name ContentObjectAPI
		 * @param {number|string|object}
		 *            id
		 * @param {function(ContentObjectAPI))=}
		 *            success Optional success callback that will receive this
		 *            object as its only argument.
		 * @param {function(GCNError):boolean=}
		 *            error Optional custom error handler.
		 * @param {object}
		 *            settings Basic settings for this object - depends on the
		 *            ContentObjetAPI Object used.
		 * @throws INVALID_DATA
		 *             If no id is found when providing an object for
		 *             initialization.
		 */
		_init: function (data, success, error, settings) {
			this._settings = settings;
			var id;

			if (jQuery.type(data) === 'object') {
				if (data.multichannelling) {
					this.multichannelling = data;
					// Remove the inherited object from the chain.
					if (this._chain) {
						this._chain = this._chain._chain;
					}
					id = this.multichannelling.derivedFrom.id();
				} else {
					if (!data.id) {
						var err = GCN.createError(
							'INVALID_DATA',
							'Data not sufficient for initalization: id is missing',
							data
						);
						GCN.handleError(err, error);
						return;
					}
					this._data = data;
					this._fetched = true;
					if (success) {
						this._invoke(success, [this]);
					}
					return;
				}
			} else {
				id = data;
			}

			// Ensure that each object has its very own `_data' and `_shadow'
			// objects.
			if (!this._fetched) {
				this._data = {};
				this._shadow = {};
				this._data.id = id;
			}
			if (success) {
				this._read(success, error);
			}
		},

		/**
		 * <p>Replaces tag blocks with appropriate "&lt;node *&gt;" notation in a given
		 * string. Given an element whose innerHTML is:<p>
		 * <pre>
		 *		&lt;span id="GENTICS_BLOCK_123"&gt;My Tag&lt;/span&gt;
		 * </pre>
		 * <p>encode() will return:</p>
		 * <pre>
		 *		&lt;node 123&gt;
		 * </pre>
		 *
		 * @name encode
		 * @function
		 * @memberOf ContentObjectAPI
		 * @param {!jQuery} $element
		 *       An element whose contents are to be encoded.
		 * @param {?function(!Element): string} serializeFn
		 *       A function that returns the serialized contents of the
		 *       given element as a HTML string, excluding the start and end
		 *       tag of the element. If not provided, jQuery.html() will
		 *       be used.
		 * @return {string} The encoded HTML string.
		 */
		'!encode': function ($element, serializeFn) {
			var $clone = $element.clone();
			var id;
			var $block;
			for (id in this._blocks) {
				if (this._blocks.hasOwnProperty(id)) {
					$block = $clone.find('#' + this._blocks[id].element);
					if ($block.length) {
						// Empty all content blocks of their innerHTML.
						$block.html('').attr('id', BLOCK_ENCODING_PREFIX +
							this._blocks[id].tagname);
					}
				}
			}
			serializeFn = serializeFn || function ($element) {
				return jQuery($element).html();
			};
			var html = serializeFn($clone[0]);
			return html.replace(CONTENT_BLOCK, function (substr, match) {
				return '<node ' + match + '>';
			});
		},

		/**
		 * For a given string, replace all occurances of "&lt;node&gt;" with
		 * appropriate HTML markup, allowing notated tags to be rendered within
		 * the surrounding HTML content.
		 *
		 * The success() handler will receives a string containing the contents
		 * of the `str' string with references to "<node>" having been inflated
		 * into their appropriate tag rendering.
		 *
		 * @name decode
		 * @function
		 * @memberOf ContentObjectAPI
		 * @param {string} str The content string, in which  "<node *>" tags
		 *                     will be inflated with their HTML rendering.
		 * @param {function(ContentObjectAPI))} success Success callback that
		 *                                              will receive the
		 *                                              decoded string.
		 * @param {function(GCNError):boolean=} error Optional custom error
		 *                                            handler.
		 */
		'!decode': function (str, success, error) {
			if (!success) {
				return;
			}

			var prefix = 'gcn-tag-placeholder-';
			var toRender = [];
			var html = replaceNodeTags(str, function (name, offset, str) {
				toRender.push('<node ', name, '>');
				return '<div id="' + prefix + name + '"></div>';
			});

			if (!toRender.length) {
				success(html);
				return;
			}

			// Instead of rendering each tag individually, we render them
			// together in one string, and map the results back into our
			// original html string.  This allows us to perform one request to
			// the server for any number of node tags found.

			var parsed = jQuery('<div>' + html + '</div>');
			var template = toRender.join('');
			var that = this;

			this._renderTemplate(template, 'edit', function (data) {
				var content = data.content;
				var tag;
				var tags = data.tags;
				var j = tags.length;
				var rendered = jQuery('<div>' + content + '</div>');

				var replaceTag = (function (numTags) {
					return function (tag) {
						parsed.find('#' + prefix + tag.prop('name'))
							.replaceWith(
								rendered.find('#' + tag.prop('id'))
							);

						if (0 === --numTags) {
							success(parsed.html());
						}
					};
				}(j));

				while (j) {
					that.tag(tags[--j], replaceTag);
				}
			}, error);
		},

		/**
		 * Clears this object from its constructor's cache so that the next
		 * attempt to access this object will result in a brand new instance
		 * being initialized and placed in the cache.
		 *
		 * @name clear
		 * @function
		 * @memberOf ContentObjectAPI
		 */
		'!clear': function () {
			// Do not clear the id from the _data.
			var id = this._data.id;
			this._data = {};
			this._data.id = id;
			this._shadow = {};
			this._fetched = false;
			this._clearCache();
		},

		/**
		 * Retrieves this objects parent folder.
		 * 
		 * @name folder
		 * @function
		 * @memberOf ContentObjectAPI
		 * @param {function(FolderAPI)=}
		 *            success Callback that will receive the requested object.
		 * @param {function(GCNError):boolean=}
		 *            error Custom error handler.
		 * @return {FolderAPI} API object for the retrieved GCN folder.
		 */
		'!folder': function (success, error) {
			return this._continue(GCN.FolderAPI, this._data.folderId, success,
				error);
		},

		/**
		 * Saves changes made to this content object to the backend.
		 * 
		 * @param {object=}
		 *            settings Optional settings to pass on to the ajax
		 *            function.
		 * @param {function(ContentObjectAPI)=}
		 *            success Optional callback that receives this object as its
		 *            only argument.
		 * @param {function(GCNError):boolean=}
		 *            error Optional customer error handler.
		 */
		save: function () {
			var settings;
			var success;
			var error;
			var args = Array.prototype.slice.call(arguments);
			var len = args.length;
			var i;

			for (i = 0; i < len; ++i) {
				switch (jQuery.type(args[i])) {
				case 'object':
					if (!settings) {
						settings = args[i];
					}
					break;
				case 'function':
					if (!success) {
						success = args[i];
					} else {
						error = args[i];
					}
					break;
				case 'undefined':
					break;
				default:
					var err = GCN.createError('UNKNOWN_ARGUMENT',
						'Don\'t know what to do with arguments[' + i + '] ' +
						'value: "' + args[i] + '"', args);
					GCN.handleError(err, error);
					return;
				}
			}

			this._save(settings, success, error);
		},

		/**
		 * Persists this object's local data onto the server.  If the object
		 * has not yet been fetched we need to get it first so we can update
		 * its internals properly...
		 *
		 * @private
		 * @param {object} settings Object which will extend the basic
		 *                          settings of the ajax call
		 * @param {function(ContentObjectAPI)=} success Optional callback that
		 *                                              receives this object as
		 *                                              its only argument.
		 * @param {function(GCNError):boolean=} error Optional customer error
		 *                                            handler.
		 */
		'!_save': function (settings, success, error) {
			var obj = this;
			this._fulfill(function () {
				GCN.pub(obj._type + '.before-save');
				obj._persist(settings, success, error);
			}, error);
		},

		/**
		 * Returns the bare data structure of this content object.
		 * To be used for creating the save POST body data.
		 *
		 * @param {object<string, *>} Plain old object representation of this
		 *                            content object.
		 */
		'!json': function () {
			var json = {};

			if (this._deletedTags.length) {
				json['delete'] = this._deletedTags;
			}

			if (this._deletedBlocks.length) {
				json['delete'] = json['delete']
				               ? json['delete'].concat(this._deletedBlocks)
				               : this._deletedBlocks;
			}

			json[this._type] = this._shadow;
			json[this._type].id = this._data.id;
			return json;
		},

		/**
		 * Sends the current state of this content object to be stored on the
		 * server.
		 *
		 * @private
		 * @param {function(ContentObjectAPI)=} success Optional callback that
		 *                                              receives this object as
		 *                                              its only argument.
		 * @param {function(GCNError):boolean=} error Optional customer error
		 *                                            handler.
		 * @throws HTTP_ERROR
		 */
		'!_persist': function (settings, success, error) {
			var that = this;

			if (!this._fetched) {
				this._read(function () {
					that._persist(settings, success, error);
				}, error);
				return;
			}

			var json = this.json();
			jQuery.extend(json, settings);
			var tags = json[this._type].tags;
			var tagname;
			for (tagname in tags) {
				if (tags.hasOwnProperty(tagname)) {
					tags[tagname].active = true;
				}
			}

			this._authAjax({
				url   : GCN.settings.BACKEND_PATH + '/rest/'
				        + this._type + '/save/' + this.id()
				        + GCN._getChannelParameter(this),
				type  : 'POST',
				error : error,
				json  : json,
				success : function (response) {
					// We must not overwrite the `_data.tags' object with this
					// one.
					delete that._shadow.tags;

					// Everything else in `_shadow' should be written over to
					// `_data' before resetting the `_shadow' object.
					jQuery.extend(that._data, that._shadow);
					that._shadow = {};
					that._deletedTags = [];
					that._deletedBlocks = [];

					if (success) {
						that._invoke(success, [that]);
					}
				}
			});
		},

		/**
		 * Deletes this content object from its containing parent.
		 * 
		 * @param {function(ContentObjectAPI)=}
		 *            success Optional callback that receives this object as its
		 *            only argument.
		 * @param {function(GCNError):boolean=}
		 *            error Optional customer error handler.
		 */
		remove: function (success, error) {
			this._remove(success, error);
		},

		/**
		 * Get a channel-local copy of this content object.
		 *
		 * @public
		 * @function
		 * @name localize
		 * @memberOf ContentObjectAPI
		 * @param {funtion(ContentObjectAPI)=} success Optional callback to
		 *                                             receive this content
		 *                                             object as the only
		 *                                             argument.
		 * @param {function(GCNError):boolean=} error Optional custom error
		 *                                            handler.
		 */
		'!localize': function (success, error) {
			if (!this._channel && !GCN.channel()) {
				var err = GCN.createError(
					'NO_CHANNEL_ID_SET',
					'No channel is set in which to get the localized object',
					GCN
				);
				GCN.handleError(err, error);
				return false;
			}
			var local = this._continue(
				this._constructor,
				{
					derivedFrom: this,
					multichannelling: true,
					read: GCN.multichannelling.localize
				},
				success,
				error
			);
			return local;
		},

		/**
		 * Remove this channel-local object, and delete its local copy in the
		 * backend.
		 *
		 * @public
		 * @function
		 * @name unlocalize
		 * @memberOf ContentObjectAPI
		 * @param {funtion(ContentObjectAPI)=} success Optional callback to
		 *                                             receive this content
		 *                                             object as the only
		 *                                             argument.
		 * @param {function(GCNError):boolean=} error Optional custom error
		 *                                            handler.
		 */
		'!unlocalize': function (success, error) {
			if (!this._channel && !GCN.channel()) {
				var err = GCN.createError(
					'NO_CHANNEL_ID_SET',
					'No channel is set in which to get the unlocalized object',
					GCN
				);
				GCN.handleError(err, error);
				return false;
			}
			var placeholder = {
				multichannelling: {
					derivedFrom: this
				}
			};
			var that = this;
			GCN.multichannelling.unlocalize(placeholder, function () {
				// TODO: This should be done inside of
				// multichannelling.unlocalize() and not in this callback.
				// Clean cache & reset object to make sure it can't be used
				// properly any more.
				that._clearCache();
				that._data = {};
				that._shadow = {};
				if (success) {
					success();
				}
			}, error);
		},

		/**
		 * Performs a REST API request to delete this object from the server.
		 *
		 * @private
		 * @param {function()=} success Optional callback that
		 *                                              will be invoked once
		 *                                              this object has been
		 *                                              removed.
		 * @param {function(GCNError):boolean=} error Optional customer error
		 *                                            handler.
		 */
		'!_remove': function (success, error) {
			var that = this;
			this._authAjax({
				url     : GCN.settings.BACKEND_PATH + '/rest/'
				          + this._type + '/delete/' + this.id()
				          + GCN._getChannelParameter(that),
				type    : 'POST',
				error   : error,
				success : function (response) {
					// Clean cache & reset object to make sure it can't be used
					// properly any more.
					that._clearCache();
					that._data = {};
					that._shadow = {};

					// Don't forward the object to the success handler since
					// it's been deleted.
					if (success) {
						that._invoke(success);
					}
				}
			});
		},

		/**
		 * Removes any additionaly data stored on this objec which pertains to
		 * a tag matching the given tagname.  This function will be called when
		 * a tag is being removed in order to bring the content object to a
		 * consistant state.
		 * Should be overriden by subclasses.
		 *
		 * @param {string} tagid The Id of the tag whose associated data we
		 *                       want we want to remove.
		 */
		'!_removeAssociatedTagData': function (tagname) {}

	});

	GCN.ContentObjectAPI.update = update;

	/**
	 * Generates a factory method for chainback classes.  The method signature
	 * used with this factory function will match that of the target class'
	 * constructor.  Therefore this function is expected to be invoked with the
	 * follow combination of arguments ...
	 *
	 * Examples for GCN.pages api:
	 *
	 * To get an array containing 1 page:
	 * pages(1)
	 * pages(1, function () {})
	 *
	 * To get an array containing 2 pages:
	 * pages([1, 2])
	 * pages([1, 2], function () {})
	 *
	 * To get an array containing any and all pages:
	 * pages()
	 * pages(function () {})
	 *
	 * To get an array containing no pages:
	 * pages([])
	 * pages([], function () {});
	 *
	 * @param {Chainback} ctor The Chainback constructor we want to expose.
	 * @throws UNKNOWN_ARGUMENT
	 */
	GCN.exposeAPI = function (ctor) {
		return function () {
			// Convert arguments into an array
			// https://developer.mozilla.org/en/JavaScript/Reference/...
			// ...Functions_and_function_scope/arguments
			var args = Array.prototype.slice.call(arguments);
			var id;
			var ids;
			var success;
			var error;
			var settings;

			// iterate over arguments to find id || ids, succes, error and
			// settings
			jQuery.each(args, function (i, arg) {
				switch (jQuery.type(arg)) {
				// set id
				case 'string':
				case 'number':
					if (!id && !ids) {
						id = arg;
					} else {
						GCN.error('UNKNOWN_ARGUMENT',
							'id is already set. Don\'t know what to do with ' +
							'arguments[' + i + '] value: "' + arg + '"');
					}
					break;
				// set ids
				case 'array':
					if (!id && !ids) {
						ids = args[0];
					} else {
						GCN.error('UNKNOWN_ARGUMENT',
							'ids is already set. Don\'t know what to do with' +
							' arguments[' + i + '] value: "' + arg + '"');
					}
					break;
				// success and error handlers
				case 'function':
					if (!success) {
						success = arg;
					} else if (success && !error) {
						error = arg;
					} else {
						GCN.error('UNKNOWN_ARGUMENT',
							'success and error handler already set. Don\'t ' +
							'know what to do with arguments[' + i + ']');
					}
					break;
				// settings
				case 'object':
					if (!id && !ids) {
						id = arg;
					} else if (!settings) {
						settings = arg;
					} else {
						GCN.error('UNKNOWN_ARGUMENT',
							'settings are already present. Don\'t know what ' +
							'to do with arguments[' + i + '] value:' + ' "' +
							arg + '"');
					}
					break;
				default:
					GCN.error('UNKNOWN_ARGUMENT',
						'Don\'t know what to do with arguments[' + i +
						'] value: "' + arg + '"');
				}
			});

			// Prepare a new set of arguments to pass on during initialzation
			// of callee object.
			args = [];

			// settings should always be an object, even if it's just empty
			if (!settings) {
				settings = {};
			}

			args[0] = (typeof id !== 'undefined') ? id : ids;
			args[1] = success || settings.success || null;
			args[2] = error || settings.error || null;
			args[3] = settings;

			// We either add 0 (no channel) or the channelid to the hash
			var channel = GCN.settings.channel;

			// Check if the value is false, and set it to 0 in this case
			if (!channel) {
				channel = 0;
			}

			var hash = (id || ids)
			         ? ctor._makeHash(channel + '/' + (ids ? ids.sort().join(',') : id))
			         : null;

			return GCN.getChainback(ctor, hash, null, args);
		};

	};

}(GCN));
/*global jQuery:true, GCN: true */
(function (GCN) {

	'use strict';

	/**
	 * Checks whether or not a tag container instance has data for a tag of the
	 * given name.
	 *
	 * @param {TagContainerAPI} container The container in which to look
	 *                                         for the tag.
	 * @param {string} tagname The name of the tag to find.
	 * @return {boolean} True if the container contains a data for the tag of
	 * the given name.
	 */
	function hasTagData(container, tagname) {
		return !!container._data.tags[tagname];
	}

	/**
	 * Extends the internal taglist with data from the given collection of tags.
	 * Will overwrite the data of any tag whose name is matched in the `tags'
	 * associative array.
	 *
	 * @param {TagContainerAPI} container The container in which to look
	 *                                         for the tag.
	 * @param {object} tags Associative array of tag data, mapped against the
	 *                      data's corresponding tag name.
	 */
	function extendTags(container, tags) {
		jQuery.extend(container._data.tags, tags);
	}

	/**
	 * Gets the construct matching the given keyword.
	 *
	 * @param {string} keyword Construct keyword.
	 * @param {NodeAPI} node The node inwhich to search for the construct.
	 * @param {function(object)} success Callback function to receive the
	 *                                   successfully found construct.
	 * @param {function(GCNError):boolean} error Optional custom error handler.
	 */
	function getConstruct(keyword, node, success, error) {
		node.constructs(function (constructs) {
			if (constructs[keyword]) {
				success(constructs[keyword]);
			} else {
				var err = GCN.createError(
					'CONSTRUCT_NOT_FOUND',
					'Cannot find constuct `' + keyword + '\'',
					constructs
				);
				GCN.handleError(err, error);
			}
		}, error);
	}

	/**
	 * Creates an new tag via the GCN REST-API.
	 *
	 * @param {TagAPI} tag A representation of the tag which will be created in
	 *                     the GCN backend.
	 * @param {object} data The request body that will be serialized into json.
	 * @param {function(TagAPI)} success Callback function to receive the
	 *                                   successfully created tag.
	 * @param {function(GCNError):boolean} error Optional custom error handler.
	 */
	function newTag(tag, data, success, error) {
		var obj = tag.parent();
		var url = GCN.settings.BACKEND_PATH + '/rest/' + obj._type
				+ '/newtag/' + obj._data.id;
		obj._authAjax({
			type: 'POST',
			url: url,
			json: data,
			error: function (xhr, status, msg) {
				GCN.handleHttpError(xhr, msg, error);
				tag._vacate();
			},
			success: function (response) {
				obj._handleCreateTagResponse(tag, response, success,
				                             error);
			}
		}, error);
	}

	/**
	 * Checks whether exactly one of the following combination of options is
	 * provided:
	 *
	 * 1. `keyword' alone
	 * or
	 * 2. `constructId' alone
	 * or
	 * 3. `sourcePageId' and `sourceTagname' together.
	 *
	 * Each of these options are mutually exclusive.
	 *
	 * @param {Object} options
	 * @return {boolean} True if only one combination of the possible options
	 *                   above is contained in the given options object.
	 */
	function isValidCreateTagOptions(options) {
		// If the sum is 0, it means that no options was specified.
		//
		// If the sum is greater than 0 but less than 2, it means that either
		// `sourcePageId' or `sourceTagname' was specified, but not both as
		// required.
		//
		// If the sum is greater than 2, it means that more than one
		// combination of settings was provided, which is one too many.
		return 2 === (options.sourcePageId  ? 1 : 0) +
		             (options.sourceTagname ? 1 : 0) +
		             (options.keyword       ? 2 : 0) +
		             (options.constructId   ? 2 : 0);
	}

	/**
	 * Parse the arguments passed into createTag() into a normalized object.
	 *
	 * @param {Arguments} createTagArgumenents An Arguments object.
	 * @parma {object} Normalized map of arguments.
	 */
	function parseCreateTagArguments(createTagArguments) {
		var args = Array.prototype.slice.call(createTagArguments);
		if (0 === args.length) {
			return {
				error: '`createtag()\' requires at least one argument.  See ' +
				       'documentation.'
			};
		}

		var options;

		// The first argument must either be a string, number or an object.
		switch (jQuery.type(args[0])) {
		case 'string':
			options = {keyword: args[0]};
			break;
		case 'number':
			options = {constructId: args[0]};
			break;
		case 'object':
			if (!isValidCreateTagOptions(args[0])) {
				return {
					error: 'createTag() requires exactly one of the ' +
					       'following, mutually exclusive, settings to be' +
					       'used: either `keyword\', `constructId\' or a ' +
					       'combination of `sourcePageId\' and ' +
					       '`sourceTagname\'.'
				};
			}
			options = args[0];
			break;
		default:
			options = {};
		}

		// Determine success() and error(): arguments 2-3.
		var i;
		for (i = 1; i < args.length; i++) {
			if (jQuery.type(args[i]) === 'function') {
				if (options.success) {
					options.error = args[i];
				} else {
					options.success = args[i];
				}
			}
		}

		return {
			options: options
		};
	}

	/**
	 * Given an object containing information about a tag, determines whether
	 * or not we should treat a tag as a editabled block.
	 *
	 * Relying on `onlyeditables' property to determine whether or not a given
	 * tag is a block or an editable is unreliable since it is possible to have
	 * a block which only contains editables:
	 *
	 * {
	 *  "tagname":"content",
	 *  "editables":[{
	 *    "element":"GENTICS_EDITABLE_1234",
	 *    "readonly":false,
	 *    "partname":"editablepart"
	 *  }],
	 *  "element":"GENTICS_BLOCK_1234",
	 *  "onlyeditables":true
	 *  "tagname":"tagwitheditable"
	 * }
	 *
	 * In the above example, even though `onlyeditable' is true the tag is
	 * still a block, since the tag's element and the editable's element are
	 * not the same.
	 *
	 * @param {object} tag A object holding the sets of blocks and editables
	 *                     that belong to a tag.
	 * @return {boolean} True if the tag
	 */
	function isBlock(tag) {
		if (!tag.editables || tag.editables.length > 1) {
			return true;
		}
		return (
			(1 === tag.editables.length)
			&&
			(tag.editables[0].element !== tag.element)
		);
	}

	/**
	 * Given a data object received from a REST API "/rest/page/render"
	 * call maps the blocks and editables into a list of each.
	 *
	 * The set of blocks and the set of editables that are returned are not
	 * mutually exclusive--if a tag is determined to be both an editable
	 * and a block, it will be included in both sets.
	 *
	 * @param {object} data
	 * @return {object<string, Array.<object>>} A map containing a set of
	 *                                          editables and a set of
	 *                                          blocks.
	 */
	function getEditablesAndBlocks(data) {
		if (!data || !data.tags) {
			return {
				blocks: [],
				editables: []
			};
		}

		var tag;
		var tags = data.tags;
		var blocks = [];
		var editables = [];
		var i;
		var j;

		for (i = 0; i < tags.length; i++) {
			tag = tags[i];
			if (tag.editables) {
				for (j = 0; j < tag.editables.length; j++) {
					tag.editables[j].tagname = tag.tagname;
				}
				editables = editables.concat(tag.editables);
			}
			if (isBlock(tag)) {
				blocks.push(tag);
			}
		}

		return {
			blocks: blocks,
			editables: editables
		};
	}

	/**
	 * Abstract class that is implemented by tag containers such as
	 * {@link PageAPI} or {@link TemplateAPI}
	 * 
	 * @class
	 * @name TagContainerAPI
	 */
	GCN.TagContainerAPI = GCN.defineChainback({
		/** @lends TagContainerAPI */

		/**
		 * @private
		 * @type {object<number, string>} Hash, mapping tag ids to their
		 *                                corresponding names.
		 */
		_tagIdToNameMap: null,

		/**
		 * @private
		 * @type {object<number, string>} Hash, mapping tag ids to their
		 *                                corresponding names for newly created
		 *                                tags.
		 */
		_createdTagIdToNameMap: {},

		/**
		 * @private
		 * @type {Array.<object>} A set of blocks that are are to be removed
		 *                        from this content object when saving it.
		 *                        This array is populated during the save
		 *                        process.  It get filled just before
		 *                        persisting the data to the server, and gets
		 *                        emptied as soon as the save operation
		 *                        succeeds.
		 */
		_deletedBlocks: [],

		/**
		 * @private
		 * @type {Array.<object>} A set of tags that are are to be removed from
		 *                        from this content object when it is saved.
		 */
		_deletedTags: [],

		/**
		 * Searching for a tag of a given id from the object structure that is
		 * returned by the REST API would require O(N) time.  This function,
		 * builds a hash that maps the tag id with its corresponding name, so
		 * that it can be mapped in O(1) time instead.
		 *
		 * @private
		 * @return {object<number,string>} A hash map where the key is the tag
		 *                                 id, and the value is the tag name.
		 */
		'!_mapTagIdsToNames': function () {
			var name;
			var map = {};
			var tags = this._data.tags;
			for (name in tags) {
				if (tags.hasOwnProperty(name)) {
					map[tags[name].id] = name;
				}
			}
			return map;
		},

		/**
		 * Retrieves data for a tag from the internal data object.
		 *
		 * @private
		 * @param {string} name The name of the tag.
		 * @return {!object} The tag data, or null if a there if no tag
		 *                   matching the given name.
		 */
		'!_getTagData': function (name) {
			return (this._data.tags && this._data.tags[name]) ||
			       (this._shadow.tags && this._shadow.tags[name]);
		},

		/**
		 * Get the tag whose id is `id'.
		 * Builds the `_tagIdToNameMap' hash map if it doesn't already exist.
		 *
		 * @todo: Should we deprecate this?
		 * @private
		 * @param {number} id Id of tag to retrieve.
		 * @return {object} The tag's data.
		 */
		'!_getTagDataById': function (id) {
			if (!this._tagIdToNameMap) {
				this._tagIdToNameMap = this._mapTagIdsToNames();
			}
			return this._getTagData(this._tagIdToNameMap[id] ||
				 this._createdTagIdToNameMap[id]);
		},

		/**
		 * Extracts the editables and blocks that have been rendered from the
		 * REST API render call's response data.
		 *
		 * @param {object} data The response object received from the
		 *                      renderTemplate() call.
		 * @return {object} An object containing two properties: an array of
		 *                  blocks, and an array of editables.
		 */
		'!_processRenderedTags': getEditablesAndBlocks,

		// !!!
		// WARNING adding &nbsp; to folder is neccessary as jsdoc will report a
		// name confict otherwise
		// !!!
		/**
		 * Get this content object's node.
		 *
		 * @function
		 * @name node&nbsp;
		 * @memberOf TagContainerAPI
		 * @param {funtion(NodeAPI)=} success Optional callback to receive a
		 *                                    {@link NodeAPI} object as the
		 *                                    only argument.
		 * @param {function(GCNError):boolean=} error Optional custom error
		 *                                            handler.
		 * @return {NodeAPI} This object's node.
		 */
		'!node': function (success, error) {
			return this.folder().node();
		},

		// !!!
		// WARNING adding &nbsp; to folder is neccessary as jsdoc will report a
		// name confict otherwise
		// !!!
		/**
		 * Get this content object's parent folder.
		 * 
		 * @function
		 * @name folder&nbsp;
		 * @memberOf TagContainerAPI
		 * @param {funtion(FolderAPI)=}
		 *            success Optional callback to receive a {@link FolderAPI}
		 *            object as the only argument.
		 * @param {function(GCNError):boolean=}
		 *            error Optional custom error handler.
		 * @return {FolderAPI} This object's parent folder.
		 */
		'!folder': function (success, error) {
			var id = this._fetched ? this.prop('folderId') : null;
			return this._continue(GCN.FolderAPI, id, success, error);
		},

		/**
		 * Gets a tag of the specified id, contained in this content object.
		 *
		 * @name tag
		 * @function
		 * @memberOf TagContainerAPI
		 * @param {function} success
		 * @param {function} error
		 * @return TagAPI
		 */
		'!tag': function (id, success, error) {
			return this._continue(GCN.TagAPI, id, success, error);
		},

		/**
		 * Retrieves a collection of tags from this content object.
		 *
		 * @name tags
		 * @function
		 * @memberOf TagContainerAPI
		 * @param {object|string|number} settings (Optional)
		 * @param {function} success callback
		 * @param {function} error (Optional)
		 * @return TagContainerAPI
		 */
		'!tags': function () {
			var args = Array.prototype.slice.call(arguments);

			if (args.length === 0) {
				return;
			}

			var i;
			var j = args.length;
			var filter = {};
			var filters;
			var hasFilter = false;
			var success;
			var error;

			// Determine `success', `error', `filter'
			for (i = 0; i < j; ++i) {
				switch (jQuery.type(args[i])) {
				case 'function':
					if (success) {
						error = args[i];
					} else {
						success = args[i];
					}
					break;
				case 'number':
				case 'string':
					filters = [args[i]];
					break;
				case 'array':
					filters = args[i];
					break;
				default:
					return;
				}
			}

			if (jQuery.type(filters) === 'array') {
				var k = filters.length;
				while (k) {
					filter[filters[--k]] = true;
				}
				hasFilter = true;
			}

			var that = this;

			if (success) {
				this._read(function () {
					var tags = that._data.tags;
					var tag;
					var list = [];

					for (tag in tags) {
						if (tags.hasOwnProperty(tag)) {
							if (!hasFilter || filter[tag]) {
								list.push(that._continue(GCN.TagAPI, tags[tag],
									null, error));
							}
						}
					}

					that._invoke(success, [list]);
				}, error);
			}
		},

		/**
		 * Internal method to create a tag of a given tagtype in this content
		 * object.
		 *
		 * Not all tag containers allow for new tags to be created on them,
		 * therefore this method will only be surfaced by tag containers which
		 * do allow this.
		 *
		 * @private
		 * @param {string|number|object} construct either the keyword of the
		 *                               construct, or the ID of the construct
		 *                               or an object with the following
		 *                               properties
		 *                               <ul>
		 *                                <li><i>keyword</i> keyword of the construct</li>
		 *                                <li><i>constructId</i> ID of the construct</li>
		 *                                <li><i>magicValue</i> magic value to be filled into the tag</li>
		 *                                <li><i>sourcePageId</i> source page id</li>
		 *                                <li><i>sourceTagname</i> source tag name</li>
		 *                               </ul>
		 * @param {function(TagAPI)=} success Optional callback that will
		 *                                    receive the newly created tag as
		 *                                    its only argument.
		 * @param {function(GCNError):boolean=} error Optional custom error
		 *                                            handler.
		 * @return {TagAPI} The newly created tag.
		 */
		'!_createTag': function () {
			var args = parseCreateTagArguments(arguments);

			if (args.error) {
				GCN.handleError(
					GCN.createError('INVALID_ARGUMENTS', args.error, arguments),
					args.error
				);
				return;
			}

			var obj = this;

			// We use a uniqueId to avoid a fetus being created.
			// This is to avoid the following scenario:
			//
			// var tag1 = container.createTag(...);
			// var tag2 = container.createTag(...);
			// tag1 === tag2 // is true which is wrong
			//
			// However, for all other cases, where we get an existing object,
			// we want this behaviour:
			//
			// var folder1 = page(1).folder(...);
			// var folder2 = page(1).folder(...);
			// folder1 === folder2 // is true which is correct
			//
			// So, createTag() is different from other chainback methods in
			// that each invokation must create a new instance, while other
			// chainback methods must return the same.
			//
			// The id will be reset as soon as the tag object is realized.
			// This happens below as soon as we get a success response with the
			// correct tag id.
			var newId = GCN.uniqueId('TagApi-unique-');

			// Create a new TagAPI instance linked to this tag container.  Also
			// acquire a lock on the newly created tag object so that any
			// further operations on it will be queued until the tag object is
			// fully realized.
			var tag = obj._continue(GCN.TagAPI, newId)._procure();

			var options = args.options;
			var copying = !!(options.sourcePageId && options.sourceTagname);

			var onCreate = function () {
				if (options.success) {
					obj._invoke(options.success, [tag]);
				}
				tag._vacate();
			};

			if (copying) {
				newTag(tag, {
					copyPageId: options.sourcePageId,
					copyTagname: options.sourceTagname
				}, onCreate, options.error);
			} else {
				if (options.constructId) {
					newTag(tag, {
						magicValue: options.magicValue,
						constructId: options.constructId
					}, onCreate, options.error);
				} else {
					// ASSERT(options.keyword)
					getConstruct(options.keyword, obj.node(), function (construct) {
						newTag(tag, {
							magicValue: options.magicValue,
							constructId: construct.constructId
						}, onCreate, options.error);
					}, options.error);
				}
			}

			return tag;
		},

		/**
		 * Internal helper method to handle the create tag response.
		 * 
		 * @private
		 * @param {TagAPI} tag
		 * @param {object} response response object from the REST call
		 * @param {function(TagContainerAPI)=} success optional success handler
		 * @param {function(GCNError):boolean=} error optional error handler
		 */
		'!_handleCreateTagResponse': function (tag, response, success, error) {
			var obj = this;

			if (GCN.getResponseCode(response) === 'OK') {
				var data = response.tag;
				tag._name = data.name;
				tag._data = data;
				tag._fetched = true;

				// The tag's id is still the temporary unique id that was given
				// to it in _createTag().  We have to realize the tag so that
				// it gets the correct id. The new id changes its hash, so it
				// must also be removed and reinserted from the caches.
				tag._removeFromTempCache(tag);
				tag._setHash(data.id)._addToCache();

				// Add this tag into the tag's container `_shadow' object, and
				// `_tagIdToNameMap hash'.
				var shouldCreateObjectIfUndefined = true;
				obj._update('tags.' + GCN.escapePropertyName(data.name),
					data, error, shouldCreateObjectIfUndefined);

				// TODO: We need to store the tag inside the `_data' object for
				// now.  A change should be made so that when containers are
				// saved, the data in the `_shadow' object is properly
				// transfered into the _data object.
				obj._data.tags[data.name] = data;

				if (!obj.hasOwnProperty('_createdTagIdToNameMap')) {
					obj._createdTagIdToNameMap = {};
				}

				obj._createdTagIdToNameMap[data.id] = data.name;

				if (success) {
					success();
				}
			} else {
				tag._die(GCN.getResponseCode(response));
				GCN.handleResponseError(response, error);
			}
		},

		/**
		 * Internal method to delete the specified tag from this content
		 * object.
		 *
		 * @private
		 * @param {string} keyword The keyword of the tag to be deleted.
		 * @param {function(TagContainerAPI)=} success Optional callback that
		 *                                             receive this object as
		 *                                             its only argument.
		 * @param {function(GCNError):boolean=} error Optional custom error
		 *                                            handler.
		 */
		'!_removeTag': function (keyword, success, error) {
			this.tag(keyword).remove(success, error);
		},

		/**
		 * Internal method to delete a set of tags from this content object.
		 *
		 * @private
		 * @param {Array.<string>} keywords The keywords of the set of tags to be
		 *                             deleted.
		 * @param {function(TagContainerAPI)=} success Optional callback that
		 *                                             receive this object as
		 *                                             its only argument.
		 * @param {function(GCNError):boolean=} error Optional custom error
		 *                                            handler.
		 */
		'!_removeTags': function (keywords, success, error) {
			var that = this;
			this.tags(keywords, function (tags) {
				var j = tags.length;
				while (j--) {
					tags[j].remove(null, error);
				}
				if (success) {
					that.save(success, error);
				}
			}, error);
		}

	});

	GCN.TagContainerAPI.hasTagData = hasTagData;
	GCN.TagContainerAPI.extendTags = extendTags;
	GCN.TagContainerAPI.getEditablesAndBlocks = getEditablesAndBlocks;

}(GCN));
/*global jQuery: true, GCN: true */
/**
 * @overview:
 * defines `AdminAPI', which gives access to global Content Node data (like all
 * existing constructs).  A single instance is of this API is exposed as
 * GCN.Admin.
 */
(function (GCN) {

	'use strict';

	/**
	 * Maps constructcategories that were fetched via the Rest API
	 * into a sorted nested array of constructs.
	 *
	 * @param {object<string, object>} constructs
	 * @return {object<string, object>}
	 */
	function mapConstructCategories(constructs) {
		var map = {
			categories: {},
			categorySortorder: []
		};
		var categories = [];
		var keyword;

		for (keyword in constructs) {
			if (constructs.hasOwnProperty(keyword)) {
				var construct = constructs[keyword];
				var name = construct.category;
				var sortorder = construct.categorySortorder;

				// Because constructs that have not been assigned to a category
				// have not real category name.
				if (!name) {
					name = 'GCN_UNCATEGORIZED';
					sortorder = -1;
				}

				// Initialize the inner array of constructs
				if (!map.categories[name]) {
					var newCategory = {};
					newCategory.constructs = {};
					newCategory.sortorder = sortorder;
					newCategory.name = name;
					map.categories[name] = newCategory;
					categories.push(newCategory);
				}

				// Add the construct to the category
				map.categories[name].constructs[keyword] = construct;
			}
		}

		categories.sort(function (a, b) {
			return a.sortorder - b.sortorder;
		});

		// Add the sorted category names to the sortorder field
		var i;
		for (i in categories) {
			if (categories.hasOwnProperty(i)) {
				var category = categories[i];
				if (typeof category.sortorder !== 'undefined'
						&& category.sortorder !== -1) {
					map.categorySortorder.push(category.name);
				}
			}
		}

		return map;
	}

	/**
	 * Maps constructs, that were fetched via the Rest API, using their keyword
	 * as the keys.
	 *
	 * @param {object<string, object>} constructs Consturcts mapped against
	 *                                            their id.
	 * @return {object<string, object>} Constructs mapped against their keys.
	 */
	function mapConstructs(constructs) {
		if (!constructs) {
			return {};
		}
		var map = {};
		var constructId;
		for (constructId in constructs) {
			if (constructs.hasOwnProperty(constructId)) {
				map[constructs[constructId].keyword] = constructs[constructId];
			}
		}
		return map;
	}

	/**
	 * The AdminAPI is exposed via {@link GCN.Admin}. The AdminAPI is not meant
	 * to be instatiated by the implementer. Stick to using GCN.Admin.
	 * 
	 * @name AdminAPI
	 * @class
	 * @augments Chainback
	 */
	var AdminAPI = GCN.defineChainback({
		/** @lends AdminAPI */

		__chainbacktype__: 'AdminAPI',
		_type: 'admin',

		/**
		 * @private
		 * @type {object<string, number} Constructs for this node are cached
		 *                               here so that we only need to fetch
		 *                               this once.
		 */
		_constructs: null,

		/**
		 * @private
		 * @type {object<string, object} Constructs categories for this node.
		 *                               Cached here so that we only need to
		 *                               fetch this once.
		 */
		_constructCategories: null,

		/**
		 * Initialize
		 * @private
		 */
		_init: function (id, success, error, settings) {
			if (typeof success === 'function') {
				this._invoke(success, [this]);
			}
		},

		/**
		 * Wrapper for internal chainback _ajax method.
		 *
		 * @private
		 * @param {object<string, *>} settings Settings for the ajax request.
		 *                                     The settings object is identical
		 *                                     to that of the `GCN.ajax'
		 *                                     method, which handles the actual
		 *                                     ajax transportation.
		 * @throws AJAX_ERROR
		 */
		'!_ajax': function (settings) {
			var that = this;

			// force no cache for all API calls
			settings.cache = false;
			settings.success = (function (onSuccess, onError) {
				return function (data) {
					// Ajax calls that do not target the REST API servlet do
					// not response data with a `responseInfo' object.
					// "/CNPortletapp/alohatag" is an example.  So we cannot
					// just assume that it exists.
					if (data.responseInfo) {
						switch (data.responseInfo.responseCode) {
						case 'OK':
							break;
						case 'AUTHREQUIRED':
							GCN.clearSession();
							that._authAjax(settings);
							return;
						default:
							GCN.handleResponseError(data, onError);
							return;
						}
					}

					if (onSuccess) {
						that._invoke(onSuccess, [data]);
					}
				};
			}(settings.success, settings.error, settings.url));

			this._queueAjax(settings);
		},

		/**
		 * Similar to `_ajax', except that it prefixes the ajax url with the
		 * current session's `sid', and will trigger an
		 * `authentication-required' event if the session is not authenticated.
		 *
		 * @private
		 * @param {object<string, *>} settings Settings for the ajax request.
		 * @throws AUTHENTICATION_FAILED
		 */
		_authAjax: function (settings) {
			var that = this;

			if (GCN.isAuthenticating) {
				GCN.afterNextAuthentication(function () {
					that._authAjax(settings);
				});

				return;
			}

			if (!GCN.sid) {
				var cancel;

				if (settings.error) {
					/**
					 * @ignore
					 */
					cancel = function (error) {
						GCN.handleError(
							error || GCN.createError('AUTHENTICATION_FAILED'),
							settings.error
						);
					};
				} else {
					/**
					 * @ignore
					 */
					cancel = function (error) {
						if (error) {
							GCN.error(error.code, error.message, error.data);
						} else {
							GCN.error('AUTHENTICATION_FAILED');
						}
					};
				}

				GCN.afterNextAuthentication(function () {
					that._authAjax(settings);
				});

				if (GCN.usingSSO) {
					// First, try to automatically authenticate via
					// Single-SignOn
					GCN.loginWithSSO(GCN.onAuthenticated, function () {
						// ... if SSO fails, then fallback to requesting user
						// credentials: broadcast `authentication-required'
						// message.
						GCN.authenticate(cancel);
					});
				} else {
					// Trigger the `authentication-required' event to request
					// user credentials.
					GCN.authenticate(cancel);
				}

				return;
			}

			// Append "?sid=..." or "&sid=..." if needed.

			var urlFragment = settings.url.substr(
				GCN.settings.BACKEND_PATH.length
			);
			var isSidInUrl = /[\?\&]sid=/.test(urlFragment);
			if (!isSidInUrl) {
				var isFirstParam = (jQuery.inArray('?',
					urlFragment.split('')) === -1);

				settings.url += (isFirstParam ? '?' : '&') + 'sid='
				             + (GCN.sid || '');
			}

			this._ajax(settings);
		},

		/**
		 * Retrieves a list of all constructs and constructs categories and
		 * passes it as the only argument into the `success()' callback.
		 *
		 * @param {function(Array.<object>)=} success Callback to receive an
		 *                                            array of constructs.
		 * @param {function(GCNError):boolean=} error Custom error handler.
		 * @return undefined
		 * @throws INVALID_ARGUMENTS
		 */
		constructs: function (success, error) {
			var that = this;
			if (!success) {
				GCN.error('INVALID_ARGUMENTS', 'the `constructs()\' method ' +
					'requires at least a success callback to be given');
			}
			if (this._constructs) {
				this._invoke(success, [this._constructs]);
			} else {
				this._authAjax({
					url: GCN.settings.BACKEND_PATH + '/rest/construct/list.json',
					type: 'GET',
					error: function (xhr, status, msg) {
						GCN.handleHttpError(xhr, msg, error);
					},
					success: function (response) {
						if (GCN.getResponseCode(response) === 'OK') {
							that._constructs = mapConstructs(response.constructs);
							that._invoke(success, [that._constructs]);
						} else {
							GCN.handleResponseError(response, error);
						}
					}
				});
			}
		},

		/**
		 * Helper method that will load the constructs of this node.
		 *
		 * @private
		 * @this {AdminAPI}
		 * @param {function(Array.<object>)} success callback
		 * @param {function(GCNError):boolean=} error callback
		 */
		constructCategories: function (success, error) {
			if (this._constructCategories) {
				this._invoke(success, [this._constructCategories]);
			} else {
				var that = this;
				this.constructs(function (constructs) {
					that._constructCategories = mapConstructCategories(constructs);
					that._invoke(success, [that._constructCategories]);
				}, error);
			}
		},

		/**
		 * Internal method, to fetch this object's data from the server.
		 *
		 * @private
		 * @override
		 * @param {function(ContentObjectAPI)=} success Optional callback that
		 *                                              receives this object as
		 *                                              its only argument.
		 * @param {function(GCNError):boolean=} error Optional customer error
		 *                                            handler.
		 */
		'!_read': function (success, error) {
			this._invoke(success, [this]);
		}
	});

	/**
	 * Exposes an instance of the AdminAPI via GCN.Admin.
	 * 
	 * @see AdminAPI
	 */
	GCN.Admin = new AdminAPI();

}(GCN));
/*global GCN: true */
(function (GCN) {
	'use strict';

	/**
	 * Maps constructcategories that were fetched via the Rest API into a
	 * sorted nested array of constructs.
	 *
	 * @param {object<string, object>} constructs
	 * @return {object<string, object>}
	 */
	function mapConstructCategories(constructs) {
		var constructKeyword;
		var categoryMap = {
			categories: {},
			categorySortorder: []
		};
		var constructCategoryArray = [];
		for (constructKeyword in constructs) {
			if (constructs.hasOwnProperty(constructKeyword)) {
				var construct = constructs[constructKeyword];
				var constructCategoryName = construct.category;
				var categorySortorder = construct.categorySortorder;

				// Use a custom name for constructs that have not been assigned
				// to a category.
				if (!constructCategoryName) {
					constructCategoryName = 'GCN_UNCATEGORIZED';
					categorySortorder = -1;
				}

				// Initialize the inner array of constructs.
				if (!categoryMap.categories[constructCategoryName]) {
					var newCategory = {};
					newCategory.constructs = {};
					newCategory.sortorder = categorySortorder;
					newCategory.name = constructCategoryName;
					categoryMap.categories[constructCategoryName] = newCategory;
					constructCategoryArray.push(newCategory);
				}

				// Add the construct to the category.
				categoryMap.categories[constructCategoryName]
				           .constructs[constructKeyword] = construct;
			}
		}

		// Sort the categories by the sortorder.
		constructCategoryArray.sort(function (a, b) {
			return a.sortorder - b.sortorder;
		});

		// Add the sorted category names to the sortorder field.
		var k;
		for (k in constructCategoryArray) {
			if (constructCategoryArray.hasOwnProperty(k)) {
				var category = constructCategoryArray[k];
				if (typeof category.sortorder !== 'undefined' && category.sortorder !== -1) {
					categoryMap.categorySortorder.push(category.name);
				}
			}
		}

		return categoryMap;
	}

	/**
	 * Represents a Node
	 *
	 * @name NodeAPI
	 * @class
	 * @augments Chainback
	 * 
	 * @param {number|string}
	 *            id of the file to be loaded
	 * @param {function(ContentObjectAPI))=}
	 *            success Optional success callback that will receive this
	 *            object as its only argument.
	 * @param {function(GCNError):boolean=}
	 *            error Optional custom error handler.
	 * @param {object}
	 *            settings currently there are no additional settings to be used
	 */
	var NodeAPI = GCN.defineChainback({
		/** @lends NodeAPI */

		__chainbacktype__: 'NodeAPI',
		_extends: GCN.ContentObjectAPI,
		_type: 'node',

		_data: {
			folderId: null
		},

		/**
		 * @private
		 * @type {object<string, number} Constructs for this node are cached
		 *                               here so that we only need to fetch
		 *                               this once.
		 */
		_constructs: null,

		/**
		 * @private
		 * @type {object<string, object} Constructs categories for this node.
		 *                               Cached here so that we only need to
		 *                               fetch this once.
		 */
		_constructCategories: null,

		/**
		 * Retrieves a list of constructs and constructs categories that are
		 * assigned to this node and passes it as the only argument into the
		 * the `success()' callback.
		 *
		 * @param {function(Array.<object>)=} success Callback to receive an
		 *                                            array of constructs.
		 * @param {function(GCNError):boolean=} error Custom error handler.
		 * @return undefined
		 * @throws INVALID_ARGUMENTS
		 */
		constructs: function (success, error) {
			if (!success) {
				return;
			}
			var node = this;
			if (node._constructs) {
				node._invoke(success, [node._constructs]);
				return;
			}
			node._read(function () {
				node._authAjax({
					url: GCN.settings.BACKEND_PATH +
					     '/rest/construct/list.json?nodeId=' + node.id(),
					type: 'GET',
					error: function (xhr, status, msg) {
						GCN.handleHttpError(xhr, msg, error);
					},
					success: function (response) {
						if (GCN.getResponseCode(response) === 'OK') {
							node._constructs = GCN.mapConstructs(response.constructs);
							node._invoke(success, [node._constructs]);
						} else {
							GCN.handleResponseError(response, error);
						}
					}
				});
			}, error);
		},

		/**
		 * Removes this node object.
		 *
		 * @ignore
		 * @param {function=} success Callback function to be invoked when
		 *                            this operation has completed
		 *                            successfully.
		 * @param {function(GCNError):boolean=} error Custom error handler.
		 */
		remove: function (success, error) {
			GCN.handleError(
				GCN.error('NOT_YET_IMPLEMENTED',
						  'This method is not yet implemented', this),
				error
			);
		},

		/**
		 * Saves the locally modified changes back to the system.
		 * This is currently not yet implemented.
		 * 
		 * @ignore
		 * @param {function=} success Callback function to be invoked when
		 *                            this operation has completed
		 *                            successfully.
		 * @param {function(GCNError):boolean=} error Custom error handler.
		 */
		save: function (success, error) {
			GCN.handleError(
				GCN.error('NOT_YET_IMPLEMENTED',
						  'This method is not yet implemented', this),
				error
			);
		},

		/**
		 * Retrieves the top-level folders of this node's root folder.
		 *
		 * @function
		 * @name folders
		 * @memberOf NodeAPI
		 * @param {function(FolderAPI)=} success
		 * @param {function(GCNError):boolean=} error Custom error handler.
		 */
		'!folders': function (success, error) {
			return this.folder(null, error).folders(success, error);
		},

		/**
		 * Helper method that will load the constructs of this node.
		 * @ignore
		 * @private
		 * @this {NodeAPI}
		 * @param {function(Array.<object>)} success callback
		 * @param {function(GCNError):boolean=} error callback
		 */
		constructCategories: function (success, error) {
			if (!success) {
				return;
			}
			var node = this;
			if (node._constructCategories) {
				node._invoke(success, [node._constructCategories]);
			} else {
				node._read(function () {
					node._data.id = node._chain._data.nodeId;
					node.constructs(function (constructs) {
						node._constructCategories =
								mapConstructCategories(constructs);
						node._invoke(success, [node._constructCategories]);
					}, error);
				}, error);
			}
		}
	});

	/**
	* Creates a new instance of NodeAPI. See the {@link NodeAPI} constructor for detailed information.
	* 
	* @function
	* @name node
	* @memberOf GCN
	* @see NodeAPI
	*/
	GCN.node = GCN.exposeAPI(NodeAPI);
	GCN.NodeAPI = NodeAPI;

}(GCN));
(function (GCN) {

	'use strict';

	/**
	 * @private
	 * @const
	 * @type {number}
	 */
	//var TYPE_ID = 10002;

	/**
	 * @const
	 * @private
	 * @type {object<string, *>} Default folder settings.
	 */
	var DEFAULT_SETTINGS = {
		// Load folder privileges as well
		privileges: true,
		update: true
	};

	/**
	 * @class
	 * @name FolderAPI
	 * @extends ContentObjectAPI
	 * @extends TagContainerAPI
	 * 
	 * @param {number|string}
	 *            id of the file to be loaded
	 * @param {function(ContentObjectAPI))=}
	 *            success Optional success callback that will receive this
	 *            object as its only argument.
	 * @param {function(GCNError):boolean=}
	 *            error Optional custom error handler.
	 * @param {object}
	 *            settings currently there are no additional settings to be used
	 */
	var FolderAPI = GCN.defineChainback({
		/** @lends FolderAPI */

		__chainbacktype__: 'FolderAPI',
		_extends: [ GCN.TagContainerAPI, GCN.ContentObjectAPI ],
		_type: 'folder',

		/**
		 * Writable properties for the folder object.
		 * Currently description, motherId, name and publishDir are writeable.
		 * 
		 * @public
		 * @type {Array.<string>} 
		 */
		WRITEABLE_PROPS: [ 'description',
		                   'motherId',
		                   'name',
		                   'publishDir' ],

		/**
		 * Persist changes made to the object in Gentics Content.Node .
		 * 
		 * @public
		 * @param {function(FolderAPI)=}
		 *            success Optional callback that will receive this object as
		 *            its only argument.
		 * @param {function(GCNError):boolean}
		 *            error Optional custom error handler.
		 */
		save: function (success, error) {
			this._save(null, success, error);
		},

		/**
		 * Removes the folder and all its children
		 *
		 * @public
		 * @param {function(FolderAPI)=} success Optional callback that will
		 *                                       receive this object as its
		 *                                       only argument.
		 * @param {function(GCNError):boolean} error Optional custom error
		 *                                           handler.
		 */
		remove: function (success, error) {
			this._remove(success, error);
		},

		/**
		 * Gets this folder's parent folder. If this folder does not have a
		 * parent, then the returned object will be an API to an object that
		 * does not exists. Only when attempting to perform read/write
		 * operations on this object on the server will a `NOTFOUND' error be
		 * encountered. We recognize that this is relatively late for the use to
		 * find out that this folder has no parent; if the use need to guarantee
		 * that a parent folder exists before further operations, they are
		 * simply to pass a callback into this function.
		 * 
		 * @name parent
		 * @function
		 * @memberOf FolderAPI
		 * @public
		 * @param {function(FolderAPI)=}
		 *            success Optional callback that will receive this object as
		 *            its only argument.
		 * @param {function(GCNError):boolean=}
		 *            error Optional custom error handler.
		 * @return {FolderAPI} The parent folder
		 */
		'!parent': function (success, error) {
			this._continue(GCN.FolderAPI, this.id(), success, error);
		},

	    /**
		 * Check if a given permission is available for a folder. If no name is
		 * provided an array of available permissions is returned.
		 * 
		 * @name perm
		 * @memberOf FolderAPI
		 * @public
		 * @function
		 * @param {name}
		 *            optional Privilege name to be checked. possible values
		 *            are: "viewfolder" "createfolder" "updatefolder"
		 *            "deletefolder" "viewpage" "createpage" "updatepage"
		 *            "deletepage" "publishpage" "viewtemplate" "createtemplate"
		 *            "linktemplate" "updatetemplate" "deletetemplate"
		 * @return {boolean|Array.<string>} Permission value for the given name
		 *         or an array of permissions
		 */
		'!perm': function (name) {
			var i;

			if (!name) {
				return this._data.privileges;
			}

			for (i in this._data.privileges) {
				if (this._data.privileges.hasOwnProperty(i) &&
						this._data.privileges[i] === name) {
					return true;
				}
			}

			return false;
		},

		/**
		 * Get this content object's node.
		 * 
		 * @public
		 * @function
		 * @name node
		 * @memberOf FolderAPI
		 * @param {funtion(NodeAPI)=}
		 *            success Optional callback to receive a {@link NodeAPI}
		 *            object as the only argument.
		 * @param {function(GCNError):boolean=}
		 *            error Optional custom error handler.
		 * @return {NodeAPI} This object's node.
		 */
		'!node': function (success, error) {
			return this._continue(GCN.NodeAPI, null, success, error);
		},

		// ====================================================================
		// Pages
		// ====================================================================

		/**
		 * Returns page of the given id which resides in this folder.
		 * 
		 * @public
		 * @function
		 * @name page
		 * @memberOf FolderAPI
		 * @param {number}
		 *            id
		 * @param {function(PageAPI)=}
		 *            success Optional callback that will receive a
		 *            {@link PageAPI} object as its only argument.
		 * @param {function(GCNError):boolean=}
		 *            error Optional custom error handler.
		 * @return {PageAPI}
		 */
		'!page': function (id, success, error) {
			return this._continue(GCN.PageAPI, id, success, error);
		},

		/**
		 * Retreive a list of all pages this folder.
		 *
		 * @param {function(Array.PageAPI)=} success Optional callback that
		 *                                           will receive an array of
		 *                                           {@link PageAPI} objects as
		 *                                           its only argument.
		 * @param {function(GCNError):boolean=} error Optional custom error
		 *                                            handler.
		 */
		pages: function (success, error) {
			this._getItems('page', success, error);
		},

		/**
		 * Creates a new page inside this folder.
		 *
		 * @param {number} templateId The id of the template to be used for
		 *                            the page.
		 * @param {object} options Set all the options to create a page the
		 *                         following options are allowed:
		 * <pre>
		 * GCN.folder(4711).createPage(13, {
		 *     // set a language code for the new page like 'en', 'de', ...
		 *     // if you don't supply a language code the page will have
		 *     // no language assigned
		 *     language: 'en',
		 *     // id of the page this page should be a variant of
		 *     variantId: 42
		 *   });
		 * </pre>
		 * @param {function(PageAPI)=} success Optional callback that will
		 *                                     receive a {@link PageAPI} object
		 *                                     as its only argument.
		 * @param {function(GCNError):boolean=} error Optional custom error
		 *                                            handler.
		 * @return {PageAPI} The newly created page.
		 */
		createPage: function () {
			var args = Array.prototype.slice.call(arguments);
			var templateId = args[0];
			var options;
			var success;
			var error;
			var j = args.length;
			var i;

			// Determine `options', `success', `error'
			for (i = 1; i < j; ++i) {
				switch (jQuery.type(args[i])) {
				case 'function':
					if (success) {
						error = args[i];
					} else {
						success = args[i];
					}
					break;
				case 'object':
					options = args[i];
					break;
				}
			}

			var that = this;
			var page = that._continue(GCN.PageAPI)._procure();

			this._read(function () {
				if (!options) {
					options = {};
				}

				// default settings
				if (that.nodeId()) {
					options.nodeId = that.nodeId();
				}
				options.folderId   = that.id();
				options.templateId = templateId;

				that._authAjax({
					url   : GCN.settings.BACKEND_PATH + '/rest/page/create/',
					type  : 'POST',
					json  : options,
					error : function (xhr, status, msg) {
						GCN.handleHttpError(xhr, msg, error);
					},
					success : function (response) {
						if (GCN.getResponseCode(response) === 'OK') {
							var data = response.page;
							page._data    = data;
							page._fetched = true;
							page._removeFromTempCache(page);
							page._setHash(data.id)._addToCache();
							if (success) {
								that._invoke(success, [page]);
							}
						} else {
							page._die(GCN.getResponseCode(response));
							GCN.handleResponseError(response, error);
						}

						// Halt the call chain until this object has been fully
						// realized.
						page._vacate();
					}
				}, error);
			}, error);
		},

		// ====================================================================
		// Templates
		// ====================================================================

//		'!template': function (id, success, error) {
//			return this._continue(GCN.TemplateAPI, id, success, error);
//		},
//
//		'!templates': function (ids, success, error) {
//			//FIXME: Not implemented
//		},
//
//		createTemplate: function (settings, success, error) {
//			//FIXME: Not implemented
//		},

		/**
		 * Retreive a list of all files in this folder.
		 *
		 * @param {function(Array.FileAPI)=} success Optional callback that
		 *                                           will receive an array of
		 *                                           {@link FileAPI} objects as
		 *                                           its only argument.
		 * @param {function(GCNError):boolean=} error Optional custom error
		 *                                            handler.
		 */
		files: function (success, error) {
			this._getItems('file', success, error);
		},

		/**
		 * Retreive a list of all images in this folder.
		 *
		 * @param {function(Array.ImageAPI)=} success Optional callback that
		 *                                            will receive an array of
		 *                                            {@link ImageAPI} objects
		 *                                            as its only argument.
		 * @param {function(GCNError):boolean=} error Optional custom error
		 *                                            handler.
		 */
		images: function (success, error) {
			this._getItems('image', success, error);
		},

		// ====================================================================
		// Folders
		// ====================================================================

		/**
		 * @override
		 * @see ContentObjectAPI._loadParams
		 */
		'!_loadParams': function () {
			return jQuery.extend(DEFAULT_SETTINGS, this._settings);
		},

		/**
		 * @FIXME(petro) Why on do we need this method inside FolderAPI?
		 */
		'!folder': function (id, success, error) {
			return this._continue(GCN.FolderAPI, id, success, error);
		},

		/**
		 * Retreive a list of all sub folders of this folder.
		 *
		 * @param {function(Array.FolderAPI)=} success Optional callback that
		 *                                             will receive an array of
		 *                                             {@link FolderAPI}
		 *                                             objects as its only
		 *                                             argument.
		 * @param {function(GCNError):boolean=} error Optional custom error
		 *                                            handler.
		 */
		folders: function (success, error) {
			this._getItems('folder', success, error);
		},

		/**
		 * Create a sub folder within this folder, with the option of also
		 * automatically creating a startpage for this folder.
		 *
		 * @param {string} name the folder name
		 * @param {object} settings pass in an optional settings object
		 *                          possible options are:
		 *     <pre>
		 *     {
		 *        // optional description for the folder
		 *        description: 'this is my folder',
		 *        // set a publish directory for the folder
		 *        publishDir: '/this/is/my/folder/',
		 *        // adding a template id will automatically create a new
		 *        // startpage for the folder
		 *        templateId: 5,
		 *        // provide a language code for the start page. optional.
		 *        language: 'en',
		 *        // when true creating the folder will fail if a folder with
		 *        // that name exists. otherwise conflicting names will be
		 *        // postfixed with an increasing number. defaults to false.
		 *        failOnDuplicate: false
		 *     }
		 *     </pre>
		 * @param {function(FolderAPI)=} success Optional callback that
		 *                                       will receive a
		 *                                       {@link FolderAPI} object as
		 *                                       its only argument.
		 * @param {function(GCNError):boolean=} error Optional custom error
		 *                                            handler.
		 * @throws UNKNOWN_ARGUMENT Thrown when unexpected arguments are
		 *                          provided.
		 */
		createFolder: function () {
			var that = this;
			var success;
			var error;
			var settings;
			var name;
			var i;
			var j = arguments.length;

			// parse arguments
			for (i = 0; i < j; ++i) {
				switch (jQuery.type(arguments[i])) {
				case 'function':
					if (!success) {
						success = arguments[i];
					} else if (success && !error) {
						error = arguments[i];
					} else {
						GCN.error('UNKNOWN_ARGUMENT',
							'success and error handler already set. Don\'t ' +
							'know what to do with arguments[' + i + ']');
					}
					break;
				case 'object':
					if (!settings) {
						settings = arguments[i];
					} else {
						GCN.error('UNKNOWN_ARGUMENT',
							'settings already set. Don\'t know what to do ' +
							'with arguments[' + i + '] value ' + arguments[i]);
					}
					break;
				case 'string':
					if (!name) {
						name = arguments[i];
					} else {
						GCN.error('UNKNOWN_ARGUMENT',
							'name already set. Don\'t know what to do with ' +
							'arguments[' + i + '] value ' + arguments[i]);
					}
					break;
				default:
					GCN.error('UNKNOWN_ARGUMENT',
						'Don\'t know what to do with arguments[' + i + '] ' +
						'value ' + arguments[i]);
				}
			}

			// initialize basic settings object
			if (!settings) {
				settings = {};
			}

			// set default parameters
			settings.name = name;
			settings.motherId = this.id();
			if (this.nodeId()) {
				settings.nodeId = this.nodeId();
			}

			// automatically enable startpage generation if a template is set
			if (settings.templateId) {
				settings.startpage = true;
			}

			this._authAjax({
				url     : GCN.settings.BACKEND_PATH + '/rest/folder/create/',
				type    : 'POST',
				error   : error,
				json    : settings,
				success : function (response) {
					that._continue(GCN.FolderAPI, response.folder, success,
						error);
				}
			});
		},

		/**
		 * Get a URL for uploading files into this folder.
		 *
		 * @public
		 * @function
		 * @name uploadURL
		 * @memberOf FolderAPI
		 * @return {string} Rest API url for file uploading.
		 */
		'!uploadURL': function () {
			return (
				GCN.settings.BACKEND_PATH
				+ '/rest/file/createSimple.json?sid=' + GCN.sid
				+ '&folderId=' + this.id()
				+ GCN._getChannelParameter(this, '&')
			);
		},

		/**
		 * Get the upload URL that is capable of dealing with multipart form 
		 * data.
		 *
		 * @public
		 * @name multipartUploadURL
		 * @function
		 * @memberOf FolderAPI
		 * @param {boolean} applyContentWrapperFilter When true the reponse will 
		 *                  be wrapped so that it can be interpreted by various 
		 *                  upload implementations. 
		 * @param {string} filterContentType Define a custom content type that
		 *                  should be used for the server side implementation.
		 *                  The defined content type will modify the response
		 *                  'Content-Type' header value.
		 * @return {string} Rest API url for multipart file upload.
		 */
		'!multipartUploadURL' : function (applyContentWrapperFilter, filterContentType) {
			var restURL = GCN.settings.BACKEND_PATH
			            + '/rest/file/create.json?sid='
						+ GCN.sid;

			if (typeof applyContentWrapperFilter !== 'undefined') {
				if (jQuery.type(applyContentWrapperFilter) === 'boolean') {
					restURL += '&content-wrapper-filter='
					        + applyContentWrapperFilter;
				} else {
					GCN.error('INVALID_ARGUMENTS', 'the `multipartUploadURL()\' method ' +
						'only accepts boolean values for the `applyContentWrapperFilter\' parameter');
				}
			}

			if (filterContentType) {
				restURL += '&filter-contenttype=' + filterContentType;
			}

			return restURL;
		},

		/**
		 * This method will inspect the json and decide whether the onSuccess or
		 * onError should be called. A file or image api object will be passed
		 * to the success handler.
		 * 
		 * @TODO(petro): The success callback should not receive a second
		 *               argument containing messages. It is not consitanct with
		 *               out API.
		 * @ignore does not make sense for me to have this being called from implementers
		 * @public
		 * @name handleUploadResponse
		 * @memberOf FolderAPI
		 * @param {object}
		 *            response The REST-API reponse object that was given in
		 *            response to the upload request.
		 * @param {function(FileAPI,
		 *            Array.string)=} success Optional callback that will
		 *            receive as its first argument, a {@link FileAPI} object of
		 *            the uploaded file. The second argument is an array of
		 *            message strings returned in response to the upload
		 *            request.
		 * @param {function(GCNError):boolean=}
		 *            error Optional custom error handler.
		 */
		'!handleUploadResponse': function (response, success, error) {
			if (GCN.getResponseCode(response) === 'OK') {
				if (success) {
					var that = this;
					GCN.file(response.file, function (file) {
						that._invoke(success, [file, response.messages]);
					}, error);
				}
			} else {
				GCN.handleResponseError(response, error);
			}
		},

		/**
		 * Fetch items inside this folder.
		 *
		 * @param {string} type One of: "file"
		 *                              "folder"
		 *                              "page"
		 *                              "image"
		 *                              "template"
		 * @param {function(Array.<ContentObjectAPI>)} success Callback that
		 *                                              will receive an array
		 *                                              of the requested items.
		 * @param {function(GCNError):boolean=} success Custom error handler.
		 */
		'!_getItems': function (type, success, error) {
			var that = this;

			if (!this._fetched) {
				this._read(function () {
					that._getItems(type, success, error);
				}, error);

				return;
			}

			var api;
			var url = GCN.settings.BACKEND_PATH + '/rest/' + this._type
				    + '/getItems/' + this.id() + '?type=' + type
					+ GCN._getChannelParameter(that, '&');

			switch (type) {
			case 'page':
				api = GCN.PageAPI;
				break;
			case 'file':
				api = GCN.FileAPI;
				break;
			case 'image':
				api = GCN.ImageAPI;
				break;
			case 'folder':
				api = GCN.FolderAPI;
				url = GCN.settings.BACKEND_PATH + '/rest/' + this._type
					+ '/getFolders/' + this.id()
					+ GCN._getChannelParameter(that);
				break;
			default:
				var err = GCN.createError('UNEXPECTED_TYPE',
					'Unknown object type ' + type, this);

				GCN.handleError(err, error);
				return;
			}

			this._authAjax({
				url     : url,
				type    : 'GET',
				error   : error,
				success : function (response) {
					var items = [];
					var i;
					var j = response.numItems;

					for (i = 0; i < j; i++) {
						items.push(that._continue(api,
							(type === 'folder') ? response.folders[i] :
							                      response.items[i],
							null, error));
					}

					that._invoke(success, [items]);
				}
			});
		}

	});

	/**
	* Creates a new instance of FolderAPI. See the {@link FolderAPI} constructor for detailed information.
	* 
	* @function
	* @name folder
	* @memberOf GCN
	* @see FolderAPI
	*/
	GCN.folder = GCN.exposeAPI(FolderAPI);
	GCN.FolderAPI = FolderAPI;

}(GCN));
(function (GCN) {

	'use strict';

	/**
	 * @private
	 * @const
	 * @type {string}
	 */
	var GCN_REPOSITORY_ID = 'com.gentics.aloha.GCN.Page';

	/**
	 * jQuery selector string for GCN internal links.
	 * @const
	 * @type {string}
	 */
	var GCN_LINK_SELECTOR
			= 'a[data-gentics-aloha-repository="' + GCN_REPOSITORY_ID + '"],'
			+ 'a[data-gentics-gcn-url]';

	/**
	 * @private
	 * @const
	 * @type {object.<string, boolean>} Default page settings.
	 */
	var DEFAULT_SETTINGS = {
		// Load folder information
		folder: true,

		// Lock page when loading it
		update: true,

		// Have language variants be included in the page response.
		langvars: true,

		// Have page variants be included in the page response.
		pagevars: true
	};

	/**
	 * Checks whether the given tag is a magic link block.
	 *
	 * @param {TagAPI} tag A tag that must already have been fetched.
	 * @param {Object} constructs Set of constructs.
	 * @return {boolean} True if the given tag's constructId is equal to the
	 *                   `MAGIC_LINK' value.
	 */
	function isMagicLinkTag(tag, constructs) {
		return !!(constructs[GCN.settings.MAGIC_LINK]
					&& (constructs[GCN.settings.MAGIC_LINK].constructId
						=== tag.prop('constructId')));
	}

	/**
	 * Given a page object, returns a jQuery set containing DOM elements for
	 * each of the page's editable that is attached to the document.
	 *
	 * @param {PageAPI} page A page object.
	 * @return {jQuery.<HTMLElement>} A jQuery set of editable DOM elements.
	 */
	function getEditablesInDocument(page) {
		var id;
		var $editables = jQuery();
		var editables = page._editables;
		for (id in editables) {
			if (editables.hasOwnProperty(id)) {
				$editables = $editables.add('#' + id);
			}
		}
		return $editables;
	}

	/**
	 * Returns all editables associated with the given page that have been
	 * rendered in the document for editing.
	 *
	 * @param {PageAPI} page
	 * @return {object} A set of editable objects.
	 */
	function getEditedEditables(page) {
		return page._editables;
	}

	/**
	 * Derives a list of the blocks that were rendered inside at least one of
	 * the given page's edit()ed editables.
	 *
	 * @param {PageAPI} page Page object.
	 * @return {Array.<object>} The set of blocks contained in any of the
	 *                          page's rendered editables.
	 */
	function getRenderedBlocks(page) {
		var editables = getEditedEditables(page);
		var id;
		var renderedBlocks = [];
		for (id in editables) {
			if (editables.hasOwnProperty(id)) {
				if (editables[id]._gcnContainedBlocks) {
					renderedBlocks = renderedBlocks.concat(
						editables[id]._gcnContainedBlocks
					);
				}
			}
		}
		return renderedBlocks;
	}

	/**
	 * Gets the DOM element associated with the given block.
	 *
	 * @param {object} block
	 * @return {?jQuery.<HTMLElement>} A jQuery unit set of the block's
	 *                                 corresponding DOM element, or null if no
	 *                                 element for the given block exists in
	 *                                 the document.
	 */
	function getElement(block) {
		var $element = jQuery('#' + block.element);
		return $element.length ? $element : null;
	}

	/**
	 * Retrieves a jQuery set of all link elements that are contained in
	 * editables associated with the given page.
	 *
	 * @param {PageAPI} page
	 * @return {jQuery.<HTMLElement>} A jQuery set of link elements.
	 */
	function getEditableLinks(page) {
		return getEditablesInDocument(page).find('a');
	}

	/**
	 * Determines all blocks that no longer need their tags to be kept in the
	 * given page's tag list.
	 *
	 * @param {PageAPI} page
	 * @param {function(Array.<object>)} success A callback function that
	 *                                           receives a list of obsolete
	 *                                           blocks.
	 * @param {function(GCNError):boolean=} error Optional custom error
	 *                                            handler.
	 */
	function getObsoleteBlocks(page, success, error) {
		var blocks = getRenderedBlocks(page);
		if (0 === blocks.length) {
			success([]);
			return;
		}
		var $links = getEditableLinks(page);
		var numToProcess = blocks.length;
		var obsolete = [];
		var onSuccess = function () {
			if ((0 === --numToProcess) && success) {
				success(obsolete);
			}
		};
		var onError = function (GCNError) {
			if (error) {
				return error(GCNError);
			}
		};
		page.constructs(function (constructs) {
			var processTag = function (block) {
				page.tag(block.tagname, function (tag) {
					if (isMagicLinkTag(tag, constructs) && !getElement(block)) {
						obsolete.push(block);
					}
					onSuccess();
				}, onError);
			};
			var i;
			for (i = 0; i < blocks.length; i++) {
				processTag(blocks[i]);
			}
		});
	}

	/**
	 * Checks whether or not the given block has a corresponding element in the
	 * document DOM.
	 *
	 * @private
	 * @static
	 * @param {object}
	 * @return {boolean} True if an inline element for this block exists.
	 */
	function hasInlineElement(block) {
		return !!getElement(block);
	}

	/**
	 * Matches "aloha-*" class names.
	 *
	 * @const
	 * @type {RegExp}
	 */
	var ALOHA_CLASS_NAMES = /\baloha-[a-z0-9\-\_]*\b/gi;

	/**
	 * Strips unwanted names from the given className string.
	 *
	 * All class names beginning with "aloha-block*" will be removed.
	 *
	 * @param {string} classes Space seperated list of classes.
	 * @return {string} Sanitized classes string.
	 */
	function cleanBlockClasses(classes) {
		return classes ? jQuery.trim(classes.replace(ALOHA_CLASS_NAMES, ''))
		               : '';
	}

	/**
	 * Determines the backend object that was set to the given link.
	 *
	 * @param {jQuery.<HTMLElement>} $link A link in an editable.
	 * @return {Object} An object containing the gtxalohapagelink part keyword
	 *                  and value.  The keyword may be either be "url" or
	 *                  "fileurl" depending on the type of object linked to.
	 *                  The value may be a string url ("http://...") for
	 *                  external links or an integer for internal links.
	 */
	function getTagPartsFromLink($link) {
		var linkData = $link.attr('data-gentics-aloha-object-id');
		var tagparts = {
			text: $link.html(),
			title: $link.attr('title'),
			target: $link.attr('target'),
			'class': cleanBlockClasses($link.attr('class'))
		};

		if (!linkData) {
			tagparts.url = $link.attr('href');
			return tagparts;
		}

		var idParts = linkData.split('.');

		if (2 !== idParts.length) {
			tagparts.url = linkData;
		} else if ('10007' === idParts[0]) {
			tagparts.url = parseInt(idParts[1], 10);
			tagparts.fileurl = 0;
		} else if ('10008' === idParts[0] || '10011' === idParts[0]) {
			tagparts.url = 0;
			tagparts.fileurl = parseInt(idParts[1], 10);
		} else {
			tagparts.url = $link.attr('href');
		}

		return tagparts;
	}

	/**
	 * Checks whether a page object has a corresponding tag for a given link
	 * DOM element.
	 *
	 * @param {PageAPI} page The page object in which to look for the link tag.
	 * @param {jQuery.<HTMLElement>} $link jQuery unit set containing a link
	 *                                     DOM element.
	 * @return {boolean} True if there is a tag on the page that corresponds with
	 *                   the givn link.
	 */
	function hasTagForLink(page, $link) {
		var id = $link.attr('id');
		return !!(id && page._getBlockById(id));
	}

	/**
	 * Checks whether or not the given part has a part type of the given
	 * name
	 *
	 * @param {TagAPI} tag
	 * @param {string} part Part name
	 * @return {boolean} True of part exists in the given tag.
	 */
	function hasTagPart(tag, part) {
		return !!tag._data.properties[part];
	}

	/**
	 * Updates the parts of a tag in the page object that corresponds to the
	 * given link DOM element.
	 *
	 * @param {PageAPI} page
	 * @param {jQuery.<HTMLElement>} $link jQuery unit set containing a link
	 *                                     DOM element.
	 */
	function updateTagForLink(page, $link) {
		var block = page._getBlockById($link.attr('id'));
		// ASSERT(block)
		var tag = page.tag(block.tagname);
		var parts = getTagPartsFromLink($link);
		var part;
		for (part in parts) {
			if (parts.hasOwnProperty(part) && hasTagPart(tag, part)) {
				tag.part(part, parts[part]);
			}
		}
	}

	/**
	 * Creates a new tag for the given link in the page.
	 *
	 * @param {PageAPI} page
	 * @param {jQuery.<HTMLElement>} $link jQuery unit set containing a link
	 *                                     element.
	 * @param {function} success Callback function that whill be called when
	 *                           the new tag is created.
	 * @param {function(GCNError):boolean=} error Optional custom error
	 *                                            handler.
	 */
	function createTagForLink(page, $link, success, error) {
		page.createTag({
			keyword: GCN.settings.MAGIC_LINK,
			magicValue: $link.html()
		}).edit(function (html, tag) {
			// Copy over the rendered id value for the link so that we can bind
			// the link in the DOM with the newly created block.
			$link.attr('id', jQuery(html).attr('id'));
			updateTagForLink(page, $link);
			success();
		}, error);
	}

	/**
	 * Identifies internal GCN links in the given page's rendered editables,
	 * and updates their corresponding content tags, or create new tags for the
	 * if they are new links.
	 *
	 *  @param {PageAPI} page
	 *  @param {function} success
	 *  @param {function} error
	 */
	function processGCNLinks(page, success, error) {
		var $links = getEditableLinks(page);
		var $gcnlinks = $links.filter(GCN_LINK_SELECTOR);
		if (0 === $gcnlinks.length) {
			if (success) {
				success();
			}
			return;
		}
		var numToProcess = $gcnlinks.length;
		var onSuccess = function () {
			if ((0 === --numToProcess) && success) {
				success();
			}
		};
		var onError = function (GCNError) {
			if (error) {
				return error(GCNError);
			}
		};
		var i;
		for (i = 0; i < $gcnlinks.length; i++) {
			if (hasTagForLink(page, $gcnlinks.eq(i))) {
				updateTagForLink(page, $gcnlinks.eq(i));
				onSuccess();
			} else {
				createTagForLink(page, $gcnlinks.eq(i), onSuccess, onError);
			}
		}
	}

	/**
	 * Adds the given blocks into the page's list of blocks that are to be
	 * deleted when the page is saved.
	 *
	 * @param {PageAPI} page
	 * @param {Array.<object>} blocks Blocks that are to be marked for deletion.
	 */
	function deleteBlocks(page, blocks) {
		blocks = jQuery.isArray(blocks) ? blocks : [blocks];
		var i;
		for (i = 0; i < blocks.length; i++) {
			if (-1 ===
					jQuery.inArray(blocks[i].tagname, page._deletedBlocks)) {
				page._deletedBlocks.push(blocks[i].tagname);
			}
			delete page._blocks[blocks[i].element];
		}
	}

	/**
	 * Removes all tags on the given page which belong to links that are no
	 * longer present in any of the page's rendered editables.
	 *
	 * @param {PageAPI} page
	 * @param {function} success Callback function that will be invoked when
	 *                           all obsolete tags have been successfully
	 *                           marked for deletion.
	 * @param {function(GCNError):boolean=} error Optional custom error
	 *                                            handler.
	 */
	function deleteObsoleteLinkTags(page, success, error) {
		getObsoleteBlocks(page, function (obsolete) {
			deleteBlocks(page, obsolete);
			if (success) {
				success();
			}
		}, error);
	}

	/**
	 * Searches for the an Aloha editable object of the given id.
	 *
	 * @TODO: Once Aloha.getEditableById() is patched to not cause an
	 *        JavaScript exception if the element for the given ID is not found
	 *        then we can deprecate this function and use Aloha's instead.
	 *
	 * @static
	 * @param {string} id Id of Aloha.Editable object to find.
	 * @return {Aloha.Editable=} The editable object, if wound; otherwise null.
	 */
	function getAlohaEditableById(id) {
		var Aloha = (typeof window !== 'undefined') && window.Aloha;
		if (!Aloha) {
			return null;
		}

		// If the element is a textarea then route to the editable div.
		var element = jQuery('#' + id);
		if (element.length &&
				element[0].nodeName.toLowerCase() === 'textarea') {
			id += '-aloha';
		}

		var editables = Aloha.editables;
		var j = editables.length;
		while (j) {
			if (editables[--j].getId() === id) {
				return editables[j];
			}
		}

		return null;
	}

	/**
	 * For a given list of editables and a list of blocks, determines in which
	 * editable each block is contained.  The result is a map of block sets.
	 * Each of these sets of blocks are mapped against the id of the editable
	 * in which they are rendered.
	 *
	 * @param {string} content The rendered content in which both the list of
	 *                         editables, and blocks are contained.
	 * @param {Array.<object>} editables A list of editables contained in the
	 *                                   content.
	 * @param {Array.<object>} blocks A list of blocks containd in the content.
	 * @return {object<string, Array>} A object whose keys are editable ids,
	 *                                  and whose values are arrays of blocks
	 *                                  contained in the corresponding
	 *                                  editable.
	 */
	function categorizeBlocksAgainstEditables(content, editables, blocks) {
		var i;
		var $content = jQuery('<div>' + content + '</div>');
		var sets = {};
		var editableId;

		var editablesSelectors = [];
		for (i = 0; i < editables.length; i++) {
			editablesSelectors.push('#' + editables[i].element);
		}

		var markerClass = 'aloha-editable-tmp-marker__';
		var $editables = $content.find(editablesSelectors.join(','));
		$editables.addClass(markerClass);

		var $block;
		var $parent;
		for (i = 0; i < blocks.length; i++) {
			$block = $content.find('#' + blocks[i].element);
			if ($block.length) {
				$parent = $block.closest('.' + markerClass);
				if ($parent.length) {
					editableId = $parent.attr('id');
					if (editableId) {
						if (!sets[editableId]) {
							sets[editableId] = [];
						}
						sets[editableId].push(blocks[i]);
					}
				}
			}
		}

		return sets;
	}

	/**
	 * Causes the given editables to be tracked, so that when the content
	 * object is saved, these editables will be processed.
	 *
	 * @private
	 * @param {PageAPI} page
	 * @param {Array.<object>} editables A set of object representing
	 *                                   editable tags that have been
	 *                                   rendered.
	 */
	function trackEditables(page, editables) {
		if (!page.hasOwnProperty('_editables')) {
			page._editables = {};
		}
		var i;
		for (i = 0; i < editables.length; i++) {
			page._editables[editables[i].element] = editables[i];
		}
	}

	/**
	 * Causes the given blocks to be tracked so that when the content object is
	 * saved, these editables will be processed.
	 *
	 * @private
	 * @param {PageAPI} page
	 * @param {Array.<object>} blocks An set of object representing block
	 *                                tags that have been rendered.
	 */
	function trackBlocks(page, blocks) {
		if (!page.hasOwnProperty('_blocks')) {
			page._blocks = {};
		}
		var i;
		for (i = 0; i < blocks.length; i++) {
			page._blocks[blocks[i].element] = blocks[i];
		}
	}

	/**
	 * Associates a list of blocks with an editable so that it can later be
	 * determined which blocks are contained inside which editable.
	 *
	 * @param object
	 */
	function associateBlocksWithEditable(editable, blocks) {
		editable._gcnContainedBlocks = editable._gcnContainedBlocks
		                             ? editable._gcnContainedBlocks.concat(blocks)
		                             : blocks;
	}

	/**
	 * Extracts the editables and blocks that have been rendered from the
	 * REST API render call's response data, and stores them in the page.
	 *
	 * @param {PageAPI} page The page inwhich to track the incoming tags.
	 * @param {object} data Raw data containing editable and block tags
	 * information.
	 * @return {object} A object containing to lists: one list of blocks, and
	 *                  another of editables.
	 */
	function trackRenderedTags(page, data) {
		var tags = GCN.TagContainerAPI.getEditablesAndBlocks(data);

		var containment = categorizeBlocksAgainstEditables(
			data.content,
			tags.editables,
			tags.blocks
		);

		trackEditables(page, tags.editables);
		trackBlocks(page, tags.blocks);

		jQuery.each(containment, function (editable, blocks) {
			if (page._editables[editable]) {
				associateBlocksWithEditable(page._editables[editable], blocks);
			}
		});

		return tags;
	}

	/**
	 * @private
	 * @const
	 * @type {number}
	 */
	//var TYPE_ID = 10007;

	/**
	 * @private
	 * @const
	 * @type {Enum}
	 */
	var STATUS = {

		// page was not found in the database
		NOTFOUND: -1,

		// page is locally modified and not yet (re-)published
		MODIFIED: 0,

		// page is marked to be published (dirty)
		TOPUBLISH: 1,

		// page is published and online
		PUBLISHED: 2,

		// Page is offline
		OFFLINE: 3,

		// Page is in the queue (publishing of the page needs to be affirmed)
		QUEUE: 4,

		// page is in timemanagement and outside of the defined timespan
		// (currently offline)
		TIMEMANAGEMENT: 5,

		// page is to be published at a given time (not yet)
		TOPUBLISH_AT: 6
	};

	/**
	 * @class
	 * @name PageAPI
	 * @extends ContentObjectAPI
	 * @extends TagContainerAPI
	 * 
	 * @param {number|string}
	 *            id of the page to be loaded
	 * @param {function(ContentObjectAPI))=}
	 *            success Optional success callback that will receive this
	 *            object as its only argument.
	 * @param {function(GCNError):boolean=}
	 *            error Optional custom error handler.
	 * @param {object}
	 *            settings additional settings for object creation. These
	 *            correspond to options available from the REST-API and will
	 *            extend or modify the PageAPI object.
	 *            <dl>
	 *            <dt>update: true</dt>
	 *            <dd>Whether the page should be locked in the backend when
	 *            loading it. default: true</dd>
	 *            <dt>template: true</dt>
	 *            <dd>Whether the template information should be embedded in
	 *            the page object. default: true</dd>
	 *            <dt>folder: true</dt>
	 *            <dd>Whether the folder information should be embedded in the
	 *            page object. default: true <b>WARNING</b>: do not turn this
	 *            option off - it will leave the API in a broken state.</dd>
	 *            <dt>langvars: false</dt>
	 *            <dd>When the language variants shall be embedded in the page
	 *            response. default: false</dd>
	 *            <dt>workflow: false</dt>
	 *            <dd>When the workflow information shall be embedded in the
	 *            page response. default: false</dd>
	 *            <dt>pagevars: false</dt>
	 *            <dd>When the page variants shall be embedded in the page
	 *            response. Page variants will contain folder information.
	 *            default: false</dd>
	 *            <dt>translationstatus: false</dt>
	 *            <dd>Will return information on the page's translation status.
	 *            default: false</dd>
	 *            </dl>
	 */
	var PageAPI = GCN.defineChainback({
		/** @lends PageAPI */

		__chainbacktype__: 'PageAPI',
		_extends: [ GCN.TagContainerAPI, GCN.ContentObjectAPI ],
		_type: 'page',

		/**
		 * A hash set of block tags belonging to this page.  This set grows as
		 * this page's tags are rendered.
		 *
		 * @private
		 * @type {Array.<object>}
		 */
		_blocks: {},

		/**
		 * A hash set of editable tags belonging to this page.  This set grows
		 * as this page's tags are rendered.
		 *
		 * @private
		 * @type {Array.<object>}
		 */
		_editables: {},

		/**
		 * Writable properties for the page object. Currently the following
		 * properties are writeable: cdate, description, fileName, folderId,
		 * name, priority, templateId. WARNING: changing the folderId might not
		 * work as expected.
		 * 
		 * @type {Array.string}
		 * @const
		 */
		WRITEABLE_PROPS: [
		                  'cdate',
		                  'description',
		                  'fileName',
		                  'folderId', // @TODO Check if moving a page is
		                              //       implemented correctly.
		                  'name',
		                  'priority',
		                  'templateId',
		                  'timeManagement'
		                  ],

		/**
		 * @type {object} Constraints for writeable props
		 * @const
		 *
		 */
		WRITEABLE_PROPS_CONSTRAINTS: {
			'name': {
				maxLength: 255
			}
		},

		/**
		 * Gets all blocks that are associated with this page.
		 *
		 * It is important to note that the set of blocks in the returned array
		 * will only include those that are the returned by the server when
		 * calling  edit() on a tag that belongs to this page.
		 *
		 * @return {Array.<object>} The set of blocks that have been
		 *                          initialized by calling edit() on one of
		 *                          this page's tags.
		 */
		'!blocks': function () {
			return this._blocks;
		},

		/**
		 * Retrieves a block with the given id among the blocks that are
		 * tracked by this page content object.
		 *
		 * @private
		 * @param {string} id The block's id.
		 * @return {?object} The block data object.
		 */
		'!_getBlockById': function (id) {
			return this._blocks[id];
		},

		/**
		 * Extracts the editables and blocks that have been rendered from the
		 * REST API render call's response data, and stores them in the page.
		 *
		 * @override
		 */
		'!_processRenderedTags': function (data) {
			return trackRenderedTags(this, data);
		},

		/**
		 * Processes this page's tags in preparation for saving.
		 *
		 * The preparation process:
		 *
		 * 1. For all editables associated with this page, determine which of
		 *    their blocks have been rendered into the DOM for editing so that
		 *    changes to the DOM can be reflected in the corresponding data
		 *    structures before pushing the tags to the server.
		 *
		 * 2.
		 *
		 * Processes rendered tags, and updates the `_blocks' and `_editables'
		 * arrays accordingly.  This function is called during pre-saving to
		 * update this page's editable tags.
		 *
		 * @private
		 */
		'!_prepareTagsForSaving': function (success, error) {
			if (!this.hasOwnProperty('_deletedBlocks')) {
				this._deletedBlocks = [];
			}
			var page = this;
			processGCNLinks(page, function () {
				deleteObsoleteLinkTags(page, function () {
					page._updateEditableBlocks();
					if (success) {
						success();
					}
				}, error);
			}, error);
		},

		/**
		 * Writes the contents of editables back into their corresponding tags.
		 * If a corresponding tag cannot be found for an editable, a new one
		 * will be created for it.
		 *
		 * A reference for each editable tag is then added to the `_shadow'
		 * object in order that the tag will be sent with the save request.
		 *
		 * @private
		 */
		'!_updateEditableBlocks': function () {
			var $element;
			var id;
			var editables = this._editables;
			var tags = this._data.tags;
			var tagname;
			var html;
			var alohaEditable;
			var $cleanElement;
			var customSerializer;

			for (id in editables) {
				if (editables.hasOwnProperty(id)) {
					$element = jQuery('#' + id);

					// Because the editable may not have have been rendered into
					// the document DOM.
					if (0 === $element.length) {
						continue;
					}

					tagname = editables[id].tagname;

					if (!tags[tagname]) {
						tags[tagname] = {
							name       : tagname,
							active     : true,
							properties : {}
						};
					} else {
						// Because it is sensible to assume that every editable
						// that was rendered for editing is intended to be an
						// activate tag.
						tags[tagname].active = true;
					}

					// Because editables that have been aloha()fied, must have
					// their contents retrieved by getContents() in order to get
					// clean HTML.

					alohaEditable = getAlohaEditableById(id);

					if (alohaEditable) {
						// Avoid the unnecessary overhead of custom editable
						// serialization by calling html ourselves.
						$cleanElement = jQuery('<div>').append(
							alohaEditable.getContents(true)
						);
						alohaEditable.setUnmodified();
						// Apply the custom editable serialization as the last step.
						customSerializer = window.Aloha.Editable.getContentSerializer();
						html = this.encode($cleanElement, customSerializer);
					} else {
						html = this.encode($element);
					}

					tags[tagname].properties[editables[id].partname] = {
						stringValue: html,
						type: 'RICHTEXT'
					};

					this._update('tags.' + GCN.escapePropertyName(tagname),
						tags[tagname]);
				}
			}
		},

		/**
		 * @see ContentObjectAPI.!_loadParams
		 */
		'!_loadParams': function () {
			return jQuery.extend(DEFAULT_SETTINGS, this._settings);
		},

		/**
		 * Get this page's template.
		 *
		 * @public
		 * @function
		 * @name template
		 * @memberOf PageAPI
		 * @param {funtion(TemplateAPI)=} success Optional callback to receive
		 *                                        a {@link TemplateAPI} object
		 *                                        as the only argument.
		 * @param {function(GCNError):boolean=} error Optional custom error
		 *                                            handler.
		 * @return {TemplateAPI} This page's parent template.
		 */
		'!template': function (success, error) {
			var id = this._fetched ? this.prop('templateId') : null;
			return this._continue(GCN.TemplateAPI, id, success, error);
		},

		/**
		 * Cache of constructs for this page.
		 * Should be cleared when page is saved.
		 */
		_constructs: null,

		/**
		 * Retrieve the list of constructs of the tag that are used in this
		 * page.
		 *
		 * Note that tags that have been created on this page locally, but have
		 * yet to be persisted to the server (unsaved tags), will not have their
		 * constructs included in the list unless their constructs are used by
		 * other saved tags.
		 */
		'!constructs': function (success, error) {
			var page = this;
			if (page._constructs) {
				return success(page._constructs);
			}
			page._authAjax({
				url: GCN.settings.BACKEND_PATH
				     + '/rest/construct/list.json?pageId=' + page.id(),
				type: 'GET',
				error: function (xhr, status, msg) {
					GCN.handleHttpError(xhr, msg, error);
				},
				success: function (response) {
					if (GCN.getResponseCode(response) === 'OK') {
						page._constructs = GCN.mapConstructs(response.constructs);
						page._invoke(success, [page._constructs]);
					} else {
						GCN.handleResponseError(response, error);
					}
				}
			});
		},

		/**
		 * @override
		 * @see ContentObjectAPI._save
		 */
		'!_save': function (settings, success, error) {
			var page = this;
			this._fulfill(function () {
				page._read(function () {
					var fork = page._fork();
					fork._prepareTagsForSaving(function () {
						GCN.pub('page.before-save', fork);
						fork._persist(settings, function () {
							if (success) {
								page._constructs = null;
								page._invoke(success, [page]);
							}
							fork._merge();
						}, error);
					}, error);
				}, error);
			}, error);
		},

		//---------------------------------------------------------------------
		// Surface the tag container methods that are applicable for GCN page
		// objects.
		//---------------------------------------------------------------------

		/**
		 * Creates a tag of a given tagtype in this page.
		 * The first parameter should either be the construct keyword or ID,
		 * or an object containing exactly one of the following property sets:<br/>
		 * <ol>
		 *   <li><i>keyword</i> to create a tag based on the construct with given keyword</li>
		 *   <li><i>constructId</i> to create a tag based on the construct with given ID</li>
		 *   <li><i>sourcePageId</i> and <i>sourceTagname</i> to create a tag as copy of the given tag from the page</li>
		 * </ol>
		 *
		 * Exmaple:
		 * <pre>
		 *  createTag('link', onSuccess, onError);
		 * </pre>
		 * or
		 * <pre>
		 *  createTag({keyword: 'link', magicValue: 'http://www.gentics.com'}, onSuccess, onError);
		 * </pre>
		 * or
		 * <pre>
		 *  createTag({sourcePageId: 4711, sourceTagname: 'link'}, onSuccess, onError);
		 * </pre>
		 *
		 * @public
		 * @function
		 * @name createTag
		 * @memberOf PageAPI
		 * @param {string|number|object} construct either the keyword of the
		 *                               construct, or the ID of the construct
		 *                               or an object with the following
		 *                               properties
		 *                               <ul>
		 *                                <li><i>keyword</i> keyword of the construct</li>
		 *                                <li><i>constructId</i> ID of the construct</li>
		 *                                <li><i>magicValue</i> magic value to be filled into the tag</li>
		 *                                <li><i>sourcePageId</i> source page id</li>
		 *                                <li><i>sourceTagname</i> source tag name</li>
		 *                               </ul>
		 * @param {function(TagAPI)=} success Optional callback that will
		 *                                    receive the newly created tag as
		 *                                    its only argument.
		 * @param {function(GCNError):boolean=} error Optional custom error
		 *                                            handler.
		 * @return {TagAPI} The newly created tag.
		 * @throws INVALID_ARGUMENTS
		 */
		'!createTag': function () {
			return this._createTag.apply(this, arguments);
		},

		/**
		 * Deletes the specified tag from this page.
		 * You should pass a keyword here not an Id.
		 * 
		 * Note: Due to how the underlying RestAPI layer works,
		 * the success callback will also be called if the specified tag
		 * does not exist.
		 * 
		 * @public
		 * @function
		 * @memberOf PageAPI
		 * @param {string}
		 *            keyword The keyword of the tag to be deleted.
		 * @param {function(PageAPI)=}
		 *            success Optional callback that receive this object as its
		 *            only argument.
		 * @param {function(GCNError):boolean=}
		 *            error Optional custom error handler.
		 */
		removeTag: function () {
			this._removeTag.apply(this, arguments);
		},

		/**
		 * Deletes a set of tags from this page.
		 * 
		 * @public
		 * @function
		 * @memberOf PageAPI
		 * @param {Array.
		 *            <string>} keywords The keywords of the tags to be deleted.
		 * @param {function(PageAPI)=}
		 *            success Optional callback that receive this object as its
		 *            only argument.
		 * @param {function(GCNError):boolean=}
		 *            error Optional custom error handler.
		 */
		removeTags: function () {
			this._removeTags.apply(this, arguments);
		},

		/**
		 * Marks the page as to be taken offline. This method will change the
		 * state of the page object.
		 *
		 * @public
		 * @function
		 * @memberOf PageAPI
		 * @param {funtion(PageAPI)=} success Optional callback to receive this
		 *                                    page object as the only argument.
		 * @param {function(GCNError):boolean=} error Optional custom error
		 *                                            handler.
		 */
		takeOffline: function (success, error) {
			var that = this;

			this._read(function () {
				that._update('status', STATUS.OFFLINE, error);
				if (success) {
					that._save(null, success, error);
				}
			}, error);
		},

		/**
		 * Trigger publish process for the page.
		 *
		 * @public
		 * @function
		 * @memberOf PageAPI
		 * @param {funtion(PageAPI)=} success Optional callback to receive this
		 *                                    page object as the only argument.
		 * @param {function(GCNError):boolean=} error Optional custom error
		 *                                            handler.
		 */
		publish: function (success, error) {
			var page = this;
			GCN.pub('page.before-publish', page);
			this._fulfill(function () {
				page._authAjax({
					url: GCN.settings.BACKEND_PATH + '/rest/' + page._type +
					     '/publish/' + page.id(),
					type: 'POST',
					json: {}, // There needs to be at least empty content
					          // because of a bug in Jersey.
					success: function (response) {
						page._data.status = STATUS.PUBLISHED;
						if (success) {
							page._invoke(success, [page]);
						}
					},
					error: error
				});
			});
		},

		/**
		 * Renders a preview of the current page.
		 * 
		 * @public
		 * @function
		 * @memberOf PageAPI
		 * @param {function(string,
		 *            PageAPI)} success Callback to receive the rendered page
		 *            preview as the first argument, and this page object as the
		 *            second.
		 * @param {function(GCNError):boolean=}
		 *            error Optional custom error handler.
		 */
		preview: function (success, error) {
			var that = this;

			this._read(function () {
				that._authAjax({
					url: GCN.settings.BACKEND_PATH + '/rest/' + that._type +
					     '/preview/',
					json: {
						page: that._data // @FIXME Shouldn't this a be merge of
						                 //        the `_shadow' object and the
										 //        `_data'.
					},
					type: 'POST',
					error: error,
					success: function (response) {
						if (success) {
							GCN._handleContentRendered(response.preview, that,
								function (html) {
									that._invoke(success, [html, that]);
								});
						}
					}
				});
			}, error);
		},

		/**
		 * Unlocks the page when finishing editing
		 * 
		 * @public
		 * @function
		 * @memberOf PageAPI
		 * @param {funtion(PageAPI)=}
		 *            success Optional callback to receive this page object as
		 *            the only argument.
		 * @param {function(GCNError):boolean=}
		 *            error Optional custom error handler.
		 */
		unlock: function (success, error) {
			var that = this;
			this._fulfill(function () {
				that._authAjax({
					url: GCN.settings.BACKEND_PATH + '/rest/' + that._type +
					     '/cancel/' + that.id(),
					type: 'POST',
					json: {}, // There needs to be at least empty content
					          // because of a bug in Jersey.
					error: error,
					success: function (response) {
						if (success) {
							that._invoke(success, [that]);
						}
					}
				});
			});
		},

		/**
		 * @see GCN.ContentObjectAPI._processResponse
		 */
		'!_processResponse': function (data) {
			jQuery.extend(this._data, data[this._type]);

			// if data contains page variants turn them into page objects
			if (this._data.pageVariants) {
				var pagevars = [];
				var i;
				for (i = 0; i < this._data.pageVariants.length; i++) {
					pagevars.push(this._continue(GCN.PageAPI,
						this._data.pageVariants[i]));
				}
				this._data.pageVariants = pagevars;
			}
		},

		/**
		 * @override
		 */
		'!_removeAssociatedTagData': function (tagid) {
			var block;
			for (block in this._blocks) {
				if (this._blocks.hasOwnProperty(block) &&
						this._blocks[block].tagname === tagid) {
					delete this._blocks[block];
				}
			}

			var editable;
			for (editable in this._editables) {
				if (this._editables.hasOwnProperty(editable) &&
						this._editables[editable].tagname === tagid) {
					delete this._editables[editable];
				}
			}
		}

	});

	/**
	 * Creates a new instance of PageAPI.
	 * See the {@link PageAPI} constructor for detailed information.
	 * 
	 * @function
	 * @name page
	 * @memberOf GCN
	 * @see PageAPI
	 */
	GCN.page = GCN.exposeAPI(PageAPI);
	GCN.PageAPI = PageAPI;

	GCN.PageAPI.trackRenderedTags = trackRenderedTags;

}(GCN));
(function (GCN) {

	'use strict';

	/**
	 * <strong>WARNING!</strong> Currently the template API is still in
	 * development and has no specific implementation. Do not use the
	 * TemplateAPI as it is subject to change.
	 * 
	 * @class
	 * @name TemplateAPI
	 * @extends ContentObjectAPI
	 * @extends TagContainerAPI
	 * 
	 * @param {number|string}
	 *            id of the template to be loaded
	 * @param {function(ContentObjectAPI))=}
	 *            success Optional success callback that will receive this
	 *            object as its only argument.
	 * @param {function(GCNError):boolean=}
	 *            error Optional custom error handler.
	 * @param {object}
	 *            settings currently there are no additional settings to be used
	 */
	var TemplateAPI = GCN.defineChainback({
		/** @lends TemplateAPI */

		__chainbacktype__: 'TemplateAPI',
		_extends: [ GCN.TagContainerAPI, GCN.ContentObjectAPI ],
		_type: 'template',

		//---------------------------------------------------------------------
		// Surface tag container methods that are applicable for GCN page
		// objects.
		//---------------------------------------------------------------------

		/**
		 * Creates a tag of a given tagtype in this template.
		 *
		 * Exmaple:
		 * <pre>
		 *	createTag('link', 'http://www.gentics.com', onSuccess, onError);
		 * </pre>
		 * or
		 * <pre>
		 *	createTag('link', onSuccess, onError);
		 * </pre>
		 *
		 * @public
		 * @function
		 * @name createTag
		 * @memberOf TemplateAPI
		 * @param {string} construct The name of the construct on which the tag
		 *                           to be created should be derived from.
		 * @param {string=} magicValue Optional property that will override the
		 *                             default values of this tag type.
		 * @param {function(TagAPI)=} success Optional callback that will
		 *                                    receive the newly created tag as
		 *                                    its only argument.
		 * @param {function(GCNError):boolean=} error Optional custom error
		 *                                            handler.
		 * @return {TagAPI} The newly created tag.
		 * @throws INVALID_ARGUMENTS
		 */
		'!createTag': function () {
			return this._createTag.apply(this, arguments);
		},

		/**
		 * Deletes the specified tag from this template.
		 *
		 * @public
		 * @function
		 * @name removeTag
		 * @memberOf TemplateAPI
		 * @param {string} id The id of the tag to be deleted.
		 * @param {function(TemplateAPI)=} success Optional callback that
		 *                                         receive this object as its
		 *                                         only argument.
		 * @param {function(GCNError):boolean=} error Optional custom error
		 *                                            handler.
		 */
		removeTag: function () {
			this._removeTag.apply(this, arguments);
		},

		/**
		 * Deletes a set of tags from this template.
		 *
		 * @public
		 * @function
		 * @name removeTags
		 * @memberOf TemplateAPI
		 * @param {Array.<string>} ids The ids of the set of tags to be
		 *                             deleted.
		 * @param {function(TemplateAPI)=} success Optional callback that
		 *                                         receive this object as its
		 *                                         only argument.
		 * @param {function(GCNError):boolean=} error Optional custom error
		 *                                            handler.
		 */
		removeTags: function () {
			this._removeTags.apply(this, arguments);
		},

		/**
		 * Not yet implemented.
		 * 
		 * @public
		 * @TODO: Not yet implemented.
		 */
		remove: function (success, error) {

		},

		/**
		 * Not yet implemented.
		 * 
		 * @public
		 * @TODO: Not yet implemented.
		 */
		save: function (success, error) {

		},

		/**
		 * Not yet implemented.
		 * 
		 * @public
		 * @TODO: Not yet implemented.
		 */
		folder: function (success, error) {

		}

	});

	/**
	* Creates a new instance of TemplateAPI. See the {@link TemplateAPI} constructor for detailed information.
	* 
	* @function
	* @name template
	* @memberOf GCN
	* @see TemplateAPI
	*/
	GCN.template = GCN.exposeAPI(TemplateAPI);
	GCN.TemplateAPI = TemplateAPI;

}(GCN));
(function (GCN) {

	'use strict';

	/**
	 * @private
	 * @const
	 * @type {number}
	 */
	var TYPE_ID = 10008;

	/**
	 * @private
	 * @const
	 * @type {object.<string, boolean>} Default file settings.
	 */
	var DEFAULT_SETTINGS = {
		// Load file for updating
		update: true
	};

	/**
	 * @class
	 * @name FileAPI
	 * @extends ContentObjectAPI
	 * @extends TagContainerAPI
	 * 
	 * @param {number|string}
	 *            id of the file to be loaded
	 * @param {function(ContentObjectAPI))=}
	 *            success Optional success callback that will receive this
	 *            object as its only argument.
	 * @param {function(GCNError):boolean=}
	 *            error Optional custom error handler.
	 * @param {object}
	 *            settings currently there are no additional settings to be used
	 */
	var FileAPI = GCN.defineChainback({
		/** @lends FileAPI */

		__chainbacktype__: 'FileAPI',
		_extends: [ GCN.ContentObjectAPI, GCN.TagContainerAPI ],
		_type: 'file',

		/**
		 * Writable properties for the folder object. Currently the following
		 * attributes are writeable: cdate, description, folderId, name.
		 * WARNING: changing the folderId might not work as expected.
		 * 
		 * @type {Array.string}
		 */
		WRITEABLE_PROPS: [ 'cdate',
		                    'description',
		                    'folderId', // @TODO Check if moving is implemented
							            // correctly.
		                    'name' ],

		/**
		 * <p>
		 * Retrieve the URL of this file's binary contents. You can use this to
		 * download the file from the server or to display an image.
		 * </p>
		 * <p>
		 * <b>WARNING!</b> Never ever store this URL in a page for users to
		 * load an image or to provide a download link. You should always refer
		 * to published files from the backend. Referencing a file directly
		 * using this link will put heavy load on you Gentics Content.Node CMS
		 * Server.
		 * </p>
		 * 
		 * @function
		 * @name binURL
		 * @memberOf FileAPI
		 * @return {string} Source URL of this file.
		 */
		'!binURL': function () {
			return (
				GCN.settings.BACKEND_PATH + '/rest/file/content/load/'
				+ this.id() + '?sid=' + GCN.sid
				+ GCN._getChannelParameter(this, '&')
			);
		},

		/**
		 * @see ContentObjectAPI.!_loadParams
		 */
		'!_loadParams': function () {
			return jQuery.extend(DEFAULT_SETTINGS, this._settings);
		}
	});

	/**
	* Creates a new instance of FileAPI. See the {@link FileAPI} constructor for detailed information.
	* 
	* @function
	* @name file
	* @memberOf GCN
	* @see FileAPI
	*/
	GCN.file = GCN.exposeAPI(FileAPI);
	GCN.FileAPI = FileAPI;

}(GCN));
(function (GCN) {

	'use strict';

	/**
	 * @TODO (petro): Where is this constant used.  Can it be removed?
	 *
	 * @const
	 * @type {number}
	 */
	var TYPE_ID = 10011;

	/**
	 * @private
	 * @const
	 * @type {object.<string, boolean>} Default image settings.
	 */
	var DEFAULT_SETTINGS = {
		// Load image for updating
		update: true
	};

	/**
	 * <strong>WARNING!</strong> The ImageAPI object is currently not implemented.
	 * 
	 * @class
	 * @name ImageAPI
	 * @extends FileAPI
	 * 
	 * @param {number|string}
	 *            id of the image to be loaded
	 * @param {function(ContentObjectAPI))=}
	 *            success Optional success callback that will receive this
	 *            object as its only argument.
	 * @param {function(GCNError):boolean=}
	 *            error Optional custom error handler.
	 * @param {object}
	 *            settings currently there are no additional settings to be used
	 */
	var ImageAPI = GCN.defineChainback({

		__chainbacktype__: 'ImageAPI',
		_extends: GCN.FileAPI,
		_type: 'image',

		/**
		 * writable properties for the page object
		 */
		WRITEABLE_PROPS: ['cdate',
		                  'description',
		                  'folderId', // @TODO Check if moving is implemented
		                              // correctly.
		                  'name' ],

		/**
		 * @see ContentObjectAPI.!_loadParams
		 */
		'!_loadParams': function () {
			return jQuery.extend(DEFAULT_SETTINGS, this._settings);
		}
	});

	/**
	* Creates a new instance of ImageAPI. See the {@link ImageAPI} constructor for detailed information.
	* 
	* @function
	* @name image
	* @memberOf GCN
	* @see ImageAPI
	*/
	GCN.image = GCN.exposeAPI(ImageAPI);
	GCN.ImageAPI = ImageAPI;

}(GCN));
/*global window: true, GCN: true, jQuery: true */

/**
 * IMPORTANT NOTE CONCERNING JSDOC-TOOLKIT WORKAROUNDS:
 *
 * It is necessary to define a local function and then write extra code to
 * expose it in the TagParts object rather than just doing it directy. Thi is
 * because of a bug in JsDoc-Toolkit prevents the function documentation from
 * being parsed correctly otherwise.
 *
 * function MULTISELECT(part, value) {
 *     return TagParts.SELECT(part, value);
 * }
 * TagParts.MULTISELECT = MULTISELECT;
 */

(function (GCN) {
	'use strict';

	/**
	 * Retrieves a copy of the properties of the select options which
	 * corresponds to the given value.
	 *
	 * @ignore
	 * @private
	 * @param {string} value Search for property of this value
	 * @param {object} part The part inwhich to search for select options.
	 * @return {object|null} A copy of properties or null if none is found for
	 *                       `value'.
	 * @throws VALUE_DOES_NOT_EXIST
	 */
	function getSelectPartOption(value, part) {
		var options = part.options;
		var i;
		for (i = 0; i < options.length; i++) {
			if (options[i].value === value) {
				return jQuery.extend({}, options[i]);
			}
		}
		GCN.error(
			'VALUE_DOES_NOT_EXIST',
			'The value `' + value + '\' does not exist in this part',
			part
		);
		return null;
	}

	/**
	 * Creates a basic getter/setter function for the given field.
	 *
	 * @private
	 * @ignore
	 * @param {string} field;
	 * @return {function(object, *=)} A getter/setter function.
	 */
	function createGetterSetter(field) {
		return function () {
			var args = Array.prototype.slice.call(arguments);
			var obj = args[0];
			if (args.length > 1) {
				obj[field] = args[1];
			}
			return obj[field];
		};
	}

	/**
	 * <p>
	 * Functions to access and modify various tag part types.
	 *
	 * <p>
	 * <b>IMPORTANT</b>: Getter and setters for the various part types should
	 * never be accessed directly.  If absolutely necessary it should be done
	 * via {@link TagParts.get} and {@link TagParts.set}.
	 *
	 * @public
	 * @namespace
	 * @name TagParts
	 * @type {object<string, function(object, (number|string|boolean|object)=)>}
	 */
	var TagParts = {};

	/**
	 * Gets or sets the value of a STRING tag part.
	 *
	 * @public
	 * @function
	 * @memberOf TagParts
	 * @name STRING
	 * @param {object} part The part whose value is to be accessed.
	 * @param {string=} value Optional. The value to set for this part.
	 * @return {string} The value held by this part.
	 */
	TagParts.STRING = createGetterSetter('stringValue');

	/**
	 * Gets or sets the value of a RICHTEXT tag part.
	 *
	 * @public
	 * @function
	 * @memberOf TagParts
	 * @name RICHTEXT
	 * @param {object} part The part whose value is to be accessed.
	 * @param {string=} value Optional. The value to set for this part.
	 * @return {string} The value held by this part.
	 */
	TagParts.RICHTEXT = createGetterSetter('stringValue');

	/**
	 * Gets or sets the value of a BOOLEAN tag part.
	 *
	 * @public
	 * @function
	 * @memberOf TagParts
	 * @name BOOLEAN
	 * @param {object} part The part whose value is to be accessed.
	 * @param {boolean=} value Optional. The value to set for this part.
	 * @return {boolean} The value held by this part.
	 */
	TagParts.BOOLEAN = createGetterSetter('booleanValue');

	/**
	 * Gets or sets the value of an IMAGE tag part.
	 *
	 * @public
	 * @function
	 * @memberOf TagParts
	 * @name IMAGE
	 * @param {object} part The part whose value is to be accessed.
	 * @param {number=} value Optional. The value to set for this part.
	 * @return {number} The value held by this part.
	 */
	TagParts.IMAGE = createGetterSetter('imageId');

	/**
	 * Gets or sets the value of a FILE tag part.
	 *
	 * @public
	 * @function
	 * @memberOf TagParts
	 * @name FILE
	 * @param {object} part The part whose value is to be accessed.
	 * @param {number=} value Optional. The value to set for this part.
	 * @return {number} The value held by this part.
	 */
	// (URL) file is the same as File (upload).
	TagParts.FILE = createGetterSetter('fileId');

	/**
	 * Gets or sets the value of a FOLDER tag part.
	 *
	 * @public
	 * @function
	 * @memberOf TagParts
	 * @name FOLDER
	 * @param {object} part The part whose value is to be accessed.
	 * @param {number=} value Optional. The value to set for this part.
	 * @return {number} The value held by this part.
	 */
	// (URL) folder is the same as Folder (upload).
	TagParts.FOLDER = createGetterSetter('folderId');

	/**
	 * Gets or sets the value of an OVERVIEW tag part.
	 *
	 * @public
	 * @function
	 * @memberOf TagParts
	 * @name OVERVIEW
	 * @param {object} part The part whose value is to be accessed.
	 * @param {object=} value Optional. The value to set for this part.
	 * @return {object} The value held by this part.
	 */
	TagParts.OVERVIEW = createGetterSetter('overview');

	/**
	 * Gets or sets the value of a PAGE tag part.
	 *
	 * @public
	 * @function
	 * @memberOf TagParts
	 * @name PAGE
	 * @param {object} part The part whose value is to be accessed.
	 * @param {(number|string)=} value Optional.  A number denotes and internal
	 *                                 page within Content.Node, whereas a
	 *                                 string denotes an external url.
	 * @return {number|string} The value held by this part.
	 */
	function PAGE(part, value) {
		if (jQuery.type(value) === 'number') {
			part.pageId = value;
			delete part.stringValue;
			return value;
		}

		if (typeof value !== 'undefined' && value !== null) {
			part.stringValue = value.toString();
			delete part.pageId;
			return value;
		}

		return part[
			jQuery.type(part.stringValue) === 'string' ? 'stringValue'
			                                           : 'pageId'
		];
	}
	TagParts.PAGE = PAGE;

	/**
	 * <p>
	 * Gets or sets the value of a SELECT tag part.
	 *
	 * <p>
	 * There are several possible values that can be passed to this function:
	 *
	 * <pre>
	 *      undefined : When value arguments is not provided, then none of this
	 *                  part's data is changed.
	 *
	 *           null : selectedOptions will set to an empty array.
	 *
	 *         object : selectedOptions will be set to contain a single select
	 *                  option that corresponds with that of the
	 *                  `selectedOptions' property in the given object.  This
	 *                  allowance exists for backwards compatibility, and is not
	 *                  recommended.
	 *
	 *         string : selectedOptions will be set to contain a single select
	 *                  option whose `value' property corresponds with that of
	 *                  the argument.
	 *
	 *       string[] : selectedOptions will be set to contain zero or more
	 *                  select option whose `value' property corresponds with
	 *                  that of those in the given array.
	 * </pre>
	 *
	 * @public
	 * @function
	 * @memberOf TagParts
	 * @name SELECT
	 * @param {object} part The part whose value is to be accessed.
	 * @param {(string|string[]|object|null)=} value The values with which to
	 *                                         determined what this part's
	 *                                         `selectedOptions' property should
	 *                                         hold.
	 * @return {object} An object containing a copy of the value of this part.
	 * @throws VALUE_DOES_NOT_EXIST
	 */
	function SELECT(part, value) {
		var options = [];
		var option;
		var i;
		switch (jQuery.type(value)) {
		case 'string':
			option = getSelectPartOption(value, part);
			if (option) {
				options.push(option);
			} else {
				return part;
			}
			break;
		case 'array':
			for (i = 0; i < value.length; i++) {
				option = getSelectPartOption(value[i], part);
				if (option) {
					options.push(option);
				} else {
					return part;
				}
			}
			break;
		case 'object':
			for (i = 0; i < value.selectedOptions.length; i++) {
				option = getSelectPartOption(value.selectedOptions[i].value,
				                             part);
				if (option) {
					options.push(option);
				} else {
					return part;
				}
			}
			break;
		case 'undefined':
			options = part.selectedOptions;
			break;
		}

		part.selectedOptions = options;

		return {
			datasourceId: part.datasourceId,
			options: part.options,
			selectedOptions: part.selectedOptions
		};
	}
	TagParts.SELECT = SELECT;

	/**
	 * Gets or sets the value of a MULTISELECT tag part.
	 * Operates in the same was as {@link TagParts.SELECT}.
	 *
	 * @public
	 * @function
	 * @memberOf TagParts
	 * @name MULTISELECT
	 * @param {object} part The part whose value is to be accessed.
	 * @param {(string|string[]|object|null)=} value The values with which to
	 *                                         determined what this part's
	 *                                         `selectedOptions' property should
	 *                                         hold.
	 * @return {object} An object containing a copy of the value of this part.
	 */
	function MULTISELECT(part, value) {
		return TagParts.SELECT(part, value);
	}
	TagParts.MULTISELECT = MULTISELECT;

	/**
	 * Gets or sets the value of a TEMPLATETAG tag part.
	 *
	 * @public
	 * @function
	 * @memberOf TagParts
	 * @name TEMPLATETAG
	 * @param {object} part The part whose value is to be accessed.
	 * @param {object=} value An object with the either the property `templateId'
	 *                        or `templateTagId'.
	 * @return {object} An object containing a copy of the value of this part.
	 *
	 */
	function TEMPLATETAG(part, value) {
		if (value) {
			if (typeof value.templateId !== 'undefined') {
				part.templateId = value.templateId;
			}

			if (typeof value.templateTagId !== 'undefined') {
				part.templateTagId = value.templateTagId;
			}
		}

		return {
			templateId: part.templateId,
			templateTagId: part.templateTagId
		};
	}
	TagParts.TEMPLATETAG = TEMPLATETAG;

	/**
	 * Gets or sets the value of a PAGETAG tag part.
	 *
	 * @public
	 * @function
	 * @memberOf TagParts
	 * @name PAGETAG
	 * @param {object} part The part whose value is to be accessed.
	 * @param {object=} value An object with the either the property `pageId'
	 *                        or `pageTagId'.
	 * @return {object} An object containing a copy of the value of this
	 *                  part.
	 */
	function PAGETAG(part, value) {
		if (value) {
			if (typeof value.pageId !== 'undefined') {
				part.pageId = value.pageId;
			}

			if (typeof value.pageTagId !== 'undefined') {
				part.pageTagId = value.pageTagId;
			}
		}

		return {
			templateId: part.pageId,
			templateTagId: part.pageTagId
		};
	}
	TagParts.PAGETAG = PAGETAG;

	/**
	 * Gets or sets the value of the given tag part.
	 *
	 * @private
	 * @ignore
	 * @param {object} part The part whose value is to be accessed.
	 * @param {*=} value The value to set the part to.
	 * @throws CANNOT_READ_TAG_PART
	 */
	function accessor() {
		var args = Array.prototype.slice.call(arguments);
		var part = args[0];
		if (!TagParts[part.type]) {
			GCN.error(
				'CANNOT_READ_TAG_PART',
				'Cannot read or write to tag part',
				part
			);
			return null;
		}
		return (
			args.length > 1
				? TagParts[part.type](part, args[1])
				: TagParts[part.type](part)
		);
	}

	/**
	 * Gets the value of the given tag part.
	 *
	 * @param {object} part The part whose value is to be retrieved.
	 * @param {*=} value The value to set the part to.
	 * @return {*} The value held in the given part.
	 * @throws CANNOT_READ_TAG_PART
	 */
	TagParts.get = function (part) {
		return accessor(part);
	};

	/**
	 * Sets the value of the given tag part.
	 *
	 * @param {object} part The part whose value is to be set.
	 * @param {*=} value The value to set the part to.
	 * @return {*} The value set to the given part.
	 * @throws CANNOT_READ_TAG_PART
	 */
	TagParts.set = function (part, value) {
		return accessor(part, value);
	};

	GCN.TagParts = TagParts;

}(GCN));
/*global window: true, GCN: true, jQuery: true*/
(function (GCN) {

	'use strict';

	/**
	 * Searches for the an Aloha editable object of the given id.
	 *
	 * @TODO: Once Aloha.getEditableById() is patched to not cause an
	 *        JavaScript exception if the element for the given ID is not found
	 *        then we can deprecate this function and use Aloha's instead.
	 *
	 * @static
	 * @param {string} id Id of Aloha.Editable object to find.
	 * @return {Aloha.Editable=} The editable object, if wound; otherwise null.
	 */
	function getAlohaEditableById(id) {
		var Aloha = (typeof window !== 'undefined') && window.Aloha;
		if (!Aloha) {
			return null;
		}

		// If the element is a textarea then route to the editable div.
		var element = jQuery('#' + id);
		if (element.length &&
				element[0].nodeName.toLowerCase() === 'textarea') {
			id += '-aloha';
		}

		var editables = Aloha.editables;
		var j = editables.length;
		while (j) {
			if (editables[--j].getId() === id) {
				return editables[j];
			}
		}

		return null;
	}

	/**
	 * Helper function to normalize the arguments that can be passed to the
	 * `edit()' and `render()' methods.
	 *
	 * @private
	 * @static
	 * @param {arguments} args A list of arguments.
	 * @return {object} Object containing an the properties `element',
	 *                  `success' and `error', and `data'.
	 */
	function getRenderOptions(args) {
		var argv = Array.prototype.slice.call(args);
		var argc = args.length;
		var arg;
		var i;

		var element;
		var success;
		var error;
		var prerenderedData = false;

		for (i = 0; i < argc; ++i) {
			arg = argv[i];

			switch (jQuery.type(arg)) {
			case 'string':
				element = jQuery(arg);
				break;
			case 'object':
				if (element) {
					prerenderedData = arg;
				} else {
					element = arg;
				}
				break;
			case 'function':
				if (success) {
					error = arg;
				} else {
					success = arg;
				}
				break;
			// Descarding all other types of arguments...
			}
		}

		return {
			element : element,
			success : success,
			error   : error,
			data    : prerenderedData
		};
	}

	/**
	 * Exposes an API to operate on a Content.Node tag.
	 *
	 * @class
	 * @name TagAPI
	 */
	var TagAPI = GCN.defineChainback({

		__chainbacktype__: 'TagAPI',

		/**
		 * A reference to the object in which this tag is contained.  This value
		 * is set during initialization.
		 *
		 * @type {GCN.ContentObject}
		 */
		_parent: null,

		/**
		 * Name of this tag.
		 *
		 * @type {string}
		 */
		_name: null,

		/**
		 * Gets this tag's information from the object that contains it.
		 *
		 * @param {function(TagAPI)} success Callback to be invoked when this
		 *                                   operation completes normally.
		 * @param {function(GCNError):boolean} error Custom error handler.
		 */
		'!_read': function (success, error) {
			if (this._fetched) {
				if (success) {
					this._invoke(success, [this]);
				}
				return;
			}

			var that = this;
			var parent = this.parent();

			// Because when loading folders via folder(1).folders() will
			// fetch them without any tag data.  We therefore have to refetch
			// them wit their tag data.
			if (parent._fetched && !parent._data.tags) {
				parent._data.tags = {};
				parent.fetch(function (response) {
					if (GCN.getResponseCode(response) !== 'OK') {
						GCN.handleResponseError(response);
						return;
					}
					var newTags = {};
					jQuery.each(
						response[parent._type].tags,
						function (name, data) {
							if (!GCN.TagContainerAPI.hasTagData(parent, name)) {
								newTags[name] = data;
							}
						}
					);
					GCN.TagContainerAPI.extendTags(parent, newTags);
					parent._read(success, error);
				});
				return;
			}

			// Take the data for this tag from it's container.
			parent._read(function () {
				that._data = parent._getTagData(that._name);

				if (!that._data) {
					var err = GCN.createError('TAG_NOT_FOUND',
						'Could not find tag "' + that._name + '" in ' +
						parent._type + " " + parent._data.id, that);
					GCN.handleError(err, error);
					return;
				}

				that._fetched = true;

				if (success) {
					that._invoke(success, [that]);
				}
			}, error);
		},

		/**
		 * Retrieve the object in which this tag is contained.  It does so by
		 * getting this chainback's "chainlink ancestor" object.
		 *
		 * @function
		 * @name parent
		 * @memberOf TagAPI
		 * @return {GCN.AbstractTagContainer}
		 */
		'!parent': function () {
			return this._ancestor();
		},

		/**
		 * Initialize a tag object. Unlike other chainback objects, tags will
		 * always have a parent. If its parent have been loaded, we will
		 * immediately copy the this tag's data from the parent's `_data' object
		 * to the tag's `_data' object.
		 *
		 * @param {string|object}
		 *            settings
		 * @param {function(TagAPI)}
		 *            success Callback to be invoked when this operation
		 *            completes normally.
		 * @param {function(GCNError):boolean}
		 *            error Custom error handler.
		 */
		_init: function (settings, success, error) {
			if (jQuery.type(settings) === 'object') {
				this._name    = settings.name;
				this._data    = settings;
				this._data.id = settings.id;
				this._fetched = true;
			} else {
				// We don't want to reinitalize the data object when it
				// has not been fetched yet.
				if (!this._fetched) {
					this._data = {};
					this._data.id = this._name = settings;
				}
			}

			if (success) {
				var that = this;

				this._read(function (container) {
					that._read(success, error);
				}, error);

			// Even if not success callback is given, read this tag's data from
			// is container, if that container has the data available.
			// If we are initializing a placeholder tag object (in the process
			// of creating brand new tag, for example), then its parent
			// container will not have any data for this tag yet.  We know that
			// we are working with a placeholder tag if no `_data.id' or `_name'
			// property is set.
			} else if (!this._fetched && this._name &&
			           this.parent()._fetched) {
				this._data = this.parent()._getTagData(this._name);
				this._fetched = !!this._data;

			// We are propably initializing a placholder object, we will assign
			// it its own `_data' and `_fetched' properties so that it is not
			// accessing the prototype values.
			} else if (!this._fetched) {
				this._data = {};
				this._data.id = this._name = settings;
				this._fetched = false;
			}
		},

		/**
		 * Gets or sets a property of this tags. Note that tags do not have a
		 * `_shadow' object, and we update the `_data' object directly.
		 *
		 * @function
		 * @name prop
		 * @memberOf TagAPI
		 * @param {string}
		 *            name Name of tag part.
		 * @param {*=}
		 *            set Optional value. If provided, the tag part will be
		 *            replaced with this value.
		 * @return {*} The value of the accessed tag part.
		 * @throws UNFETCHED_OBJECT_ACCESS
		 */
		'!prop': function (name, value) {
			var parent = this.parent();

			if (!this._fetched) {
				GCN.error('UNFETCHED_OBJECT_ACCESS',
					'Calling method `prop()\' on an unfetched object: ' +
					parent._type + " " + parent._data.id, this);

				return;
			}

			if (jQuery.type(value) !== 'undefined') {
				this._data[name] = value;
				parent._update('tags.' + GCN.escapePropertyName(name),
					this._data);
			}

			return this._data[name];
		},

		/**
		 * <p>
		 * Gets or sets a part of a tag.
		 *
		 * <p>
		 * There exists different types of tag parts, and the possible value of
		 * each kind of tag part may differ.
		 *
		 * <p>
		 * Below is a list of possible kinds of tag parts, and references to
		 * what the possible range their values can take:
		 *
		 * <pre>
		 *      STRING : {@link TagParts.STRING}
		 *    RICHTEXT : {@link TagParts.RICHTEXT}
		 *     BOOLEAN : {@link TagParts.BOOLEAN}
		 *       IMAGE : {@link TagParts.IMAGE}
		 *        FILE : {@link TagParts.FILE}
		 *      FOLDER : {@link TagParts.FOLDER}
		 *        PAGE : {@link TagParts.PAGE}
		 *    OVERVIEW : {@link TagParts.OVERVIEW}
		 *     PAGETAG : {@link TagParts.PAGETAG}
		 * TEMPLATETAG : {@link TagParts.TEMPLATETAG}
		 *      SELECT : {@link TagParts.SELECT}
		 * MULTISELECT : {@link TagParts.MULTISELECT}
		 * </pre>
		 *
		 * @function
		 * @name part
		 * @memberOf TagAPI
		 *
		 * @param {string}
		 *            name Name of tag opart.
		 * @param {*=}
		 *            set Optional value.  If provided, the tag part will be
		 *            update with this value.  How this happends differs between
		 *            different type of tag parts.
		 * @return {*} The value of the accessed tag part.
		 * @throws UNFETCHED_OBJECT_ACCESS
		 * @throws PART_NOT_FOUND
		 */
		'!part': function (name, value) {
			var parent;

			if (!this._fetched) {
				parent = this.parent();

				GCN.error('UNFETCHED_OBJECT_ACCESS',
					'Calling method `prop()\' on an unfetched object: ' +
					parent._type + " " + parent._data.id, this);

				return null;
			}

			var part = this._data.properties[name];

			if (!part) {
				parent = this.parent();

				GCN.error('PART_NOT_FOUND', 'Tag "' + this._name +
					'" of ' + parent._type + ' ' + parent._data.id +
					' does not have a part "' + name + '"', this);

				return null;
			}

			if (jQuery.type(value) === 'undefined') {
				return GCN.TagParts.get(part);
			}

			var partValue = GCN.TagParts.set(part, value);

			// Each time we perform a write operation on a tag, we will update
			// the tag in the tag container's `_shadow' object as well.
			this.parent()._update('tags.' + GCN.escapePropertyName(this._name),
				this._data);

			return partValue;
		},

		/**
		 * Remove this tag from its containing object (it's parent).
		 *
		 * @function
		 * @memberOf TagAPI
		 * @name remove
		 * @param {function} callback A function that receive this tag's parent
		 *                            object as its only arguments.
		 */
		remove: function (success, error) {
			var parent = this.parent();

			if (!parent.hasOwnProperty('_deletedTags')) {
				parent._deletedTags = [];
			}

			GCN.pub('tag.before-deleted', {tag: this});

			parent._deletedTags.push(this._name);

			if (parent._data.tags &&
					parent._data.tags[this._name]) {
				delete parent._data.tags[this._name];
			}

			if (parent._shadow.tags &&
					parent._shadow.tags[this._name]) {
				delete parent._shadow.tags[this._name];
			}

			parent._removeAssociatedTagData(this._name);

			if (success) {
				parent._persist(null, success, error);
			}
		},

		/**
		 * Given a DOM element, will generate a template which represents this
		 * tag as it would be if rendered in the element.
		 *
		 * @param {jQuery.<HTMLElement>} $element DOM element with which to
		 *                                        generate the template.
		 * @return {string} Template string.
		 */
		'!_makeTemplate': function ($element) {
			if (0 === $element.length) {
				return '<node ' + this._name + '>';
			}
			var placeholder =
					'-{(' + this.parent().id() + ':' + this._name + ')}-';
			var template = jQuery.trim(
					$element.clone().html(placeholder)[0].outerHTML
				);
			return template.replace(placeholder, '<node ' + this._name + '>');
		},

		/**
		 * Will render this tag in the given render `mode'.  If an element is
		 * provided, the content will be placed in that element.  If the `mode'
		 * is "edit", any rendered editables will be initialized for Aloha
		 * Editor.  Any editable that are rendered into an element will also be
		 * added to the tag's parent object's `_editables' array so that they
		 * can have their changed contents copied back into their corresponding
		 * tags during saving.
		 *
		 * @param {string} mode The rendering mode.  Valid values are "view",
		 *                      and "edit".
		 * @param {jQuery.<HTMLElement>} element DOM element into which the
		 *                                       the rendered content should be
		 *                                       placed.
		 * @param {function(string, TagAPI, object)} Optional success handler.
		 * @param {function(GCNError):boolean} Optional custom error handler.
		 */
		'!_render': function (mode, $element, success, error) {
			var tag = this;

			tag._read(function () {
				// Because no further operations are allowed on this tag until
				// we the rendering process finished is completed on its parent
				// content object.
				tag._procure();

				var template = ($element && $element.length)
				             ? tag._makeTemplate($element)
				             : '<node ' + tag._name + '>';

				var obj = tag.parent();

				obj._renderTemplate(template, mode, function (data) {

					// Because the parent content object needs to track any
					// blocks or editables that have been rendered in this tag.
					obj._processRenderedTags(data);

					GCN._handleContentRendered(data.content, tag,
						function (html) {
							if ($element && $element.length) {
								GCN.renderOnto($element, html);
								// Because 'content-inserted' is deprecated by
								// 'tag.inserted'.
								GCN.pub('content-inserted', [$element, html]);
								GCN.pub('tag.inserted', [$element, html]);
							}

							var frontendEditing = function (callback) {
								if ('edit' === mode) {
									// Because 'rendered-for-editing' is deprecated by
									// 'tag.rendered-for-editing'.
									GCN.pub('rendered-for-editing', {
										tag: tag,
										data: data,
										callback: callback
									});
									GCN.pub('tag.rendered-for-editing', {
										tag: tag,
										data: data,
										callback: callback
									});
								} else if (callback) {
									callback();
								}
							};

							// Because the caller of edit() my wish to do things
							// in addition to, or instead of, our frontend
							// initialization.
							if (success) {
								tag._invoke(
									success,
									[html, tag, data, frontendEditing]
								);
							} else {
								frontendEditing();
							}

							// Because now, both the tag, and its content object
							// are stable can on the tag object that were queued
							// during the rendering process can now be
							// initiatated.
							tag._vacate();
						});
				}, function () {
					tag._vacate();
				});
			}, error);
		},

		/**
		 * <p>
		 * Render the tag based on its settings on the server. Can be called
		 * with the following arguments:<(p>
		 *
		 * <pre>
		 * // Render tag contents into div whose id is &quot;content-div&quot;
		 * render('#content-div') or render(jQuery('#content-div'))
		 * </pre>
		 *
		 * <pre>
		 * // Pass the html rendering of the tag in the given callback
		 * render(function(html, tag) {
		 *   // implementation!
		 * })
		 * </pre>
		 *
		 * Whenever a 2nd argument is provided, it will be taken as as custom
		 * error handler. Invoking render() without any arguments will yield no
		 * results.
		 *
		 * @function
		 * @name render
		 * @memberOf TagAPI
		 * @param {string|jQuery.HTMLElement}
		 *            selector jQuery selector or jQuery target element to be
		 *            used as render destination
		 * @param {function(string,
		 *            GCN.TagAPI)} success success function that will receive
		 *            the rendered html as well as the TagAPI object
		 */
		render: function () {
			var tag = this;
			var args = arguments;
			jQuery(function () {
				args = getRenderOptions(args);
				if (args.element || args.success) {
					tag._render(
						'view',
						args.element,
						args.success,
						args.error
					);
				}
			});
		},

		/**
		 * <p>
		 * Renders this tag for editing.
		 * </p>
		 *
		 * <p>
		 * Differs from the render() method in that it calls this tag to be
		 * rendered in "edit" mode via the REST API so that it is rendered with
		 * any additional content that is appropriate for when this tag is used
		 * in edit mode.
		 * </p>
		 *
		 * <p>
		 * The GCN JS API library will also start keeping track of various
		 * aspects of this tag and its rendered content.
		 * </p>
		 *
		 * <p>
		 * When a jQuery selector is passed to this method, the contents of the
		 * rendered tag will overwrite the element identified by that selector.
		 * All rendered blocks and editables will be automatically placed into
		 * the DOM and initialize for editing.
		 * </p>
		 *
		 * <p>
		 * The behavior is different when this method is called with a function
		 * as its first argument.  In this case the rendered contents of the tag
		 * will not be autmatically placed into the DOM, but will be passed onto
		 * the callback function as argmuments.  It is then up to the caller to
		 * place the content into the DOM and initialize all rendered blocks and
		 * editables appropriately.
		 * </p>
		 *
		 * @function
		 * @name edit
		 * @memberOf TagAPI
		 * @param {(string|jQuery.HTMLElement)=} element
		 *            The element into which this tag is to be rendered.
		 * @param {function(string,TagAPI)=} success
		 *            A function that will be called once the tag is rendered.
		 * @param {function(GCNError):boolean=} error
		 *            A custom error handler.
		 */
		edit: function () {
			var tag = this;
			var args = getRenderOptions(arguments);
			if (args.data) {

				// Because the parent content object needs to track any
				// blocks or editables that have been rendered in this tag.
				tag.parent()._processRenderedTags(args.data);

				// Because 'rendered-for-editing' is deprecated in favor of
				// 'tag.rendered-for-editing'
				GCN.pub('rendered-for-editing', {
					tag: tag,
					data: args.data,
					callback: function () {
						if (args.success) {
							tag._invoke(
								args.success,
								[args.content, tag, args.data]
							);
						}
					}
				});
				GCN.pub('tag.rendered-for-editing', {
					tag: tag,
					data: args.data,
					callback: function () {
						if (args.success) {
							tag._invoke(
								args.success,
								[args.content, tag, args.data]
							);
						}
					}
				});
			} else {
				jQuery(function () {
					if (args.element || args.success) {
						tag._render(
							'edit',
							args.element,
							args.success,
							args.error
						);
					}
				});
			}
		},

		/**
		 * Persists the changes to this tag on its container object.
		 *
		 * @todo: deprecated this method.
		 * @function
		 * @name save
		 * @memberOf TagAPI
		 * @param {function(TagAPI)} success Callback to be invoked when this
		 *                                   operation completes normally.
		 * @param {function(GCNError):boolean} error Custom error handler.
		 */
		save: function (success, error) {
			var that = this;
			this.parent().save(function () {
				if (success) {
					that._invoke(success, [that]);
				}
			}, error);
		}

	});

	// Unlike content objects, tags do not have unique ids and so we uniquely I
	// dentify tags by their name, and their parent's id.
	TagAPI._needsChainedHash = true;

	GCN.tag = GCN.exposeAPI(TagAPI);
	GCN.TagAPI = TagAPI;

}(GCN));
/*global GCN: true */
(function (GCN) {
	'use strict';

	/**
	 * @class
	 * @name MessageAPI
	 * @extends ContentObjectAPI
	 */
	var MessageAPI = GCN.defineChainback({
		/** @lends message */

		__chainbacktype__: 'MessageAPI',
		_extends: GCN.ContentObjectAPI,
		_type: 'msg',

		/**
		 * Lists all message of the currently authenticated user.
		 * 
		 * @public
		 * @param {boolean}
		 *            Specifies wether to list unread messages only (true),
		 *            or to list all messages (false).
		 * @param {function(MessageAPI)=}
		 *            success Optional callback that will receive this object as
		 *            its only argument.
		 * @param {function(GCNError):boolean}
		 *            error Optional custom error handler.
		 */
		'!list': function (unreadOnly, success, error) {
			// Build the URL we will send to the RestAPI
			var url = GCN.settings.BACKEND_PATH + '/rest/' + this._type +
				'/list/?unread=' + (unreadOnly ? 'true' : 'false');

			var that = this;

			// Check that we are authenticated and send away
			// the RestAPI request
			this._authAjax({
				url     : url,
				type    : 'GET',
				error: function (xhr, status, msg) {
					GCN.handleHttpError(xhr, msg, error);
				},
				success: function (response) {
					if (GCN.getResponseCode(response) === 'OK') {
						that._invoke(success, [ response.messages ]);
					} else {
						GCN.handleResponseError(response, error);
					}
				}
			});
		},

		/**
		 * Marks one or multiple messages as read.
		 * 
		 * @public
		 * @param {array|number}
		 *            This either takes an array, which includes one
		 *            or multiple message ID's, or an integer with a
		 *            single ID.
		 * @param {function(MessageAPI)=}
		 *            success Optional callback that will receive the
		 *            response object.
		 * @param {function(GCNError):boolean}
		 *            error Optional custom error handler.
		 */
		'!read': function (messageIds, success, error) {
			if (messageIds === null ||
					(!(messageIds instanceof Array) && typeof messageIds !== 'number')) {
				GCN.handleError(
					GCN.error('Wrong parameter given',
							  '[Message.read] The first parameter should be an array or a number', this),
					error
				);
			}

			var ajaxMessageIds = [];

			// Whatever we just got: make an array out of it!
			if (messageIds instanceof Array) {
				ajaxMessageIds = messageIds;
			} else {
				ajaxMessageIds = [ messageIds ];
			}

			// Build the URL we will send to the RestAPI
			var url = GCN.settings.BACKEND_PATH + '/rest/' + this._type + '/read/';

			var that = this;

			// Check that we are authenticated and send away
			// the RestAPI request
			this._authAjax({
				url    : url,
				type   : 'POST',
				json   : { 'messages': ajaxMessageIds },
				error  : function (xhr, status, msg) {
					GCN.handleHttpError(xhr, msg, error);
				},
				success: function (response) {
					if (GCN.getResponseCode(response) === 'OK') {
						that._invoke(success, [ response ]);
					} else {
						GCN.handleResponseError(response, error);
					}
				}
			});
		},

		/**
		 * Sends a message to one or multiple users or groups.
		 * 
		 * @public
		 * @param {object}
		 *            An object containing a 'users' or/and a 'groups' value:
		 *            { users: [ userId1, ... ], groups: [ groupId2, ... ] }
		 *            Note: instead of arrays you can also just pass a single
		 *            integer for each of both.
		 * @param {function(MessageAPI)=}
		 *            success Optional callback that will receive the response
		 *            object.
		 * @param {function(GCNError):boolean}
		 *            error Optional custom error handler.
		 */
		'!send': function (receivers, message, success, error) {
			if (receivers === null || typeof receivers !== 'object') {
				GCN.handleError(
					GCN.error('Wrong parameter given',
							  '[Message.send] The first parameter should be an object', this),
					error
				);
			}

			// Define variables for the json object
			var
				toUserId  = [],
				toGroupId = [];

			// Whatever we just got: make an array out of it!
			if (typeof receivers.users !== 'undefined') {
				if (receivers.users instanceof Array) {
					toUserId = receivers.users;
				} else {
					toUserId = [ receivers.users ];
				}
			}

			// The same goes for the group-ID's
			if (typeof receivers.group !== 'undefined') {
				if (receivers.group instanceof Array) {
					toGroupId = receivers.groups;
				} else {
					toGroupId = [ receivers.groups ];
				}
			}

			var sendJsonObject = {
				'message'  : message,
				'toUserId' : toUserId,
				'toGroupId': toGroupId
			};

			// Build the URL we will send to the RestAPI
			var url = GCN.settings.BACKEND_PATH + '/rest/' + this._type + '/send/';

			var that = this;

			// Check that we are authenticated and do the rest call
			// to send our message away to the receiver(s).
			this._authAjax({
				url    : url,
				type   : 'POST',
				json   : sendJsonObject,
				error  : function (xhr, status, msg) {
					GCN.handleHttpError(xhr, msg, error);
				},
				success: function (response) {
					if (GCN.getResponseCode(response) === 'OK') {
						that._invoke(success, [ response ]);
					} else {
						GCN.handleResponseError(response, error);
					}
				}
			});
		}
	});

	/**
	* MessageAPI namespace. See the {@link MessageAPI} constructor for detailed information.
	* 
	* @function
	* @name Message
	* @memberOf GCN
	* @see MessageAPI
	*/
	GCN.Message = new MessageAPI();
}(GCN));
(function (GCN) {

	'use strict';

	// One needs to be cautious when using channel-inherited ids to load content
	// objects.  The object data that is loaded varies depending on whether or
	// not you are in a channel, and whether or not a channel local copy of the
	// inherited object exists in a given channel.
	//
	// Consider working in a channel (with a node id 2 for example).  Further
	// consider that this channel inherits a page with the id 123, and that at
	// some point in time a channel-local copy of this page is made with the id
	// 456.  Now consider the following statements:
	//
	// GCN.channel(2);
	// var p1 = GCN.page(123, function () {});
	// var p2 = GCN.page(456, function () {});
	// GCN.channel(false);
	// var p3 = GCN.page(123, function () {});
	// var p4 = GCN.page(456, function () {});
	//
	// The fact that page 456 is a channel-local copy of page 123 in the
	// channel 2, means that p1, and p2 will be two difference objects on
	// the client which reference the exact same object on the backend.
	//
	// If client changes were made to p1 and p2, and both objects are saved(),
	// one set of changes will be overridden, with the last changes to reach
	// the server clobbering those of the first.
	//
	// In this senario out library cache would contain the following entries:
	//
	// "PageAPI:0/123" = @clientobject1 => @serverobject1
	// "PageAPI:0/456" = @clientobject2 => @serverobject2
	// "PageAPI:2/123" = @clientobject3 => @serverobject2
	// "PageAPI:2/456" = @clientobject4 => @serverobject2
	//
	// What we should do in the future is have object p1, and p2 be references
	// to the same instance on the client side.  This would make it symmetrical
	// with the REST-API.  The challenge in the above scenario is that 2
	// requests will be made to the server for 2 different id, and not until
	// the requests complete will be know whether a channel-local copy was
	// returned.
	//
	// What we should do is that in _processResponse() we should
	// check if there exists any object matching any of the values of
	// getCacheKeyVariations(), and if so, we should through away the incoming
	// data and use the data that is previously loaded.  We would need to make
	// sure that _clearCache() does in fact clear references for a given
	// instance.
	//
	// Example:
	// !_processResponse': function (data) {
	//    var keys = GCN.cache.getCacheKeyVariations(this, data[this._type]);
	//    GCN.cache.addCacheReferences(keys, this);
	//    ...

	// === multichannelling ===================================================

	/**
	 * Constructs the nodeId query parameter for REST-API calls.
	 *
	 * @param {ContentObjectAPI} obj A content object instance.
	 * @param {string=} delimiter Optional delimiter character.
	 * @return {string} Query parameter string.
	 */
	function getChannelParameter(obj, delimiter) {
		if (false === obj._channel) {
			return '';
		}
		return (delimiter || '?') + 'nodeId=' + obj._channel;
	}

	/**
	 * Adds the given instance to its constructor's cache.
	 *
	 * @TODO: Should be a factory method GCN.Cache.addToConstructorCache()
	 * @param {ChainbackAPI} instance
	 * @param {function} ctor The constructor of `instance`.
	 */
	function addToConstructorCache(instance, ctor) {
		ctor.__gcncache__[instance.__gcnhash__] = instance;
	}

	/**
	 * Removes the given instance from its ancestor's temporary cache.
	 *
	 * @TODO: Should be a factory method GCN.Cache.removeFromAncestorCache()
	 * @param {ChainbackAPI} instance
	 * @param {ChainbackAPI} ancestor Ancestor object of `instance`.
	 */
	function removeFromAncestorCache(instance, ancestor) {
		var hash;
		var cache = ancestor.__gcntempcache__;
		for (hash in cache) {
			if (cache.hasOwnProperty(hash) && instance === cache[hash]) {
				delete cache[hash];
			}
		}
	}

	/**
	 * Initializes a placeholder content object by populating it with its
	 * fetched data, assigning it a hash, and tranferring it from its ancestor's
	 * cache into its constructor's cache.
	 *
	 * The localized object must mask the original object from which the
	 * channel-local copy was derived.  All further attempts to access the
	 * original object should now return the channel-local copy.  This is done
	 * by assigning the channel-local instance the identical id and overriding
	 * it in the cache.
	 *
	 * @param {Chainback} localized A placeholder for localized content object.
	 * @param {object} data The data of the localized object that was returned
	 *                      by the "localize/" REST-API call.
	 */
	function initialize(localized, data) {
		var original = localized.multichannelling.derivedFrom;

		// Are tags localizable? If they are not then this is not needed
		localized._name = data.name;

		localized._data = data;
		localized._fetched = true;
		localized._setHash(original.id());

		// Because the cache entry that contained `original` will be overwritten
		// with `localized`, the data in `original` is therefore stale.  Any
		// further attemtps to access an object using the id of `original` will
		// return `localized`.
		original.clear();

		removeFromAncestorCache(localized, original);
		addToConstructorCache(localized, localized._constructor);
	}

	/**
	 * Fetches the channel-local data represented by the given placeholder object.
	 *
	 * @param {Chainback} obj A placeholder for a localized content object.
	 * @param {function(ContentObjectAPI)} success A callback function to
	 *                                             receive the channel-local
	 *                                             data.
	 * @param {function(GCNError)=} error Optional custom error handler.
	 */
	function fetch(obj, success, error) {
		obj._authAjax({
			url: GCN.settings.BACKEND_PATH + '/rest/' + obj._type + '/load/'
			     + obj.id() + getChannelParameter(obj),
			data: obj.multichannelling.derivedFrom._loadParams(),
			error: error,
			success: function (response) {
				if (GCN.getResponseCode(response) !== 'OK') {
					GCN.handleResponseError(response, error);
				} else {
					success(response);
				}
			}
		});
	}

	/**
	 * Create a channel-local version of a content object represented by `obj`.
	 *
	 * @param {ContentObjectAPI} obj Place holder for a localized content
	 *                               object.
	 * @param {function(ContentObjectAPI)} success A function invoked the
	 *                                             object is successfully
	 *                                             localized.
	 * @param {function(gcnerror)=} error Optional custom error handler.
	 */
	function createLocalizedVersion(obj, success, error) {
		var derived = obj.multichannelling.derivedFrom;
		obj._authAjax({
			url: GCN.settings.BACKEND_PATH + '/rest/' + derived._type
			     + '/localize/' + derived.id(),
			type: 'POST',
			json: { channelId: derived._channel },
			error: error,
			success: function (response) {
				if (GCN.getResponseCode(response) !== 'OK') {
					GCN.handleResponseError(response, error);
				} else {
					success();
				}
			}
		});
	}

	/**
	 * Delete the localized version of a content object.
	 *
	 * @param {ContentObjectAPI} obj Content Object
	 * @param {function(ContentObjectAPI)} success a callback function when the
	 *                                             object is successfully
	 *                                             localized.
	 * @param {function(gcnerror)=} error optional custom error handler.
	 */
	function deleteLocalizedVersion(obj, success, error) {
		var derived = obj.multichannelling.derivedFrom;
		derived._authAjax({
			url: GCN.settings.BACKEND_PATH + '/rest/' + derived._type
			     + '/unlocalize/' + derived.id(),
			type: 'POST',
			json: { channelId: derived._channel },
			error: error,
			success: function (response) {
				if (GCN.getResponseCode(response) !== 'OK') {
					GCN.handleResponseError(response, error);
				} else {
					success();
				}
			}
		});
	}

	/**
	 * Fetches the contents of the object from which our placeholder content
	 * object is derived from.
	 *
	 * @TODO: rename to fetchOriginal()
	 *
	 * @param {ContentObjectAPI} obj A placeholder content object waiting for
	 *                               data.
	 * @param {function(Chainback)} success A callback function that will
	 *                                      receive the content object when it
	 *                                      has been successfully read from the
	 *                                      backend.
	 * @param {function(GCNError)=} error Optional custom error handler.
	 */
	function fetchDerivedObject(obj, success, error) {
		obj.multichannelling.derivedFrom._read(success, error);
	}

	/**
	 * Poplates a placeholder that represents an localized content object with
	 * with its data to such that it becomes a fully fetched object.
	 *
	 * Will first cause the inherited object from which this placeholder is
	 * derived to be localized.
	 *
	 * @TODO: If fetching the object that is to be localized results in an
	 *        object with a different id being returned, then the returned
	 *        object is the channel-local version of the object we wanted to
	 *        localize.  The object should not be re-localized therefore, rather
	 *        the channel-local copy should simply be returned.
	 *        See isLocalizedData() at bottom of file.
	 *
	 * @param {Chainback} obj A placholder content object what is waiting for
	 *                        data.
	 * @param {function(Chainback)} success A callback function that will
	 *                                      receive the content object when it
	 *                                      has been successfully read from the
	 *                                      backend.
	 * @param {function(GCNError)=} error Optional custom error handler.
	 */
	function localize(obj, success, error) {
		fetchDerivedObject(obj, function (derived) {
			if (!derived.prop('inherited')) {
				var err = GCN.createError(
					'CANNOT_LOCALIZE',
					'Cannot localize an object which is not inherited',
					obj
				);
				GCN.handleError(err, error);
				return;
			}
			createLocalizedVersion(obj, function () {
				fetch(obj, function (response) {
					initialize(obj, response[obj._type]);
					success(obj);
				}, error);
			}, error);
		}, error);
	}

	/**
	 * Poplates a placeholder that represents an inherited content object with
	 * with its data to such that it becomes a fully fetched object.
	 *
	 * Will first cause the local object from which this placeholder is derived
	 * to be deleted so that the inherited object data is re-exposed.
	 *
	 * @param {Chainback} obj A placholder content object what is waiting for
	 *                        data.
	 * @param {function(Chainback)} success A callback function that will
	 *                                      receive the content object when it
	 *                                      has been successfully read from the
	 *                                      backend.
	 * @param {function(GCNError)=} error Optional custom error handler.
	 */
	function unlocalize(obj, success, error) {
		fetchDerivedObject(obj, function (derived) {
			if (derived.prop('inherited')) {
				var err = GCN.createError(
					'CANNONT_UNLOCALIZE',
					'Cannot unlocalize an object that was not first localized',
					obj
				);
				GCN.handleError(err, error);
				return false;
			}
			deleteLocalizedVersion(obj, success, error);
		}, error);
	}

	GCN.multichannelling =  {
		localize: localize,
		unlocalize: unlocalize
	};

	// === caching ============================================================

	/**
	 * Determines whether the incoming data is that of a multi-channel
	 * localized copy.
	 *
	 * When loading content objects in multi-channel nodes, there exists the
	 * possibility that the object data that is returned does not match the id
	 * of the one being requested.  This is the case when the request is made
	 * with a channel specified, and the requested id is of an inherited page
	 * which has previously been localized.  In such situations, the response
	 * will contain the data for the local copy and not the original inherited
	 * data.
	 *
	 * @param {ContentObjectAPI} obj The content object whose data was
	 *                               requested.
	 * @param {object} data The content object data from the server response.
	 * @return {boolean} True if the data object contains data for the local
	 *                   copy of this content object.
	 */
	function isLocalizedData(obj, data) {
		return obj._channel && (data.id !== obj.id());
	}

	/**
	 * Generates a hash from the given parameters.
	 *
	 * @param {?string} prefix
	 * @param {string} type The Chainback object type.
	 * @param {number} channel A node id.
	 * @param {number} id An object id.
	 * @return {string} A hash key.
	 */
	function makeCacheHash(prefix, type, channel, id) {
		return (prefix ? prefix + '::' : '') + type + ':' + channel + '/' + id;
	}

	/**
	 * Generates a list of hash keys which should map to the given obj. 
	 *
	 * @param {Chainback} obj A content object instance.
	 * @param {object} data The object's data received from the REST-API.
	 * @param {Array.<string>} An array of hash keys.
	 */
	function getCacheKeyVariations(obj, data) {
		var ctor = obj._constructor;
		var channel = obj._channel;
		var idFromObj = obj.id();
		var idFromData = data.id;
		var type = ctor.__chainbacktype__;
		var prefix = (ctor._needsChainedHash && obj._chain)
		           ? obj._chain.__gcnhash__
		           : '';
		var keys = [];
		keys.push(makeCacheHash(prefix, type, channel, idFromObj));
		if (isLocalizedData(obj, data)) {
			keys.push(makeCacheHash(prefix, type, 0, idFromData));
			keys.push(makeCacheHash(prefix, type, channel, idFromData));
		}
		return keys;
	}

	/**
	 * Maps an obj into its constructor's cache against a list of hash keys.
	 *
	 * @param {Array.<string>} keys A set of hash keys.
	 * @param {Chainback} obj A chainback instance which the given keys should
	 *                        should be mapped to. 
	 */
	function addCacheReferences(keys, obj) {
		var cache = obj._constructor.__gcncache__;
		var i;
		for (i = 0; i < keys.length; i++) {
			cache[keys[i]] = obj;
		}
	}

	GCN.cache = {
		getKeyVariations: getCacheKeyVariations,
		addReferences: addCacheReferences
	};

}(GCN));
/*global module: true */

/**
 * @overview: Surfaces API feature of the GCN JS API which are NodeJS specific.
 */
(function (GCN) {

	'use strict';

	if (!GCN.global.isNode) {
		GCN.FolderAPI.prototype.createFile = function (file, success, error) {
			GCN.handleError(GCN.createError('UNAVAILABLE_FEATURE',
				'createFile() functionality is only available when using the' +
				'GCN JS API in Node.js environment.'), error);
		};
		return;
	}

	var fs = require('fs');
	var url = require('url');
	var path = require('path');
	var http = require('http');
	var mime = require('mime');

	/**
	 * Performs HTTP requests, including POST and GET.
	 *
	 * @private
	 * @param {string} uri The URI to send the request to.
	 * @param {object} options A object specifying options to use in the HTTP
	 *                         request.
	 * @param {function(string)} callback A function that will receive the HTTP
	 */
	function httpRequest(uri, options, callback) {
		if (typeof options === 'function') {
			callback = options;
			options = {};
		}
		if (!/^https?\:\/\//.test(uri)) {
			uri = 'http://' + uri;
		}
		var urlSegments = url.parse(uri);
		var data = (typeof options.data !== 'undefined') ? options.data : '';
		var settings = {
			host: urlSegments.host,
			port: urlSegments.port || 80,
			path: urlSegments.path,
			method: options.method || 'GET',
			headers: {
				'Content-Length': data.length
			}
		};
		var header;
		for (header in options.headers) {
			if (options.headers.hasOwnProperty(header)) {
				settings.headers[header] = options.headers[header];
			}
		}
		var request = http.request(settings, function (response) {
			var responseText = [];
			response.setEncoding('utf8');
			response.on('data', function (chunk) {
				responseText.push(chunk);
			});
			response.on('end', function () {
				callback(responseText.join(''), response);
			});
		});
		if (options.data) {
			request.write(options.data);
		}
		request.end();
	}

	/**
	 * Uploads a file at the given location and creates correspoding file
	 * content object for it in the GCN backend.
	 *
	 * @public
	 * @function
	 * @name createFile
	 * @memberOf GCN.FolderAPI
	 * @param {string} file The relative path to the file to be uploaded.
	 * @param {function(GCN.File)} success A callback that will receive the
	 *                                     created file object as its only
	 *                                     argument.
	 * @param {function(GCNError):boolean=} error An optional custom error
	 *                                            handler.
	 * @return {undefined}
	 */
	GCN.FolderAPI.prototype.createFile = function (file, success, error) {
		var folder = this;
		this._read(function () {
			fs.readFile(file, function (err, data) {
				if (err) {
					GCN.handleError(GCN.createError('UPLOAD_FAILED',
						'Could not upload file: ' + file, err), error);
					return;
				}
				var url = GCN.settings.BACKEND_PATH
						+ '/rest/file/createSimple?sid=' + GCN.sid
						+ '&folderId=' + folder.id()
						+ '&qqfile=' + path.basename(file);

				httpRequest(url, {
					method: 'POST',
					headers: {
						'Content-Type': mime.lookup(file),
						'Accept': 'application/json'
					},
					data: data
				}, function (responseText, response) {
					folder.handleUploadResponse(JSON.parse(responseText),
						success, error || function () {});
				});
			});
		}, error);
	};

	module.exports = GCN;

}(GCN));
return GCN;
}
})(typeof global !== 'undefined' ? global : window);
